<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' ); 

class HTML_pms{

function listConfiguration($option, &$rows, &$usergroups_list)
{
	global $database;
	
	require(PMS_BASEPATH_ADMINISTRATOR . '/config.pms.php');
	$configfile = PMS_BASEPATH_ADMINISTRATOR . '/config.pms.php';
	$row = $rows[0];
?>
	<form action="index2.php" method="post" name="adminForm">
	<table cellpadding="4" cellspacing="0" border="0" width="100%">
	<tr>
		<th align="left">
			<img src="components/com_pms/images/asterisk.png" style="margin-right:10px; vertical-align:middle;" alt="asterisk.png" />
			<font style="color: #FF9E31;font-size : 18px;font-weight: bold;text-align: left;"><?php echo _PMS_SETTINGS_TITLE; ?></font>
			<span class="componentheading">
			<?php
			$is_writeable = "";
			if(is_writable($configfile))
			{
				$is_writable = '<b><font color="green">'._PMS_SETTINGS_WRITEABLE.'</font></b>';
			}
			else
			{
				$is_writable = '<b><font color="red">'._PMS_SETTINGS_UNWRITEABLE.'</font></b>';
			}
			echo sprintf(_PMS_SETTINGS_CONFIGFILE, $is_writable);
			?>
			</span>
		</th>
	</tr>
	</table>
<?php
	$pmstabs=new mosTabs(1);
	$pmstabs->startPane("PMS_enhanced");
	$pmstabs->startTab(_PMS_SETTINGS_BACKENDTAB, "backend-page");
?>	
	<table border="0" cellspacing="0" cellpadding="0" class="adminlist">
	<tr>
		<td>
			<b><?php echo _PMS_SETTINGS_PARAM; ?></b>
		</td>
		<td>
			<b><?php echo _PMS_SETTINGS_VALUE; ?></b>
		</td>
		<td>
			<b><?php echo _PMS_SETTINGS_DESCRIPTION; ?></b>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_MAX_ALLOWED_PM; ?>
		</td>
		<td>
			<input type="text" name="file_max_allowed_pm" value="<?php echo $max_allowed_pm; ?>" />
		</td>
		<td>
			<?php echo _PMS_SETTINGS_MAX_ALLOWED_PM_DESCR; ?>
		</td>
	</tr>
<?php
	$database->setQuery("DESCRIBE #__pms");
	$result = $database->loadResultArray(1);
	$subject_length = substr($result[6], 8, -1);
?>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_MAX_LENGTH_SUBJECT; ?>
		</td>
		<td>
			<input type="text" name="file_max_length_subject" value="<?php echo $max_length_subject; ?>" />
		</td>
		<td>
			<?php echo sprintf(_PMS_SETTINGS_MAX_LENGTH_SUBJECT_DESCR, $subject_length); ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_MAX_LENGTH_MESSAGE; ?>
		</td>
		<td>
			<input type="text" name="file_max_length_message" value="<?php echo $max_length_message; ?>" />
		</td>
		<td>
			<?php echo _PMS_SETTINGS_MAX_LENGTH_MESSAGE_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td valign="top">
			<?php echo _PMS_SETTINGS_USERGROUPS; ?>
		</td>
		<td>
			<?php echo $usergroups_list; ?>
		</td>
		<td valign="top">
			<?php echo _PMS_SETTINGS_USERGROUPS_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_MAX_ENTRIES_RECIPLIST; ?>
		</td>
		<td>
			<input type="text" name="file_max_entries_reciplist" value="<?php echo $max_entries_reciplist; ?>" />
		</td>
		<td>
			<?php echo _PMS_SETTINGS_MAX_ENTRIES_RECIPLIST_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_RETRACT; ?>
		</td>
		<td>
		<?php
			$retract_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_RETRACT_NO);
			$retract_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_RETRACT_YES);
			$retract_arr[] = mosHTML::makeOption(2, _PMS_SETTINGS_RETRACT_UNREAD);
			echo mosHTML::selectList($retract_arr, 'file_retract', 'size="1"', 'value', 'text', $retract);
		?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_RETRACT_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_ADDRESSBOOK; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_addressbook", "", $addressbook); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_ADDRESSBOOK_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_IGNORELIST; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_ignorelist", "", $ignorelist); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_IGNORELIST_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_CB; ?>
		</td>
		<td>
		<?php
			$cb_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_CB_NONE);
			$cb_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_CB_CBSTABLE);
			$cb_arr[] = mosHTML::makeOption(2, _PMS_SETTINGS_CB_CBE);
			echo mosHTML::selectList($cb_arr, 'file_cb_version', 'size="1"', 'value', 'text', $cb_version);
		?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_CB_DESCR; ?>
		</td>
	</tr>
	</table>
<?php
	$pmstabs->endTab();
	$pmstabs->startTab(_PMS_SETTINGS_FRONTENDTAB, "frontend-page");
?>
	<table border="0" cellspacing="0" cellpadding="0" class="adminlist">
	<tr>
		<td>
			<b><?php echo _PMS_SETTINGS_PARAM; ?></b>
		</td>
		<td>
			<b><?php echo _PMS_SETTINGS_VALUE; ?></b>
		</td>
		<td>
			<b><?php echo _PMS_SETTINGS_DESCRIPTION; ?></b>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_LAYOUT; ?>
		</td>
		<td>
		<?php
			$menu_layout_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_LAYOUT_ICON);
			$menu_layout_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_LAYOUT_TEXT);
			$menu_layout_arr[] = mosHTML::makeOption(2, _PMS_SETTINGS_LAYOUT_ICON_TEXT);
			echo mosHTML::selectList($menu_layout_arr, 'file_menu_layout', 'size="1"', 'value', 'text', $menu_layout);
		?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_LAYOUT_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_USERLIST; ?>
		</td>
		<td>
		<?php
			$userlist_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_USERLIST_USERNAME);
			$userlist_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_USERLIST_NAME);
			$userlist_arr[] = mosHTML::makeOption(2, _PMS_SETTINGS_USERLIST_USERNAME_NAME);
			$userlist_arr[] = mosHTML::makeOption(3, _PMS_SETTINGS_USERLIST_NAME_USERNAME);
			echo mosHTML::selectList($userlist_arr, 'file_userlist', 'size="1"', 'value', 'text', $userlist);
		?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_USERLIST_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_SMILEY; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_smiley", "", $smiley); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_SMILEY_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_BB_CODE; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_bb_code", "", $bb_code); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_BB_CODE_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_WIDTH_RECIPFIELD; ?>
		</td>
		<td>
			<input type="text" name="file_width_recipfield" value="<?php echo $width_recipfield; ?>" />
		</td>
		<td>
			<?php echo _PMS_SETTINGS_WIDTH_RECIPFIELD_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_WIDTH_MESSAGEFIELDS; ?>
		</td>
		<td>
			<input type="text" name="file_width_messagefields" value="<?php echo $width_messagefields; ?>" />
		</td>
		<td>
			<?php echo _PMS_SETTINGS_WIDTH_MESSAGEFIELDS_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_HEIGHT_MESSAGEFIELD; ?>
		</td>
		<td>
			<input type="text" name="file_height_messagefield" value="<?php echo $height_messagefield; ?>" />
		</td>
		<td>
			<?php echo _PMS_SETTINGS_HEIGHT_MESSAGEFIELD_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_HEIGHT_USERLISTS; ?>
		</td>
		<td>
			<input type="text" name="file_height_userlists" value="<?php echo $height_userlists; ?>" />
		</td>
		<td>
			<?php echo _PMS_SETTINGS_HEIGHT_USERLISTS_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_USERSEARCH; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_usersearch", "", $usersearch); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_USERSEARCH_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_USERSEARCH_MIN_CHARACTERS; ?>
		</td>
		<td>
			<input type="text" name="file_usersearch_min_character" value="<?php echo $usersearch_min_character; ?>" />
		</td>
		<td>
			<?php echo _PMS_SETTINGS_USERSEARCH_MIN_CHARACTERS_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_USERSEARCH_MAX_ROWS; ?>
		</td>
		<td>
			<input type="text" name="file_usersearch_max_rows" value="<?php echo $usersearch_max_rows; ?>" />
		</td>
		<td>
			<?php echo _PMS_SETTINGS_USERSEARCH_MAX_ROWS_DESCR; ?>
		</td>
	</tr>
	</table>
<?php
	$pmstabs->endTab();
	$pmstabs->startTab(_PMS_SETTINGS_USERTAB, "usersettings-page");
?>
	<table border="0" cellspacing="0" cellpadding="0" class="adminlist">
	<tr>
		<td>
			<b><?php echo _PMS_SETTINGS_PARAM; ?></b>
		</td>
		<td>
			<b><?php echo _PMS_SETTINGS_VALUE; ?></b>
		</td>
		<td>
			<b><?php echo _PMS_SETTINGS_ALLOW_OVERRIDE; ?></b>
		</td>
		<td>
			<b><?php echo _PMS_SETTINGS_DESCRIPTION; ?></b>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_EMAIL_NEW; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("db_email_new", "", $row->email_new); ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_email_new", "", $allow_change_email_new); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_EMAIL_NEW_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_EMAIL_REPLY; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("db_email_reply", "", $row->email_reply); ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_email_reply", "", $allow_change_email_reply); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_EMAIL_REPLY_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_EMAIL_FORMAT; ?>
		</td>
		<td>
		<?php
			$email_html_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_EMAIL_FORMAT_TEXT);
			$email_html_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_EMAIL_FORMAT_HTML);
			echo mosHTML::selectList($email_html_arr, 'db_email_html', 'size="1"', 'value', 'text', $row->email_html);
		?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_email_html", "", $allow_change_email_html); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_EMAIL_FORMAT_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_OFFLINE; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("db_email_offline", "", $row->email_offline); ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_email_offline", "", $allow_change_email_offline); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_OFFLINE_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_EMAIL_SENDER_ADDRESS; ?>
		</td>
		<td>
		<?php
			$email_sender_address_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_EMAIL_SENDER_ADDRESS_GLOBAL);
			$email_sender_address_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_EMAIL_SENDER_ADDRESS_USER);
			echo mosHTML::selectList($email_sender_address_arr, 'db_email_sender_address', 'size="1"', 'value', 'text', $row->email_sender_address);
		?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_email_sender_address", "", $allow_change_email_sender_address); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_EMAIL_SENDER_ADDRESS_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_REPLY; ?>
		</td>
		<td>
		<?php
			$format_reply_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_REPLY_WITHOUT);
			$format_reply_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_REPLY_WITH);
			$format_reply_arr[] = mosHTML::makeOption(2, _PMS_SETTINGS_REPLY_ITALIC);
			echo mosHTML::selectList($format_reply_arr, 'db_format_reply', 'size="1"', 'value', 'text', $row->format_reply);
		?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_format_reply", "", $allow_change_format_reply); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_REPLY_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_CLEAR_SENT_ITEMS; ?>
		</td>
		<td>
		<?php
			$clear_sent_items_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_CLEAR_SENT_ITEMS_NO);
			$clear_sent_items_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_CLEAR_SENT_ITEMS_TRASH);
			$clear_sent_items_arr[] = mosHTML::makeOption(-1, _PMS_SETTINGS_CLEAR_SENT_ITEMS_DELETE);
			echo mosHTML::selectList($clear_sent_items_arr, 'db_clear_sent_items', 'size="1"', 'value', 'text', $row->clear_sent_items);
		?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_clear_sent_items", "", $allow_change_clear_sent_items); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_CLEAR_SENT_ITEMS_DESCR; ?>
		</td>
	</tr>
<?php

/*
//check if PMS Notify is installed
$database->setQuery("SELECT published FROM #__modules WHERE module='mod_pmsnotify' LIMIT 1");
if(!$database->query())
{
	pms_sql_error($database->getErrorMsg());
	return false;
}
$published = $database->loadResult();
if(file_exists(PMS_BASEPATH_ADMINISTRATOR . '/../../../modules/mod_pmsnotify.xml') AND $published)
{
?>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_POPUP; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("db_popup", "", $row->popup); ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_popup", "", $allow_change_popup); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_POPUP_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_SOUND; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("db_sound", "", $row->sound); ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_sound", "", $allow_change_sound); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_SOUND_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_SOUND_VALUE; ?>
		</td>
		<td>
		<?php
			$handle=opendir(PMS_BASEPATH_ADMINISTRATOR . '/../../../modules/mod_pmsnotify/sounds/');
			$i=0;
			while($file = readdir($handle))
			{
				if($file != "." && $file != "..")
				{
					$name = explode(".", $file);
					$sound_value_arr[] = mosHTML::makeOption($i, $name[0]);
					$i++;
				}
			}
			echo mosHTML::selectList($sound_value_arr, 'db_sound_value', 'size="1"', 'value', 'text', $row->sound_value);
		?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_sound_value", "", $allow_change_sound_value); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_SOUND_VALUE_DESCR; ?>
		</td>
	</tr>
<?php
}
*/
?>	
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_ROWS; ?>
		</td>
		<td>
			<input type="text" name="db_rows_per_page" value="<?php echo $row->rows_per_page; ?>" maxlength="3" />
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_rows_per_page", "", $allow_change_rows_per_page); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_ROWS_DESCR; ?>
		</td>
	</tr>
	<tr>
		<td>
			<?php echo _PMS_SETTINGS_PAGES; ?>
		</td>
		<td>
			<input type="text" name="db_pages_in_list" value="<?php echo $row->pages_in_list; ?>" maxlength="2" />
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList("file_allow_change_pages_in_list", "", $allow_change_pages_in_list); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_PAGES_DESCR; ?>
		</td>
	</tr>
	</table>
<?php
	$pmstabs->endTab();
	$pmstabs->endPane();
?>	
	<input type="hidden" name="error_invalid_values" value="<?php echo _PMS_SETTINGS_INVALID_VALUES; ?>" />
	<input type="hidden" name="option" value="<?php echo $option; ?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="id" value=<?php echo $row->id ?> />
	<input type="hidden" name="act" value="config" />
	</form> 
<?php
}

function showPMs($option, &$rows, &$pageNav, &$filter_values, $is_admin)
{
	global $database;

	require(PMS_BASEPATH_ADMINISTRATOR . '/config.pms.php');
	?>
	<form action="index2.php" method="post" name="adminForm">
	<table cellpadding="4" cellspacing="0" border="0" width="100%">
	<?php
	if($is_admin)
	{

		// description for readstate icons
		$readstate_img_alt[0] = _PMS_PM_UNREAD;
		$readstate_img_alt[1] = _PMS_PM_READ;
		$readstate_img_alt[2] = _PMS_PM_REPLY_UNREAD;
		$readstate_img_alt[3] = _PMS_PM_REPLY_READ;
		$readstate_img_alt[4] = _PMS_PM_FORWARD_UNREAD;
		$readstate_img_alt[5] = _PMS_PM_FORWARD_READ;
		$readstate_img_alt[6] = _PMS_PM_REPLY_FORWARD_UNREAD;
		$readstate_img_alt[7] = _PMS_PM_REPLY_FORWARD_READ;

		if($userlist==0 OR $userlist==2) $order = "ORDER BY username";
		if($userlist==1 OR $userlist==3) $order = "ORDER BY name";
		if($cb_version>0) $query = "SELECT t1.id, t1.username, t1.name FROM #__users AS t1, #__comprofiler AS t2 WHERE t1.block!=1 AND t2.approved=1 AND t2.confirmed=1 AND t1.id=t2.user_id $order";
		else $query = "SELECT id, username, name FROM #__users WHERE block!=1 $order";
		$database->setQuery($query);
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$results = $database->loadObjectList();

		$sender_users = '<select name="sender" size="5"><option value=""';
		$recip_users = '<select name="recip" size="5"><option value=""';
		if($filter_values[0]=="") $sender_users .= ' selected';
		if($filter_values[1]=="") $recip_users .= ' selected';
		$sender_users .= '>'._PMS_BACKEND_DROPDOWN_NONE.'</option>';
		$recip_users .= '>'._PMS_BACKEND_DROPDOWN_NONE.'</option>';
		foreach($results as $result)
		{
			$sender_users .= '<option value="'.$result->id.'"';
			$recip_users .= '<option value="'.$result->id.'"';
			if($result->id==$filter_values[0]) $sender_users .= ' selected';
			if($result->id==$filter_values[1]) $recip_users .= ' selected';
			$sender_users .= '>';
			$recip_users .= '>';
			if($userlist==0)
			{
				$sender_users .= $result->username;
				$recip_users .= $result->username;
			}
			if($userlist==1)
			{
				$sender_users .= $result->name;
				$recip_users .= $result->name;
			}
			if($userlist==2)
			{
				$sender_users .= $result->username.' ('.$result->name.')';
				$recip_users .= $result->username.' ('.$result->name.')';
			}
			if($userlist==3)
			{
				$sender_users .= $result->name.' ('.$result->username.')';
				$recip_users .= $result->name.' ('.$result->username.')';
			}
			$sender_users .= '</option>';
			$recip_users .= '</option>';
		}
		$sender_users .= "</select>";
		$recip_users .= "</select>";
		?>
		<tr>
			<td width="100%">
				<img src="components/com_pms/images/asterisk.png" style="margin-right:10px; vertical-align:middle;" alt="asterisk.png" />
				<font style="color: #FF9E31;font-size : 18px;font-weight: bold;text-align: left;"><?php echo _PMS_SETTINGS_TITLE; ?></font>
			</td>
			<td nowrap="nowrap">
				<?php echo _PMS_BACKEND_RESULTS_PER_PAGE; ?>
			</td>
			<td>
				<?php echo $pageNav->writeLimitBox('?option=com_pms&act=edit_view'); ?>
			</td>
		</tr>
		</table>
		<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
		<tr>
			<th colspan="4">
				<?php echo _PMS_BACKEND_FILTER; ?>
			</th>
		</tr>
		<tr>
			<td valign="top" align="right">
				<b><?php echo _PMS_SENDER; ?>:</b>
			</td>
			<td>
				<?php echo $sender_users; ?>
			</td>
			<td valign="top" align="right">
				<b><?php echo _PMS_RECIP; ?>:</b>
			</td>
			<td width="100%">
				<?php echo $recip_users; ?>
			</td>
		</tr>
		<tr>
			<td align="right">
				<b><?php echo _PMS_BACKEND_DATE_FROM; ?></b>
			</td>
			<td>
				<input type="text" name="date_start" value="<?php echo $filter_values[2]; ?>" maxlength="10" />
			</td>
			<td align="right">
				<b><?php echo _PMS_BACKEND_DATE_TILL; ?></b>
			</td>
			<td>
				<input type="text" name="date_end" value="<?php echo $filter_values[3]; ?>" maxlength="10" />
			</td>
		</tr>
		<tr>
			<td align="right">
				<b><?php echo _PMS_SUBJECT; ?>:</b>
			</td>
			<?php
			$database->setQuery("DESCRIBE #__pms");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$result = $database->loadResultArray(1);
			$subject_length = substr($result[6], 8, -1);
			?>
			<td colspan="3">
				<input type="text" name="subject" value="<?php echo $filter_values[4]; ?>" maxlength="<?php echo $subject_length; ?>" />
			</td>
		</tr>
		<tr>
			<td align="right">
				<b><?php echo _PMS_MESSAGE; ?>:</b>
			</td>
			<td colspan="3">
				<input type="text" name="message" value="<?php echo $filter_values[5]; ?>" />
			</td>
		</tr>
		<tr>
			<td align="right">
				<b><?php echo _PMS_STATUS; ?>:</b>
			</td>
			<td colspan="3">
			<?php
				$status_arr[] = mosHTML::makeOption(-9, _PMS_BACKEND_DROPDOWN_NONE);
				$status_arr[] = mosHTML::makeOption(0, _PMS_PM_UNREAD);
				$status_arr[] = mosHTML::makeOption(1, _PMS_PM_READ);
				$status_arr[] = mosHTML::makeOption(2, _PMS_PM_REPLY_UNREAD);
				$status_arr[] = mosHTML::makeOption(3, _PMS_PM_REPLY_READ);
				$status_arr[] = mosHTML::makeOption(4, _PMS_PM_FORWARD_UNREAD);
				$status_arr[] = mosHTML::makeOption(5, _PMS_PM_FORWARD_READ);
				$status_arr[] = mosHTML::makeOption(7, _PMS_PM_REPLY_FORWARD_READ);
				echo mosHTML::selectList($status_arr, 'status', 'size="1"', 'value', 'text', $filter_values[6]);
			?>
			</td>
		</tr>
		<tr>
			<td align="right" nowrap>
				<b><?php echo _PMS_BACKEND_STATUS_SENDER; ?>:</b>
			</td>
			<td colspan="3">
			<?php
				$sent_items_arr[] = mosHTML::makeOption(-9, _PMS_BACKEND_DROPDOWN_NONE);
				$sent_items_arr[] = mosHTML::makeOption(1, _PMS_SENT_ITEMS);
				$sent_items_arr[] = mosHTML::makeOption(0, _PMS_TRASH);
				$sent_items_arr[] = mosHTML::makeOption(-1, _PMS_BACKEND_DELETED);
				echo mosHTML::selectList($sent_items_arr, 'sent_items', 'size="1"', 'value', 'text', $filter_values[8]);
			?>
			</td>
		</tr>
		<tr>
			<td align="right" nowrap>
				<b><?php echo _PMS_BACKEND_STATUS_RECIPIENT; ?>:</b>
			</td>
			<td colspan="3">
			<?php
				$inbox_arr[] = mosHTML::makeOption(-9, _PMS_BACKEND_DROPDOWN_NONE);
				$inbox_arr[] = mosHTML::makeOption(1, _PMS_INBOX);
				$inbox_arr[] = mosHTML::makeOption(0, _PMS_TRASH);
				$inbox_arr[] = mosHTML::makeOption(-1, _PMS_BACKEND_DELETED);
				echo mosHTML::selectList($inbox_arr, 'inbox', 'size="1"', 'value', 'text', $filter_values[7]);
			?>
			</td>
		</tr>
		<tr>
			<td colspan="4" align="center">
				<input type="hidden" name="error_wrong_date" value="<?php echo _PMS_BACKEND_VALID_DATE; ?>" />
				<input type="button" value="<?php echo _PMS_BACKEND_FILTER_BUTTON; ?>" onClick="javascript:submitbutton('filter');" />
			</td>
		</tr>
		</table>
		<br />
		<table class="adminlist">
		<tr>
			<th class="title">
				<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count($rows); ?>);" />
			</th>
			<th class="title">
				<?php echo _PMS_SENDER; ?>
			</th>
			<th class="title">
				<?php echo _PMS_RECIP; ?>
			</th>
			<th class="title" nowrap>
				<?php echo _PMS_DATETIME; ?>
			</th>
			<th class="title" width="100%">
				<?php echo _PMS_SUBJECT; ?>
			</th>
			<th class="title">
				<?php echo _PMS_STATUS; ?>
			</th>
			<th class="title">
				<?php echo _PMS_BACKEND_STATUS_SENDER; ?>
			</th>
			<th class="title">
				<?php echo _PMS_BACKEND_STATUS_RECIPIENT; ?>
			</th>
		</tr>
		<?php
		$img_inbox = array("backend_delete", "backend_trash", "backend_inbox");
		$img_sent_items = array("backend_delete", "backend_trash", "backend_sent_items");
		$img_inbox_alt = array(_PMS_BACKEND_DELETED, _PMS_TRASH, _PMS_INBOX);
		$img_sent_items_alt = array(_PMS_BACKEND_DELETED, _PMS_TRASH, _PMS_SENT_ITEMS);

		$k = 0;
		for($i=0, $n=count($rows); $i<$n; $i++)
		{
			$row = &$rows[$i];
		?>
		<tr class="row<?php echo $k; ?>">
			<td width="5%">
				<input type="checkbox" id="cb<?php echo $i; ?>" name="pmid[]" value="<?php echo $row->id; ?>" onclick="isChecked(this.checked);" />
			</td>
			<td align="left" nowrap>
				<?php echo ($userlist==0 OR $userlist==2) ? $row->sender_username : $row->sender_name; ?>
			</td>
			<td align="left" nowrap>
				<?php echo ($userlist==0 OR $userlist==2) ? $row->recip_username : $row->recip_name; ?>
			</td>
			<td align="center" nowrap>
				<?php echo $row->date; echo _PMS_AT; echo $row->time; ?>
			</td>
			<td align="left">
				<a href="index2.php?option=<?php echo $option; ?>&act=view_edit&task=edit&id=cb<?php echo $i; ?>&pmid[]=<?php echo $row->id; ?>"><?php echo $row->subject; ?></a>
			</td>
			<td align="center">
				<img src="../components/com_pms/images/<?php echo $row->readstate; ?>.png" border="0" alt="<?php echo $readstate_img_alt[$row->readstate]; ?>" title="<?php echo $readstate_img_alt[$row->readstate]; ?>" />
			</td>
			<td align="center">
				<img src="components/com_pms/images/<?php echo $img_sent_items[$row->sent_items + 1]; ?>.png" border="0" alt="<?php echo $img_sent_items_alt[$row->sent_items + 1]; ?>" title="<?php echo $img_sent_items_alt[$row->sent_items + 1]; ?>" />
			</td>
			<td align="center">
				<img src="components/com_pms/images/<?php echo $img_inbox[$row->inbox + 1]; ?>.png" border="0" alt="<?php echo $img_inbox_alt[$row->inbox + 1]; ?>" title="<?php echo $img_inbox_alt[$row->inbox + 1]; ?>" />
			</td>
		</tr>
		<?php
		$k = 1 - $k;
		}
		?>
		<th align="center" colspan="8">
			<?php echo $pageNav->writePagesLinks(); ?>
		</th>
		<tr>
			<td align="center" colspan="8">
				<?php echo $pageNav->writePagesCounter(); ?>
			</td>
		</tr>
	<?php
	}
	else
	{
	?>
		<tr>
			<td width="100%">
				<img src="components/com_pms/images/asterisk.png" style="margin-right:10px; vertical-align:middle;" alt="asterisk.png" />
				<font style="color: #FF9E31;font-size : 18px;font-weight: bold;text-align: left;"><?php echo _PMS_SETTINGS_TITLE; ?></font>
			</td>
		</tr>
		<tr>
			<td>
				<?php echo _PMS_BACKEND_NOT_ADMIN; ?>
			</td>
		</tr>
	<?php
	}
	?>
	</table>
	<input type="hidden" name="option" value="<?php echo $option;?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="act" value="view_edit" />
	<input type="hidden" name="boxchecked" value="0" />
	</form>
	<?php
}

function edit_newPM($option, &$row, $is_admin)
{
	global $database;
	
	?>
	<form action="index2.php" method="post" name="adminForm">
	<table cellpadding="4" cellspacing="0" border="0" width="100%">
	<?php
	if($is_admin)
	{
		require(PMS_BASEPATH_ADMINISTRATOR . '/config.pms.php');
		
		if($userlist==0 OR $userlist==2) $order = "ORDER BY username";
		if($userlist==1 OR $userlist==3) $order = "ORDER BY name";
		if($cb_version>0) $query="SELECT t1.id,t1.username,t1.name FROM #__users AS t1, #__comprofiler AS t2 WHERE t1.block!=1 AND t2.approved=1 AND t2.confirmed=1 AND t1.id=t2.user_id $order";
		else $query="SELECT id,username,name FROM #__users WHERE block!=1 $order";
		$database->setQuery($query);
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$results = $database->loadObjectList();

		if(isset($row->date))
		{
			$date = $row->date;
			$tmp = explode(".", $date);
			$date = $tmp[2]."-".$tmp[1]."-".$tmp[0];
			$time = $row->time;
		}
		else
		{
			$date = date("Y-m-d");
			$time = date("H:i:s");
		}

		$sender_users = '<select name="db_sender_id" size="5">';
		$recip_users = '<select name="db_recip_id" size="5">';
		foreach($results as $result)
		{
			$sender_users .= '<option value="'.$result->id.'"';
			$recip_users .= '<option value="'.$result->id.'"';
			if(isset($row->sender_id))
			{
				if($result->id==$row->sender_id) $sender_users .= ' selected';
				if($result->id==$row->recip_id) $recip_users .= ' selected';
			}
			$sender_users .= '>';
			$recip_users .= '>';
			if($userlist==0)
			{
				$sender_users .= $result->username;
				$recip_users .= $result->username;
			}
			if($userlist==1)
			{
				$sender_users .= $result->name;
				$recip_users .= $result->name;
			}
			if($userlist==2)
			{
				$sender_users .= $result->username.' ('.$result->name.')';
				$recip_users .= $result->username.' ('.$result->name.')';
			}
			if($userlist==3)
			{
				$sender_users .= $result->name.' ('.$result->username.')';
				$recip_users .= $result->name.' ('.$result->username.')';
			}
			$sender_users .= '</option>';
			$recip_users .= '</option>';
		}
		$sender_users .= '</select>';
		$recip_users .= '</select>';
		?>
		<tr>
			<td width="100%">
				<img src="components/com_pms/images/asterisk.png" style="margin-right:10px; vertical-align:middle;" alt="asterisk.png" />
				<font style="color: #FF9E31;font-size : 18px;font-weight: bold;text-align: left;"><?php echo _PMS_SETTINGS_TITLE; ?></font>
			</td>
		</tr>
		</table>
		<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
		<tr>
			<th class="title" colspan="4">
				<?php echo isset($row->id) ? _PMS_BACKEND_PM_EDIT : _PMS_BACKEND_PM_NEW; ?>
			</th>
		</tr>
		<tr>
			<td align="right" valign="top">
				<b><?php echo _PMS_SENDER; ?>:</b>
			</td>
			<td>
				<?php echo $sender_users; ?>
			</td>
			<td align="right" valign="top">
				<b><?php echo _PMS_RECIP; ?>:</b>
			</td>
			<td width="100%">
				<?php echo $recip_users; ?>
			</td>
		</tr>
		<tr>
			<td align="right">
				<b><?php echo _PMS_SUBJECT; ?>:</b>
			</td>
			<?php
			$database->setQuery("DESCRIBE #__pms");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$result = $database->loadResultArray(1);
			$subject_length = substr($result[6], 8, -1);
			?>
			<td colspan="3">
				<input type="text" name="db_subject" value="<?php echo isset($row->subject) ? $row->subject : ""; ?>" size="50" maxlength="<?php echo $subject_length; ?>" />
			</td>
		</tr>
		<tr>
			<td align="right" valign="top">
				<b><?php echo _PMS_MESSAGE; ?>:</b>
			</td>
			<td colspan="3">
			<?php
				if($bb_code==1)
				{
					define('_PMS_REQUEST_FROM_ADMIN', 'backend');
					$form = "adminForm";
					$field = "db_message";
					include_once(PMS_BASEPATH_COMPONENTS.'/bb_code.php');
				}
			?>
				<textarea name="db_message" rows="10" cols="40" style="float: left"><?php echo isset($row->message) ? $row->message : ""; ?></textarea>
			<?php
				if($smiley==1)
				{
					define('_PMS_REQUEST_FROM_ADMIN', 'backend');
					$form = "adminForm";
					$field = "db_message";
					include_once(PMS_BASEPATH_COMPONENTS.'/smiley.php');
				}
			?>
			</td>
		</tr>
		<tr>
			<td align="right">
				<b><?php echo _PMS_STATUS; ?>:</b>
			</td>
			<td colspan="3">
			<?php
				$status_arr[] = mosHTML::makeOption(0, _PMS_PM_UNREAD);
				$status_arr[] = mosHTML::makeOption(1, _PMS_PM_READ);
				$status_arr[] = mosHTML::makeOption(2, _PMS_PM_REPLY_UNREAD);
				$status_arr[] = mosHTML::makeOption(3, _PMS_PM_REPLY_READ);
				$status_arr[] = mosHTML::makeOption(4, _PMS_PM_FORWARD_UNREAD);
				$status_arr[] = mosHTML::makeOption(5, _PMS_PM_FORWARD_READ);
				$status_arr[] = mosHTML::makeOption(7, _PMS_PM_REPLY_FORWARD_READ);
				echo mosHTML::selectList($status_arr, 'db_readstate', 'size="1"', 'value', 'text', isset($row->readstate) ? $row->readstate : 0);
			?>
			</td>
		</tr>
		<tr>
			<td align="right" nowrap>
				<b><?php echo _PMS_BACKEND_STATUS_SENDER; ?>:</b>
			</td>
			<td colspan="3">
			<?php
				$sent_items_arr[] = mosHTML::makeOption(1, _PMS_SENT_ITEMS);
				$sent_items_arr[] = mosHTML::makeOption(0, _PMS_TRASH);
				$sent_items_arr[] = mosHTML::makeOption(-1, _PMS_BACKEND_DELETED);
				echo mosHTML::selectList($sent_items_arr, 'db_sent_items', 'size="1"', 'value', 'text', isset($row->sent_items) ? $row->sent_items : 1);
			?>
			</td>
		</tr>
		<tr>
			<td align="right" nowrap>
				<b><?php echo _PMS_BACKEND_STATUS_RECIPIENT; ?>:</b>
			</td>
			<td colspan="3">
			<?php
				$inbox_arr[] = mosHTML::makeOption(1, _PMS_INBOX);
				$inbox_arr[] = mosHTML::makeOption(0, _PMS_TRASH);
				$inbox_arr[] = mosHTML::makeOption(-1, _PMS_BACKEND_DELETED);
				echo mosHTML::selectList($inbox_arr, 'db_inbox', 'size="1"', 'value', 'text', isset($row->inbox) ? $row->inbox : 1);
			?>
			</td>
		</tr>
	<?php
	}
	else
	{
	?>
		<tr>
			<td width="100%">
				<img src="components/com_pms/images/asterisk.png" style="margin-right:10px; vertical-align:middle;" alt="asterisk.png" />
				<font style="color: #FF9E31;font-size : 18px;font-weight: bold;text-align: left;"><?php echo _PMS_SETTINGS_TITLE; ?></font>
			</td>
		</tr>
		<tr>
			<td>
				<?php echo _PMS_BACKEND_NOT_ADMIN; ?>
			</td>
		</tr>
	<?php
	}
	?>
	</table>
	<input type="hidden" name="error_no_users" value="<?php echo _PMS_BACKEND_VALID_NO_USERS; ?>" />
	<input type="hidden" name="error_same_users" value="<?php echo _PMS_BACKEND_VALID_SAME_USERS; ?>" />
	<input type="hidden" name="error_no_message" value="<?php echo _PMS_BACKEND_VALID_NO_MESSAGE; ?>" />
	<input type="hidden" name="bb_insert_at" value="<?php echo _PMS_BB_INSERT_AT; ?>" />
	<input type="hidden" name="bb_enter_text" value="<?php echo _PMS_BB_ENTER_TEXT; ?>" />
	<input type="hidden" name="option" value="<?php echo $option;?>" />
	<input type="hidden" name="id" value="<?php echo isset($row->id) ? $row->id : ""; ?>" />
	<input type="hidden" name="db_date" value="<?php echo $date; ?>" />
	<input type="hidden" name="db_time" value="<?php echo $time; ?>" />
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="act" value="view_edit" />
	</form>
	<?php
}

function about()
{
	
?>
	<table cellpadding="4" cellspacing="0" border="0" width="100%">
	<tr>
		<td width="100%">
			<img src="components/com_pms/images/asterisk.png" style="margin-right:10px; vertical-align:middle;" alt="asterisk.png" />
			<font style="color: #FF9E31;font-size : 18px;font-weight: bold;text-align: left;"><?php echo _PMS_SETTINGS_TITLE; ?></font>
		</td>
	</tr>
	</table>
	<form action="index2.php" method="post" name="adminForm" onSubmit="return pms_backend_about_validate('<?php echo _PMS_BACKEND_ABOUT_VALIDATE; ?>');">
	<table class="adminlist">
	<tr>
		<th class="title" colspan="2">
			<?php echo _PMS_BACKEND_ABOUT_SUGGESTION; ?>
		</th>
		<th class="title">
			<div align="center"><?php echo _PMS_BACKEND_ABOUT_TITLE; ?></div>
		</th>
	</tr>
	<tr>
		<td align="right" nowrap>
			<b><?php echo _PMS_BACKEND_ABOUT_NAME; ?></b>
		</td>
		<td>
			<input type="text" name="about_name" style="width: 300px;" />
		</td>
		<td width="100%" align="center" valign="middle" rowspan="5">
			<?php echo _PMS_BACKEND_ABOUT_TEXT; ?>
		</td>
	</tr>
	<tr>
		<td align="right" nowrap>
			<b><?php echo _PMS_BACKEND_ABOUT_MAIL; ?></b>
		</td>
		<td>
			<input type="text" name="about_mail" style="width: 300px;" />
		</td>
	</tr>
	<tr>
		<td align="right" nowrap>
			<b><?php echo _PMS_SUBJECT; ?>:</b>
		</td>
		<td>
			<input type="text" name="about_subject" style="width: 300px;" />
		</td>
	</tr>
	<tr>
		<td align="right" valign="top" nowrap>
			<b><?php echo _PMS_MESSAGE; ?>:</b>
		</td>
		<td>
			<textarea name="about_message" style="width: 300px; height:200px;"></textarea>
		</td>
	</tr>
	<tr>
		<td colspan="2" align="center">
			<input type="submit" value="<?php echo _PMS_BACKEND_ABOUT_SENT; ?>" class="button" />
		</td>
	</tr>
	</table>
	<input type="hidden" name="option" value="com_pms" />
	<input type="hidden" name="act" value="about" />
	</form>
<?php
}

}
?>