<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$sort_value = mosGetParam($_POST, 'sort_value');
$asc_desc_value = mosGetParam($_POST, 'asc_desc_value');
$sort_value = $database->getEscaped($sort_value);
$asc_desc_value = $database->getEscaped($asc_desc_value);
if($sort_value AND $sort_value!="")
{
	if($sort_value=="date") $sort = "ORDER BY t1.date ".$asc_desc_value.", t1.time ".$asc_desc_value;
	else $sort = "ORDER BY ".$sort_value." ".$asc_desc_value;
}
else $sort = "ORDER BY t1.date DESC, t1.time DESC";
$limitstart = mosGetParam($_POST, 'limitstart');
$limitstart = $database->getEscaped($limitstart);
if(!$limitstart OR $limitstart=="") $limitstart = 0;

if($page=="inbox")
{
	DEFINE('_PMS_SUBTITLE', _PMS_INBOX);
	$base_url_param = "?option=com_pms&Itemid=".$pms_menuid."&page=".$page;
	$count_pm = $pm_in_inbox;
	$limit = $rows_per_page;
	if($limit>$count_pm) $limitstart = 0;
	$list_query = "SELECT t1.id, t1.date, DATE_FORMAT(t1.date, '%d.%m.%Y') AS sentdate, t1.time, t1.readstate, t1.subject, t1.message, t2.id AS sender_id, t2.username AS sender_username, t2.name AS sender_name FROM #__pms AS t1, #__users AS t2 WHERE t1.recip_id=$my_id AND t1.inbox=1 AND t1.sender_id=t2.id $sort LIMIT $limitstart, $limit";
	$sort_arr[0] = mosHTML::makeOption('t1.readstate', _PMS_STATUS);
	if($userlist==0 OR $userlist==2) $sort_arr[1] = mosHTML::makeOption('sender_username', _PMS_SENDER);
	if($userlist==1 OR $userlist==3) $sort_arr[1] = mosHTML::makeOption('sender_name', _PMS_SENDER);
	$sort_arr[2] = mosHTML::makeOption('t1.subject', _PMS_SUBJECT);
	$sort_arr[3] = mosHTML::makeOption('date', _PMS_DATETIME);
	$col_title_arr[0] = _PMS_STATUS;
	$col_title_arr[1] = _PMS_SENDER;
	$col_title_arr[2] = _PMS_SUBJECT;
	$col_title_arr[3] = _PMS_DATETIME;
	$options_arr[0] = mosHTML::makeOption('trash_sel', _PMS_TO_TRASH);
	$options_arr[1] = mosHTML::makeOption('delete_sel', _PMS_DELETE);
}
if($page=="sent_items")
{
	DEFINE('_PMS_SUBTITLE', _PMS_SENT_ITEMS);
	$base_url_param="?option=com_pms&Itemid=".$pms_menuid."&page=".$page;
	$count_pm = $pm_in_sent_items;
	$limit = $rows_per_page;
	if($limit>$count_pm) $limitstart = 0;
	$list_query = "SELECT t1.id, t1.date, DATE_FORMAT(t1.date, '%d.%m.%Y') AS sentdate, t1.time, t1.readstate, t1.subject, t1.message, t2.id AS recip_id, t2.username AS recip_username, t2.name AS recip_name FROM #__pms AS t1, #__users AS t2 WHERE sender_id=$my_id AND sent_items=1 AND t1.recip_id=t2.id $sort LIMIT $limitstart, $limit";
	$sort_arr[0] = mosHTML::makeOption('t1.readstate', _PMS_STATUS);
	if($userlist==0 OR $userlist==2) $sort_arr[1] = mosHTML::makeOption('recip_username', _PMS_RECIP);
	if($userlist==1 OR $userlist==3) $sort_arr[1] = mosHTML::makeOption('recip_name', _PMS_RECIP);
	$sort_arr[2] = mosHTML::makeOption('t1.subject', _PMS_SUBJECT);
	$sort_arr[3] = mosHTML::makeOption('date', _PMS_DATETIME);
	$col_title_arr[0] = _PMS_STATUS;
	$col_title_arr[1] = _PMS_RECIP;
	$col_title_arr[2] = _PMS_SUBJECT;
	$col_title_arr[3] = _PMS_DATETIME;
	$options_arr[0] = mosHTML::makeOption('trash_sel', _PMS_TO_TRASH);
	$options_arr[1] = mosHTML::makeOption('delete_sel', _PMS_DELETE);
	if($retract==1 OR $retract==2) $options_arr[2] = mosHTML::makeOption('retract_sel', _PMS_RETRACT);
}
if($page=="trash" OR $page=="search")
{
	DEFINE('_PMS_SUBTITLE', _PMS_TRASH);
	$base_url_param = "?option=com_pms&Itemid=".$pms_menuid."&page=".$page;
	$limit = $rows_per_page;
	if($page!="search")
	{
		$list_query = "SELECT t1.id, t1.date, DATE_FORMAT(t1.date, '%d.%m.%Y') AS sentdate, t1.time, t1.readstate, t1.subject, t2.id AS recip_id, t2.username AS recip_username, t2.name AS recip_name, t3.id AS sender_id, t3.username AS sender_username, t3.name AS sender_name FROM #__pms AS t1, #__users AS t2, #__users AS t3 WHERE t2.id=t1.recip_id AND t3.id=t1.sender_id AND ((t1.recip_id=$my_id AND t1.inbox=0) OR (t1.sender_id=$my_id AND t1.sent_items=0)) $sort LIMIT $limitstart, $limit";
		$count_pm = $pm_in_trash;
	}
	if($limit > $count_pm) $limitstart = 0;
	$sort_arr[0] = mosHTML::makeOption('t1.readstate', _PMS_STATUS);
	if($userlist==0 OR $userlist==2)
	{
		$sort_arr[1] = mosHTML::makeOption('sender_username', _PMS_SENDER);
		$sort_arr[2] = mosHTML::makeOption('recip_username', _PMS_RECIP);
	}
	if($userlist==1 OR $userlist==3)
	{
		$sort_arr[1] = mosHTML::makeOption('sender_name', _PMS_SENDER);
		$sort_arr[2] = mosHTML::makeOption('recip_name', _PMS_RECIP);
	}
	$sort_arr[3] = mosHTML::makeOption('t1.subject', _PMS_SUBJECT);
	$sort_arr[4] = mosHTML::makeOption('date', _PMS_DATETIME);
	$col_title_arr[0] = _PMS_STATUS;
	$col_title_arr[1] = _PMS_SENDER;
	$col_title_arr[2] = _PMS_RECIP;
	$col_title_arr[3] = _PMS_SUBJECT;
	$col_title_arr[4] = _PMS_DATETIME;
	if($page=="search")
	{
		$options_arr[0] = mosHTML::makeOption('trash_sel', _PMS_TO_TRASH);
		$options_arr[1] = mosHTML::makeOption('delete_sel', _PMS_DELETE);
		$options_arr[2] = mosHTML::makeOption('recycle_sel', _PMS_RECYCLE);
		if($retract==1 OR $retract==2) $options_arr[3] = mosHTML::makeOption('retract_sel', _PMS_RETRACT);
	}
	else
	{
		$options_arr[0] = mosHTML::makeOption('delete_sel', _PMS_DELETE);
		$options_arr[1] = mosHTML::makeOption('recycle_sel', _PMS_RECYCLE);
		if($retract==1 OR $retract==2) $options_arr[2] = mosHTML::makeOption('retract_sel', _PMS_RETRACT);
	}
}

$count_cols = count($col_title_arr)+1;
$asc_desc_arr[0] = mosHTML::makeOption('ASC', _PMS_ASC);
$asc_desc_arr[1] = mosHTML::makeOption('DESC', _PMS_DESC);
if($page!="search")
{
	$mainframe->appendPathWay(_PMS_SUBTITLE);
?>

<table width="100%" cellpadding="0" cellspacing="0" border="0" align="center" class="contentpane">
<tr>
	<td>
		<span class="contentheading">
			<?php echo _PMS_TITLE; ?>:&nbsp;<?php echo _PMS_SUBTITLE; ?>
		</span>
	</td>
</tr>
</table>

<?php
}
$options = mosGetParam($_POST, 'options');
$submit_value = mosGetParam($_POST, 'submit_value');
$options = $database->getEscaped($options);
$submit_value = $database->getEscaped($submit_value);

if($options=="trash_sel" AND $submit_value=="submit")
{
	$selection = mosGetParam($_POST, 'selection');
	$pm_ids = implode(",", $selection);
	$pm_ids = $database->getEscaped($pm_ids);
	if($page=="inbox") $pm_to_trash = "UPDATE #__pms SET inbox=0 WHERE id IN (".$pm_ids.")";
	if($page=="sent_items") $pm_to_trash = "UPDATE #__pms SET sent_items=0 WHERE id IN (".$pm_ids.")";
	$database->setQuery($pm_to_trash);
	if(!$database->query())
	{
		pms_sql_error($database->getErrorMsg());
		if(count($_POST['selection'])==1) $mosmsg = _PMS_MSG_TRASHED_ERROR;
		else $mosmsg = _PMS_MSG_TRASHED_MULTIPLE_ERROR;
	}
	else
	{
		if(count($_POST['selection'])==1) $mosmsg = _PMS_MSG_TRASHED;
		else $mosmsg = _PMS_MSG_TRASHED_MULTIPLE;
	}
	mosRedirect('index.php'.$base_url_param.'&mosmsg='.$mosmsg);
}
if($options=="retract_sel" AND $submit_value=="submit")
{
	$forbidden = false;
	$forbidden_count = 0;
	$error = false;
	$selection = mosGetParam($_POST, 'selection');
	if($retract==1)
	{
		$pm_ids = implode(",", $selection);
		$pm_ids = $database->getEscaped($pm_ids);
		$database->setQuery("DELETE FROM #__pms WHERE id IN (".$pm_ids.")");
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			$error = true;
		}
	}
	if($retract==2)
	{
		foreach($selection AS $retract_id)
		{
			$retract_id = intval($retract_id);
			$database->setQuery("SELECT readstate FROM #__pms WHERE id=$retract_id LIMIT 1");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$readstate = $database->loadResult();
			if($readstate%2==0) $retract_arr[] = $retract_id;
			else
			{
				$forbidden = true;
				$forbidden_count++;
			}
		}
		count($retract_arr) > 0 ? $retract_ids = implode(",", $retract_arr) : $retract_ids = -1;
		$database->setQuery("DELETE FROM #__pms WHERE id IN (".$retract_ids.")");
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			$error = true;
		}
	}
	if($error)
	{
		if(count($selection)==1) $mosmsg = _PMS_MSG_RETRACTED_ERROR;
		else $mosmsg = _PMS_MSG_RETRACTED_MULTIPLE_ERROR;
	}
	elseif(count($selection)==1)
	{
		if(!$forbidden) $mosmsg = _PMS_MSG_RETRACTED;
		else $mosmsg = _PMS_MSG_RETRACTED_FORBIDDEN;
	}
	else
	{
		if(!$forbidden) $mosmsg = _PMS_MSG_RETRACTED_MULTIPLE;
		elseif($forbidden_count==count($selection)) $mosmsg = _PMS_MSG_RETRACTED_MULTIPLE_FORBIDDEN_ALL; 
		else $mosmsg = _PMS_MSG_RETRACTED_MULTIPLE_FORBIDDEN_SOME;
	}
	mosRedirect('index.php'.$base_url_param.'&mosmsg='.$mosmsg);
}
if($options=="delete_sel" AND $submit_value=="submit")
{
	$selection = mosGetParam($_POST, 'selection');
	foreach($selection AS $key)
	{
    	$key = intval($key);
    	$database->setQuery("SELECT recip_id FROM #__pms WHERE id=$key");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$rows = $database->loadObjectList();
		$row = $rows[0];
		$recip_id = $row->recip_id;
		if($recip_id==$my_id) $pm_delete = "UPDATE #__pms SET inbox=-1 WHERE id=$key";
		else $pm_delete = "UPDATE #__pms SET sent_items=-1 WHERE id=$key";
		$database->setQuery($pm_delete);
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			if(count($selection)==1) $mosmsg = _PMS_MSG_DELETED_ERROR;
			else $mosmsg = _PMS_MSG_DELETED_MULTIPLE_ERROR;
		}
		else
		{
			if(count($selection)==1) $mosmsg = _PMS_MSG_DELETED;
			else $mosmsg = _PMS_MSG_DELETED_MULTIPLE;
		}
	}
	$database->setQuery("DELETE FROM #__pms WHERE inbox=-1 AND sent_items=-1");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	mosRedirect('index.php'.$base_url_param.'&mosmsg='.$mosmsg);
}
if($options=="recycle_sel" AND $submit_value=="submit")
{
	$selection = mosGetParam($_POST, 'selection');
	foreach($selection AS $key)
	{
    	$key = intval($key);
    	$database->setQuery("SELECT recip_id FROM #__pms WHERE id=$key");
    	if(!$database->query()) pms_sql_error($database->getErrorMsg());
    	$rows = $database->loadObjectList();
		$row = $rows[0];
		$recip_id = $row->recip_id;
    	if($recip_id==$my_id) $pm_recycle = "UPDATE #__pms SET inbox=1 WHERE id=$key";
    	else $pm_recycle = "UPDATE #__pms SET sent_items=1 WHERE id=$key";
		$database->setQuery($pm_recycle);
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			if(count($selection)==1) $mosmsg = _PMS_MSG_RECYCLED_ERROR;
			else $mosmsg = _PMS_MSG_RECYCLED_MULTIPLE_ERROR;
		}
		else
		{
			if(count($selection)==1) $mosmsg = _PMS_MSG_RECYCLED;
			else $mosmsg = _PMS_MSG_RECYCLED_MULTIPLE;
		}
	}
	mosRedirect('index.php'.$base_url_param.'&mosmsg='.$mosmsg);
}

if($count_pm<1 AND $page!="search") echo _PMS_NO_MSG._PMS_SUBTITLE.'.';
elseif($count_pm==0 AND $page=="search") echo _PMS_SEARCH_NO_RESULTS;
else
{
	$database->setQuery($list_query);
	$result = $database->query();
	if(!$result) pms_sql_error($database->getErrorMsg());
	if($page!="search")
	{
?>
	<form name="pmsForm" method="post" action="index.php<?php echo $base_url_param; ?>">
	<?php
	}
	?>
	<table width="100%">
	<tr>
		<td align="left">
			<?php echo _PMS_SORT_FOR.':'.mosHTML::selectList($sort_arr, 'sort', 'class="inputbox" size="1"', 'value', 'text', $sort_value).mosHTML::selectList($asc_desc_arr, 'asc_desc', 'class="inputbox" size="1"', 'value', 'text', $asc_desc_value); ?>
			<input type="submit" class="button" value="<?php echo _PMS_SORT; ?>" onClick="pms_list_update_sort_fields()" />
		</td>
		<td align="right">
			<?php echo _PMS_PAGE; pms_writePagesLinks($limitstart, $limit, $count_pm); ?>
		</td>
	</tr>
	</table>
	<table cellspacing="1" cellpadding="4" border="0" width="100%" class="contentpane">
	<tr>
		<th class="sectiontableheader">
			<input type="checkbox" name="alle" onClick="pms_list_check_all()" />
		</th>
	<?php
	foreach($col_title_arr AS $col_title)
	{
		echo '<th class="sectiontableheader"';
		if($col_title==_PMS_SUBJECT) echo ' width="100%"';
		echo '><b>'.$col_title.'</b></th>';
	}
	?>
	</tr>
	<?php
	$i = 0;
	while($row = mysql_fetch_assoc($result))
	{
		if($page!="sent_items")
		{
			if($userlist==0 OR $userlist==2)
			{
				$sender = $row['sender_username'];
				$database->setQuery("SELECT count(username) FROM #__session WHERE username='$sender' LIMIT 1");
			}
			if($userlist==1 OR $userlist==3)
			{
				$sender = $row['sender_name'];
				$database->setQuery("SELECT count(t2.name) FROM #__session AS t1, #__users AS t2 WHERE t1.username=t2.username AND t2.name='$sender' LIMIT 1");
			}
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$online_sender = $database->loadResult();
		}
		if($page!="inbox")
		{
			if($userlist==0 OR $userlist==2)
			{
				$recip = $row['recip_username'];
				$database->setQuery("SELECT count(username) FROM #__session WHERE username='$recip' LIMIT 1");
			}
			if($userlist==1 OR $userlist==3)
			{
				$recip = $row['recip_name'];
				$database->setQuery("SELECT count(t2.name) FROM #__session AS t1, #__users AS t2 WHERE t1.username=t2.username AND t2.name='$recip' LIMIT 1");
			}
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$online_recip = $database->loadResult();
		}
		$change_class = "sectiontableentry";
		$change_class .= $i % 2 + 1;
		?>
		<tr class="<?php echo $change_class; ?>">
			<td>
				<input type="checkbox" name="selection[]" value="<?php echo $row['id']; ?>" />
			</td>
			<td align=center>
				<img src="components/com_pms/images/<?php echo $row['readstate']; ?>.png" border="0" alt="<?php echo $readstate_img_alt[$row['readstate']]; ?>" title="<?php echo $readstate_img_alt[$row['readstate']]; ?>" />
			</td>
			<?php
			if($page!="sent_items")
			{
			?>
			<td>
				<table>
				<tr>
					<td width="100%">
						<?php
						if($cb_version>0)
						{
						?>
						<a href="index.php?option=com_comprofiler&task=userProfile&user=<?php echo $row['sender_id']; ?>&Itemid=<?php echo $cb_menuid; ?>"><?php echo $sender; ?></a>
						<?php
						}
						else echo $sender;
						?>
					</td>
					<td align="right">
					<?php
					if($online_sender)
					{
					?>
						<img src="components/com_pms/images/online.png" border="0" alt="<?php echo _PMS_ONLINE; ?>" title="<?php echo _PMS_ONLINE; ?>" />
					<?php
					}
					else
					{
					?>
						<img src="components/com_pms/images/offline.png" border="0" alt="<?php echo _PMS_OFFLINE; ?>" title="<?php echo _PMS_OFFLINE; ?>" />
					<?php
					}
					?>
					</td>
				</tr>
				</table>
			</td>
			<?php
			}
			if($page!="inbox")
			{
			?>
			<td>
				<table>
				<tr>
					<td width="100%">
						<?php
						if($cb_version>0)
						{
						?>
						<a href="index.php?option=com_comprofiler&task=userProfile&user=<?php echo $row['recip_id']; ?>&Itemid=<?php echo $cb_menuid; ?>"><?php echo $recip; ?></a>
						<?php
						}
						else echo $recip;
						?>
					</td>
					<td align="right">
					<?php
					if($online_recip)
					{
					?>
						<img src="components/com_pms/images/online.png" border="0" alt="<?php echo _PMS_ONLINE; ?>" title="<?php echo _PMS_ONLINE; ?>" />
					<?php
					}
					else
					{
					?>
						<img src="components/com_pms/images/offline.png" border="0" alt="<?php echo _PMS_OFFLINE; ?>" title="<?php echo _PMS_OFFLINE; ?>" />
					<?php
					}
					?>
					</td>
				</tr>
				</table>
			</td>
			<?php
			}
			?>
			<td>
				<a href="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=open&id=<?php echo $row['id']; ?>" />
				<?php
					if(!get_magic_quotes_gpc()) echo pms_parse(stripslashes($row['subject']));
					else echo pms_parse($row['subject']);
				?>
				</a>
			</td>
			<td nowrap align="center">
				<?php echo $row['sentdate']; echo _PMS_AT.$row['time']; ?>
			</td>
		</tr>
		<?php
		$i++;
		}
		?>
		<tr>
			<td colspan="<?php echo $count_cols; ?>">
				<table width="100%" cellspacing="0" cellpadding="0">
				<tr>
					<td align="left">
					<?php
						echo _PMS_OPTIONS.mosHTML::selectList($options_arr, 'options', 'class="inputbox" size="1"', 'value', 'text', $options);
					?>
						<input type="submit" class="button" name="options_submit" value="<?php echo _PMS_OPTIONS_SUBMIT; ?>" onClick="return pms_list_submit()" />
					</td>
					<td align="right">
					<?php
						pms_writePagesCounter($limitstart, $limit, $count_pm);
					?>
					</td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
		<input type="hidden" name="submit_value" value="" />
		<input type="hidden" name="submit_error" value="<?php echo _PMS_OPTIONS_SUBMIT_NO_SELECTION; ?>" />
		<input type="hidden" name="sort_value" value="<?php echo $sort_value; ?>" />
		<input type="hidden" name="asc_desc_value" value="<?php echo $asc_desc_value; ?>" />
		<input type="hidden" name="limitstart" value="<?php echo $limitstart; ?>" />
	<?php
	if($page!="search")
	{
	?>
	</form>
	<?php
	}
}
?>