<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

?>
<style type="text/css">
ul#pms_mainmenu
{
	margin: 0px;
	padding: 0px;
	text-align: center;
}
ul#pms_mainmenu li
{
	list-style: none;
	display: inline;
	float: left;
	margin: 5px 10px;
	padding: 0px;
	background: 0px;
}
ul#pms_mainmenu img
{
	vertical-align: middle;
}
</style>
<ul id="pms_mainmenu">
	<li title="<?php echo _PMS_INBOX; ?>">
		<a href="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=inbox">
		<?php
		if($menu_layout==0) echo '<img src="components/com_pms/images/inbox.png" border="0" alt="'._PMS_INBOX.'" />&nbsp;('.$pm_in_inbox.')';
		if($menu_layout==1) echo _PMS_INBOX.'&nbsp;('.$pm_in_inbox.')';
		if($menu_layout==2) echo '<img src="components/com_pms/images/inbox.png" border="0" alt="'._PMS_INBOX.'" />&nbsp;('.$pm_in_inbox.')<br />'._PMS_INBOX;
		?>
		</a>
	</li>
	
	<li title="<?php echo _PMS_SENT_ITEMS; ?>">
		<a href="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=sent_items">
		<?php
		if($menu_layout==0) echo '<img src="components/com_pms/images/sent_items.png" border="0" alt="'._PMS_SENT_ITEMS.'" />&nbsp;('.$pm_in_sent_items.')';
		if($menu_layout==1) echo _PMS_SENT_ITEMS.'&nbsp;('.$pm_in_sent_items.')';
		if($menu_layout==2) echo '<img src="components/com_pms/images/sent_items.png" border="0" alt="'._PMS_SENT_ITEMS.'" />&nbsp;('.$pm_in_sent_items.')<br />'._PMS_SENT_ITEMS;
		?>
		</a>
	</li>
	
	<li title="<?php echo _PMS_WRITE; ?>">
		<a href="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=new">
		<?php
		if($menu_layout==0) echo '<img src="components/com_pms/images/write.png" border="0" alt="'._PMS_WRITE.'" />';
		if($menu_layout==1) echo _PMS_WRITE;
		if($menu_layout==2) echo '<img src="components/com_pms/images/write.png" border="0" alt="'._PMS_WRITE.'" /><br />'._PMS_WRITE;
		?>
		</a>
	</li>
	
	<li title="<?php echo _PMS_SEARCH; ?>">
		<a href="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=search">
		<?php
		if($menu_layout==0) echo '<img src="components/com_pms/images/search.png" border="0" alt="'._PMS_SEARCH.'" />';
		if($menu_layout==1) echo _PMS_SEARCH;
		if($menu_layout==2) echo '<img src="components/com_pms/images/search.png" border="0" alt="'._PMS_SEARCH.'" /><br />'._PMS_SEARCH;
		?>
		</a>
	</li>
	
	<li title="<?php echo _PMS_TRASH; ?>">
		<a href="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=trash">
		<?php
		if($menu_layout==0) echo '<img src="components/com_pms/images/trash.png" border="0" alt="'._PMS_TRASH.'" />&nbsp;('.$pm_in_trash.')';
		if($menu_layout==1) echo _PMS_TRASH.' ('.$pm_in_trash.')';
		if($menu_layout==2) echo '<img src="components/com_pms/images/trash.png" border="0" alt="'._PMS_TRASH.'" />&nbsp;('.$pm_in_trash.')<br />'._PMS_TRASH;
		?>
		</a>
	</li>

	<?php
	if($addressbook==1)
	{
	?>
		<li title="<?php echo _PMS_ADDRESSBOOK; ?>">
			<a href="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=addressbook">
			<?php
			if($menu_layout==0) echo '<img src="components/com_pms/images/addressbook.png" border="0" alt="'._PMS_ADDRESSBOOK.'" />';
			if($menu_layout==1) echo _PMS_ADDRESSBOOK;
			if($menu_layout==2) echo '<img src="components/com_pms/images/addressbook.png" border="0" alt="'._PMS_ADDRESSBOOK.'" /><br />'._PMS_ADDRESSBOOK;
			?>
			</a>
		</li>
	
	<?php
	}
	if($ignorelist==1)
	{
	?>
		<li title="<?php echo _PMS_IGNORELIST; ?>">
			<a href="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=ignore">
			<?php
			if($menu_layout==0) echo '<img src="components/com_pms/images/ignorelist.png" border="0" alt="'._PMS_IGNORELIST.'" />';
			if($menu_layout==1) echo _PMS_IGNORELIST;
			if($menu_layout==2) echo '<img src="components/com_pms/images/ignorelist.png" border="0" alt="'._PMS_IGNORELIST.'" /><br />'._PMS_IGNORELIST;
			?>
			</a>
		</li>
	
	<?php
	}
	if($user_settings==1)
	{
	?>
		<li title="<?php echo _PMS_SETTINGS; ?>">
			<a href="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=settings">
			<?php
			if($menu_layout==0) echo '<img src="components/com_pms/images/settings.png" border="0" alt="'._PMS_SETTINGS.'" />';
			if($menu_layout==1) echo _PMS_SETTINGS;
			if($menu_layout==2) echo '<img src="components/com_pms/images/settings.png" border="0" alt="'._PMS_SETTINGS.'" /><br />'._PMS_SETTINGS;
			?>
			</a>
		</li>
	<?php
	}
	?>
</ul>
<p style="clear: left"></p>
<br />