<?php
/*
	XML-RPC Komponente - Joomla! PMS- Center
	Author: 	Tobias Burggraf
			http://www.joomlascripts.de
	Version: 	1.0.0
	
	Note: this class is part of the Joomla! PMS- Center package. Its licenced unter the GPL.
	Please, dont remove this copyright!
	
	(c) Original by: http://www.iphosting.ch/index.php?content=schnipsel&id=45"
	
*/

$sperrfile = "dagdfgneroir302948sdajfsarzutqewewlsfehrueqrhrhe.php";

//GLOBAL Sperrzeit in Sekunden
$sperrstamp = 1;

//////////////////////////////////////////////////////////////////////////////////////////////
//Diese Funktion ermittelt uns die IP des Besuchers
//Leider nur zum Teil zuverlssig
//zu sehen unter "http://www.iphosting.ch/index.php?content=schnipsel&id=45"
function get_ip()
{
$ip = "";

if (getenv("HTTP_CLIENT_IP"))
	$ip = getenv("HTTP_CLIENT_IP");
else if(getenv("HTTP_X_FORWARDED_FOR"))
	$ip = getenv("HTTP_X_FORWARDED_FOR");
else if(getenv("REMOTE_ADDR"))
	$ip = getenv("REMOTE_ADDR");
else
	$ip = "";

return $ip;
}


function delete_entry ($timestamp)
{

GlOBAL $sperrstamp;

GLOBAL $sperrfile;

$lines = file ($sperrfile);

if (is_array ($lines))
{
//Durchlaufen wir $lines zeilenweise
foreach ($lines as $key => $var)
{
	//Hier trennen wir jede Zeile anhand von ## auf
	//in $values[0] ist die IP
	//in $values[1] ist der Eintragezeitpunkt
	//in $values[2] ist die ausgefhrte Aktion
	$values = explode ("##", $var);
	//In die Variable $old_time kommt nun der Wert des Eintragezeitpunktes
	//und der Sperrzeit addiert
	$old_time = $values[1] + $sperrstamp;
	//Falls die Variable $old_time kleiner ist als der jetztige Zeitpunkt
	
	if ($old_time < $timestamp || empty ($var))
	{	
		unset ($lines[$key]);
	}
}

$fp = fopen ($sperrfile, "w");

foreach ($lines as $var)
	{
	
		fputs ($fp, $var . "");
	}
	//Dateizeiger schliessen
	fclose ($fp);
	}
}

function check_entry ($ip, $timestamp, $action)
{
//Datei "sperren.txt" als Global definieren
GLOBAL $sperrfile;
//Die Datei erneut in ein Array einlesen
$lines = file ($sperrfile);
//Falls die Datei nicht leer war
if (is_array ($lines))
{
//Durchlaufen wir sie zeilenweise
foreach ($lines as $line)
{
//Falls wir in einer Zeile
//// IP ## *irgendeinen Zeitstempel* ## und die Gesuchte Akion ////
//finden
if (preg_match ("/$ip##(.*)##$action/", $line))
{
return false;
}
}

return true;
}

else
{

return true;
}

}


function write_entry ($ip, $timestamp, $action)
{
GLOBAL $sperrfile;
$lines = file_get_contents ($sperrfile);
$fp = fopen ($sperrfile, "w");
//Den neuen Eintrag schreiben
fputs ($fp, "$ip##$timestamp##$action\n");
//Die alten Eintrge schreiben
fputs ($fp, $lines);
//Dateizeiger schliessen
fclose ($fp);
}


function check_it ($ip, $timestamp, $action)
{

delete_entry ($timestamp);

if (check_entry ($ip, $timestamp, $action))
{
write_entry ($ip, $timestamp, $action);
return true;
}
else
{
return false;
}
}
?>
