<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$mainframe->appendPathWay(_PMS_SEARCH);

$sort_value = mosGetParam($_POST, 'sort_value');
$asc_desc_value = mosGetParam($_POST, 'asc_desc_value');
$sort_value = $database->getEscaped($sort_value);
$asc_desc_value = $database->getEscaped($asc_desc_value);

if($sort_value AND $sort_value!="")
{
	if($sort_value=="date") $sort = "ORDER BY t1.date ".$asc_desc_value.", t1.time ".$asc_desc_value;
	else $sort = "ORDER BY ".$sort_value." ".$asc_desc_value;
}
else $sort = "ORDER BY t1.date DESC, t1.time DESC";
$limitstart = mosGetParam($_POST, 'limitstart');
$limitstart = $database->getEscaped($limitstart);
if(!$limitstart OR $limitstart=="") $limitstart = 0;
$limit = $rows_per_page;

$sender = mosGetParam($_POST, 'sender');
$recip = mosGetParam($_POST, 'recip');
$subject = mosGetParam($_POST, 'subject');
$message = mosGetParam($_POST, 'message');
$sender = $database->getEscaped($sender);
$recip = $database->getEscaped($recip);
$subject = $database->getEscaped($subject);
$message = $database->getEscaped($message);

?>
<table width="100%" cellpadding="0" cellspacing="0" border="0" align="center" class="contentpane">
<tr>
	<td colspan="2">
		<span class="contentheading">
			<?php echo _PMS_TITLE; ?>:&nbsp;<?php echo _PMS_SEARCH; ?>
		</span>
	</td>
</tr>
</table>

<form name="pmsForm" method="post" action="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=search" onSubmit="return pms_search_validate('<?php echo _PMS_SEARCH_VALIDATE; ?>')">
<table cellspacing="1" cellpadding="4" border="0" class="contentpane" align="center" width="100%">
<tr class="sectiontableheader">
	<th colspan="2">
		<b><?php echo _PMS_SEARCH_FOR; ?></b>
	</th>
</tr>
<tr class="sectiontableentry1">
	<td>
		<b><?php echo _PMS_SENDER; ?>:</b>
	</td>
	<td width="100%">
		<input type="text" name="sender" class="inputbox_pms" value="<?php echo $sender; ?>" />
	</td>
</tr>
<tr class="sectiontableentry2">
	<td>
		<b><?php echo _PMS_RECIP; ?>:</b>
	</td>
	<td>
		<input type="text" name="recip" class="inputbox_pms" value="<?php echo $recip; ?>" />
	</td>
</tr>
<tr class="sectiontableentry1">
	<td>
		<b><?php echo _PMS_SUBJECT; ?>:</b>
	</td>
	<td>
		<input type="text" name="subject" class="inputbox_pms" value="<?php echo $subject; ?>" />
	</td>
</tr>
<tr class="sectiontableentry2">
	<td>
		<b><?php echo _PMS_MESSAGE; ?>:</b>
	</td>
	<td>
		<input type="text" name="message" class="inputbox_pms" value="<?php echo $message; ?>" />
	</td>
</tr>
<tr>
	<td colspan="2" align="center">
		<input type="submit" class="button" name="search" value="<?php echo _PMS_SEARCH_BUTTON; ?>" />
	</td>
</tr>
</table>

<?php

if(mosGetParam($_POST, 'search') OR mosGetParam($_POST, 'search_result'))
{
	$search_where = array();
	if($subject!="")
	{
		$tmp = explode(" ", $subject);
		foreach($tmp as $word) $search_where[] = "t1.subject LIKE '%$word%'";
	}
	if($message!="")
	{
		$tmp = explode(" ", $message);
		foreach($tmp as $word) $search_where[] = "t1.message LIKE '%$word%'";
	}
	if($userlist==0 OR $userlist==2)
	{
		if($sender!="") $search_where[] = "(t2.username LIKE '%".$sender."%')";
		if($recip!="") $search_where[] = "(t3.username LIKE '%".$recip."%')";
	}
	if($userlist==1 OR $userlist==3)
	{
		if($sender!="") $search_where[] = "(t2.name LIKE '%".$sender."%')";
		if($recip!="") $search_where[] = "(t3.name LIKE '%".$recip."%')";
	}
	
	$list_query = "SELECT t1.id, t1.subject, DATE_FORMAT(t1.date, '%d.%m.%Y') AS sentdate, t1.time, t1.readstate, t2.id AS sender_id, t2.username AS sender_username, t2.name AS sender_name, t3.id AS recip_id, t3.username AS recip_username, t3.name AS recip_name FROM #__pms AS t1, #__users AS t2, #__users AS t3 WHERE ((t1.recip_id=$my_id AND t1.inbox!=-1) OR (t1.sender_id=$my_id AND t1.sent_items!=-1)) AND t2.id=t1.sender_id AND t3.id=t1.recip_id AND ".implode(' AND ', $search_where)." $sort LIMIT $limitstart, $limit";
	
	$database->setQuery("SELECT count(t1.id) FROM #__pms AS t1, #__users AS t2, #__users AS t3 WHERE ((t1.recip_id=$my_id AND t1.inbox!=-1) OR (t1.sender_id=$my_id AND t1.sent_items!=-1)) AND t2.id=t1.sender_id AND t3.id=t1.recip_id AND ".implode(' AND ', $search_where));
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$count_pm = $database->loadResult();
	
	echo '<br />';
	include_once(PMS_BASEPATH_COMPONENTS . '/list.php');
	echo '<input type="hidden" name="search_result" value="true" />';
}
?>
</form>