<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$mainframe->appendPathWay(_PMS_SETTINGS);

?>
<table width="100%" cellpadding="0" cellspacing="0" border="0" align="center" class="contentpane">
<tr>
	<td colspan="2">
		<span class="contentheading">
			<?php echo _PMS_TITLE; ?>:&nbsp;<?php echo _PMS_SETTINGS; ?>
		</span>
	</td>
</tr>
</table>

<?php

if($user_settings==0) echo _PMS_SETTINGS_DISABLED;
else
{
	if(mosGetParam($_POST, 'save'))
	{
		$set = array();
		
		$email_new = mosGetParam($_POST, 'email_new');
		$email_reply = mosGetParam($_POST, 'email_reply');
		$email_html = mosGetParam($_POST, 'email_html');
		$email_offline = mosGetParam($_POST, 'email_offline');
		$email_sender_address = mosGetParam($_POST, 'email_sender_address');
		$format_reply = mosGetParam($_POST, 'format_reply');
		$clear_sent_items = mosGetParam($_POST, 'clear_sent_items');
		#$popup = mosGetParam($_POST, 'popup');
		#$sound = mosGetParam($_POST, 'sound');
		#$sound_value = mosGetParam($_POST, 'sound_value');
		$rows_per_page = mosGetParam($_POST, 'rows_per_page');
		$pages_in_list = mosGetParam($_POST, 'pages_in_list');
		
		if($allow_change_email_new==1) $set[] = "email_new=".intval($email_new);
		if($allow_change_email_reply==1) $set[] = "email_reply=".intval($email_reply);
		if($allow_change_email_html==1) $set[] = "email_html=".intval($email_html);
		if($allow_change_email_offline==1) $set[] = "email_offline=".intval($email_offline);
		if($allow_change_email_sender_address==1) $set[] = "email_sender_address=".intval($email_sender_address);
		if($allow_change_format_reply==1) $set[] = "format_reply=".intval($format_reply);
		if($allow_change_clear_sent_items==1) $set[] = "clear_sent_items=".intval($clear_sent_items);
		#if($allow_change_popup==1) $set[] = "popup=".intval($popup);
		#if($allow_change_sound==1) $set[] = "sound=".intval($sound);
		#if($allow_change_sound_value==1) $set[] = "sound_value=".intval($sound_value);
		if($allow_change_rows_per_page==1) $set[] = "rows_per_page=".intval($rows_per_page);
		if($allow_change_pages_in_list==1) $set[] = "pages_in_list=".intval($pages_in_list);
		$save = "UPDATE #__pms_conf SET ".implode(",", $set)." WHERE user_id=$my_id";
		$database->setQuery($save);
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			$mosmsg = _PMS_MSG_SAVE_SETTINGS_ERROR;
		}
		else $mosmsg = _PMS_MSG_SAVE_SETTINGS_ALL;
		mosRedirect('index.php?option=com_pms&Itemid='.$pms_menuid.'&page=settings&mosmsg='.$mosmsg);
	}
?>
<form name="pmsForm" method="post" action="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=settings">
<table border="0" cellspacing="1" cellpadding="4" class="contentpane">
<tr>
	<th class="sectiontableheader">
		<b><?php echo _PMS_SETTINGS_PARAM; ?></b>
	</th>
	<th class="sectiontableheader">
		<b><?php echo _PMS_SETTINGS_VALUE; ?></b>
	</th>
	<th class="sectiontableheader">
		<b><?php echo _PMS_SETTINGS_DESCRIPTION; ?></b>
	</th>
</tr>

<?php
$entry = 0;
if($allow_change_email_new==1)
{
?>

<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
	<td>
		<?php echo _PMS_SETTINGS_EMAIL_NEW; ?>
	</td>
	<td>
		<?php echo mosHTML::yesnoSelectList('email_new', 'class="inputbox"', $email_new); ?>
	</td>
	<td>
		<?php echo _PMS_SETTINGS_EMAIL_NEW_DESCR; ?>
	</td>
</tr>

<?php
}
if($allow_change_email_reply==1)
{
?>

<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
	<td>
		<?php echo _PMS_SETTINGS_EMAIL_REPLY; ?>
	</td>
	<td>
		<?php echo mosHTML::yesnoSelectList('email_reply', 'class="inputbox"', $email_reply); ?>
	</td>
	<td>
		<?php echo _PMS_SETTINGS_EMAIL_REPLY_DESCR; ?>
	</td>
</tr>

<?php
}
if($allow_change_email_html==1)
{
?>

<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
	<td>
		<?php echo _PMS_SETTINGS_EMAIL_FORMAT; ?>
	</td>
	<td>
	<?php
		$email_html_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_EMAIL_FORMAT_TEXT);
		$email_html_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_EMAIL_FORMAT_HTML);
		echo mosHTML::selectList($email_html_arr, 'email_html', 'size="1" class="inputbox"', 'value', 'text', $email_html);
	?>
	</td>
	<td>
		<?php echo _PMS_SETTINGS_EMAIL_FORMAT_DESCR; ?>
	</td>
</tr>

<?php
}
if($allow_change_email_offline==1)
{
?>

<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
	<td>
		<?php echo _PMS_SETTINGS_OFFLINE; ?>
	</td>
	<td>
		<?php echo mosHTML::yesnoSelectList('email_offline', 'class="inputbox"', $email_offline); ?>
	</td>
	<td>
		<?php echo _PMS_SETTINGS_OFFLINE_DESCR; ?>
	</td>
</tr>

<?php
}
if($allow_change_email_sender_address==1)
{
?>

<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
	<td>
		<?php echo _PMS_SETTINGS_EMAIL_SENDER_ADDRESS; ?>
	</td>
	<td>
	<?php
		$email_sender_address_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_EMAIL_SENDER_ADDRESS_GLOBAL);
		$email_sender_address_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_EMAIL_SENDER_ADDRESS_USER);
		echo mosHTML::selectList($email_sender_address_arr, 'email_sender_address', 'size="1" class="inputbox"', 'value', 'text', $email_sender_address);
	?>
	</td>
	<td>
		<?php echo _PMS_SETTINGS_EMAIL_SENDER_ADDRESS_DESCR; ?>
	</td>
</tr>

<?php
}
if($allow_change_format_reply==1)
{
?>

<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
	<td>
		<?php echo _PMS_SETTINGS_REPLY; ?>
	</td>
	<td>
	<?php
		$format_reply_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_REPLY_WITHOUT);
		$format_reply_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_REPLY_WITH);
		$format_reply_arr[] = mosHTML::makeOption(2, _PMS_SETTINGS_REPLY_ITALIC);
		echo mosHTML::selectList($format_reply_arr, 'format_reply', 'size="1" class="inputbox"', 'value', 'text', $format_reply);
	?>
	</td>
	<td>
		<?php echo _PMS_SETTINGS_REPLY_DESCR; ?>
	</td>
</tr>

<?php
}
if($allow_change_clear_sent_items==1)
{
?>

<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
	<td>
		<?php echo _PMS_SETTINGS_CLEAR_SENT_ITEMS; ?>
	</td>
	<td>
	<?php
		$clear_sent_items_arr[] = mosHTML::makeOption(1, _PMS_SETTINGS_CLEAR_SENT_ITEMS_NO);
		$clear_sent_items_arr[] = mosHTML::makeOption(0, _PMS_SETTINGS_CLEAR_SENT_ITEMS_TRASH);
		$clear_sent_items_arr[] = mosHTML::makeOption(-1, _PMS_SETTINGS_CLEAR_SENT_ITEMS_DELETE);
		echo mosHTML::selectList($clear_sent_items_arr, 'clear_sent_items', 'size="1" class="inputbox"', 'value', 'text', $clear_sent_items);
	?>
	</td>
	<td>
		<?php echo _PMS_SETTINGS_CLEAR_SENT_ITEMS_DESCR; ?>
	</td>
</tr>

<?php
}

/*
//check if PMS Notify is installed

if(file_exists(PMS_BASEPATH_COMPONENTS . '/../../modules/mod_pmsnotify.xml'))
{
	if($allow_change_popup==1)
	{
	?>
	<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_POPUP; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList('popup', 'class="inputbox"', $popup); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_POPUP_DESCR; ?>
		</td>
	</tr>

	<?php
	}
	if($allow_change_sound==1)
	{
	?>
	<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_SOUND; ?>
		</td>
		<td>
			<?php echo mosHTML::yesnoSelectList('sound', 'class="inputbox"', $sound); ?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_SOUND_DESCR; ?>
		</td>
	</tr>

	<?php
	}
	if($allow_change_sound_value==1)
	{
	?>
	<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_SOUND_VALUE; ?>
		</td>
		<td>
		<?php
			$handle=opendir(PMS_BASEPATH_COMPONENTS . '/../../modules/mod_pmsnotify/sounds/');
			$i=0;
			while($file = readdir($handle))
			{
				if($file != "." && $file != "..")
				{
					$name = explode(".", $file);
					$sound_value_arr[] = mosHTML::makeOption($i, $name[0]);
					$i++;
				}
			}
			echo mosHTML::selectList($sound_value_arr, 'sound_value', 'size="1" class="inputbox"', 'value', 'text', $sound_value);
		?>
		</td>
		<td>
			<?php echo _PMS_SETTINGS_PMSNOTIFY_SOUND_VALUE_DESCR; ?>
		</td>
	</tr>

	<?php
	}
}
*/

if($allow_change_rows_per_page==1)
{
?>

<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
	<td>
		<?php echo _PMS_SETTINGS_ROWS; ?>
	</td>
	<td>
		<input type="text" name="rows_per_page" class="inputbox" value="<?php echo $rows_per_page; ?>" maxlength="3" />
	</td>
	<td>
		<?php echo _PMS_SETTINGS_ROWS_DESCR; ?>
	</td>
</tr>

<?php
}
if($allow_change_pages_in_list==1)
{
?>

<tr class="sectiontableentry<?php echo ($entry % 2) + 1; $entry++; ?>">
	<td>
		<?php echo _PMS_SETTINGS_PAGES; ?>
	</td>
	<td>
		<input type="text" name="pages_in_list" class="inputbox" value="<?php echo $pages_in_list; ?>" maxlength="2" />
	</td>
	<td>
		<?php echo _PMS_SETTINGS_PAGES_DESCR; ?>
	</td>
</tr>

<?php
}
?>

<tr>
	<td colspan="3" align="center">
		<input type="submit" class="button" name="save" value="<?php echo _PMS_SETTINGS_SAVE; ?>" />
	</td>
</tr>
</table>
</form>

<?php
}
?>