<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

if(!isset($first_load))
{
	define( '_VALID_MOS', 1 );
	define('PMS_BASEPATH_COMPONENTS', dirname(__FILE__));
	define('PMS_BASEPATH_ADMINISTRATOR', dirname(__FILE__).'/../../administrator/components/com_pms');
	require_once("./../../configuration.php");
	require_once("./../../includes/database.php");
	require_once("./../../includes/joomla.php");
	require_once(PMS_BASEPATH_ADMINISTRATOR . '/config.pms.php');
	if(file_exists(PMS_BASEPATH_ADMINISTRATOR . '/language/'.$mosConfig_lang.'.php')) require_once(PMS_BASEPATH_ADMINISTRATOR . '/language/'.$mosConfig_lang.'.php');
	else require_once(PMS_BASEPATH_ADMINISTRATOR . '/language/english.php');
	if(file_exists("./../../language/".$mosConfig_lang.".php")) require_once("./../../language/".$mosConfig_lang.".php");
	else require_once("./../../language/english.php");
	
	$database = new database($mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix);
	$my_id = intval(mosGetParam($_GET, 'my_id'));
	$session_id = mosGetParam($_GET, 'session_id', -1);
	if($session_id=="") $session_id = -1;
	if($userlist==0 OR $userlist==2) $order = "ORDER BY t1.username";
	if($userlist==1 OR $userlist==3) $order = "ORDER BY t1.name";
}

$database->setQuery("SELECT session_id FROM #__session WHERE userid=$my_id LIMIT 1");
$session_id_table = $database->loadResult();
if($session_id!=$session_id_table) die('Direct Access to this location is not allowed.');
else
{
	mosGetParam($_GET, 'filter') ? $filter = $database->getEscaped(mosGetParam($_GET, 'filter')) : $filter = _PMS_ADDRESSBOOK_FILTER_ALL;
	$alphabet = array(_PMS_ADDRESSBOOK_FILTER_ALL, "0-9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z");

	$database->setQuery("SELECT session_id FROM #__session WHERE userid=$my_id LIMIT 1");
	$session_id = $database->loadResult();
	$filter_site_users = "<select class=\"inputbox\" name=\"filter_site_users\" size=\"1\" onChange=\"pms_ajax_user_list_filter(".$my_id.",'".$session_id."')\">";
	foreach($alphabet as $character)
	{
		$filter_site_users .= '<option value="'.$character.'"';
		if($filter==$character) $filter_site_users .= ' selected';
		$filter_site_users .= '>'.$character.'</option>';
	}
	$filter_site_users .= '</select>';

	if($userlist==0 OR $userlist==2)
	{
		if($filter==_PMS_ADDRESSBOOK_FILTER_ALL) $where_filter = "AND t1.username LIKE '%'";
		elseif($filter=="0-9") $where_filter="AND (t1.username LIKE '0%' OR t1.username LIKE '1%' OR t1.username LIKE '2%' OR t1.username LIKE '3%' OR t1.username LIKE '4%' OR t1.username LIKE '5%' OR t1.username LIKE '6%' OR t1.username LIKE '7%' OR t1.username LIKE '8%' OR t1.username LIKE '9%')";
		else $where_filter = "AND t1.username LIKE '$filter%'";
	}
	if($userlist==1 OR $userlist==3)
	{
		if($filter==_PMS_ADDRESSBOOK_FILTER_ALL) $where_filter = "AND t1.name LIKE '%'";
		elseif($filter=="0-9") $where_filter = "AND (t1.name LIKE '0%' OR t1.name LIKE '1%' OR t1.name LIKE '2%' OR t1.name LIKE '3%' OR t1.name LIKE '4%' OR t1.name LIKE '5%' OR t1.name LIKE '6%' OR t1.name LIKE '7%' OR t1.name LIKE '8%' OR t1.name LIKE '9%')";
		else $where_filter = "AND t1.name LIKE '$filter%'";
	}

	if($cb_version>0) $query = "SELECT t1.id, t1.username, t1.name FROM #__users AS t1, #__comprofiler AS t2 WHERE t1.block!=1 AND t2.approved=1 AND t2.confirmed=1 AND t2.banned=0 AND t1.id!=$my_id AND t1.id=t2.user_id AND t1.gid IN (".$usergroupids.") $where_filter $order";
	else $query = "SELECT t1.id, t1.username, t1.name FROM #__users AS t1 WHERE t1.block!=1 AND t1.id!=$my_id AND t1.gid IN (".$usergroupids.") $where_filter $order";

	$database->setQuery($query);
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$rows = $database->loadObjectList();

	$site_users = "<select class=\"inputbox\" name=\"site_users\" size=\"".$height_userlists."\">";
	if(count($rows)==0) $site_users .= '<option value="no_entry">'._PMS_ADDRESSBOOK_NO_ENTRY.'</option>';
	else
	{
		foreach($rows AS $row)
		{
			$site_users .= '<option value="'.$row->id.'">';
			if($userlist==0) $site_users .= htmlentities($row->username);
			if($userlist==1) $site_users .= htmlentities($row->name);
			if($userlist==2) $site_users .= htmlentities($row->username.' ('.$row->name.')');
			if($userlist==3) $site_users .= htmlentities($row->name.' ('.$row->username.')');
			$site_users .= '</option>';
		}
	}
	$site_users .= "</select>";

	$list_site_users = '
	<table border="0" cellspacing="0" cellpadding="0">
	<tr>
		<td colspan="2">'.$site_users.'</td>
	</tr>
	<tr>
		<td>'._PMS_ADDRESSBOOK_FILTER.'</td>
		<td align="right" style="text-align: right;">'.$filter_site_users.'</td>
	</tr>
	</table>';
	echo $list_site_users;
}
?>