<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$mainframe->appendPathWay(_PMS_WRITE);
$recip_id = "";
$recip_name = "";
$subject = "";
if($page=="new")
{
	if(mosGetParam($_GET, 'id'))
	{
		$recip_id = mosGetParam($_GET, 'id');
		$recip_id = $database->getEscaped($recip_id);
		
		// for compatibility reasons
		$database->setQuery("SELECT count(id) FROM #__users WHERE username='$recip_id'");
		$result = $database->loadResult();
		if($result==1)
		{
			
			$database->setQuery("SELECT id FROM #__users WHERE username='$recip_id' LIMIT 1");
			$recip_id = $database->loadResult();
		}
		
	}
	if(mosGetParam($_GET, 'title')) $subject = mosGetParam($_GET, 'title');
}

?>
<style type="text/css">
ul#pms_write_recip
{
	margin: 0px;
	padding: 0px;
}
ul#pms_write_recip li
{
	list-style: none;
	display: inline;
	float: left;
	margin: 0px 5px;
}
ul#pms_write_recip li.pms_write_recipfield
{
	width: <?php echo $width_recipfield; ?>px;
}
ul#pms_write_recip a
{
	cursor: pointer;
}
</style>
<table width="100%" cellpadding="0" cellspacing="0" border="0" align="center" class="contentpane">
<tr>
	<td colspan="2">
		<span class="contentheading">
			<?php echo _PMS_TITLE; ?>:&nbsp;<?php echo _PMS_WRITE; ?>
		</span>
	</td>
</tr>
</table>

<?php

if($pm_all >= $max_allowed_pm AND $max_allowed_pm > 0) echo _PMS_NEW_WARNING;
else
{
	if(mosGetParam($_REQUEST, 'sent'))
	{
		$recip_names_post = array();
		$recip_names_ltrim = array();
		$recip_names_post = explode(",", mosGetParam($_POST, 'recip_users'));
		foreach($recip_names_post AS $recip_name_tmp) $recip_names_ltrim[] = ltrim($recip_name_tmp);
		$recip_names = implode("','", $recip_names_ltrim);
		$recip_names = $database->getEscaped($recip_names);
		if($userlist==0 OR $userlist==2) $query = "SELECT id FROM #__users WHERE username IN ('".$recip_names."')";
		elseif($userlist==1 OR $userlist==3) $query = "SELECT id FROM #__users WHERE name IN ('".$recip_names."')";
		$database->setQuery($query);
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$recip_ids = $database->loadResultArray();
		if($max_entries_reciplist>0) $recip_ids = array_slice($recip_ids, 0, $max_entries_reciplist);
		$pm_id = intval(mosGetParam($_REQUEST, 'id'));
		$sender_id = intval(mosGetParam($_REQUEST, 'sender_id'));
		$readstate_original = intval(mosGetParam($_REQUEST, 'readstate_original'));
		$readstate_new = intval(mosGetParam($_REQUEST, 'readstate_new'));
		$subject = $database->getEscaped(mosGetParam($_REQUEST, 'subject'));
		$message = $database->getEscaped(mosGetParam($_REQUEST, 'message'));
		$time = date('H:i:s', time() + $mosConfig_offset*3600);
		$date = date('Y-m-d', time() + $mosConfig_offset*3600);
		if(!ereg("[^\x01-\x20]", $subject)) $subject = _PMS_NO_SUBJECT;
		if(!get_magic_quotes_gpc())
		{
			$message = stripcslashes(strip_tags(addslashes($message)));
			$subject = stripcslashes(strip_tags(addslashes($subject)));
		}
		else
		{
			$message = stripcslashes(strip_tags($message));
			$subject = stripcslashes(strip_tags($subject));
		}
		$recip_count = 0;
		$error_sent_count = 0;
		
		// make loop for all recips
		foreach($recip_ids as $recip_id)
		{
			$recip_count++;
			$recip_id = intval($recip_id);
			
			// check if recip is member of allowed groups, not banned/blocked and also not the sender self
			if($cb_version>0)
			{
				$query = "SELECT count(t1.id) FROM #__users AS t1, #__comprofiler AS t2 WHERE t1.id!=$my_id AND t1.id=$recip_id AND t1.gid IN (".$usergroupids.") AND t1.block=0 AND t2.approved=1 AND t2.confirmed=1 AND t2.banned=0 AND t1.id=t2.user_id LIMIT 1";
			}
			else
			{
				$query = "SELECT count(id) FROM #__users WHERE id!=$my_id AND id=$recip_id AND gid IN (".$usergroupids.") AND block=0 LIMIT 1";
			}
			$database->setQuery($query);
			
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$result = $database->loadResult();
			if($result==0) $error_sent_count++;
			else
			{
				// check if sender is in ignorelist of recip
				$query = "SELECT ignore_ids FROM #__pms_ignorelist WHERE my_id=$recip_id LIMIT 1";
				$database->setQuery($query);
				if(!$database->query()) pms_sql_error($database->getErrorMsg());
				$result = $database->loadResult();
				$ignore_ids = explode(",", str_replace("|", "", $result));
				if(in_array($my_id, $ignore_ids)) $error_sent_count++;
				else
				{
					// check how many PMs recip already has
					$database->setQuery("SELECT count(id) FROM #__pms WHERE (recip_id=$recip_id AND inbox!=-1) OR (sender_id=$recip_id AND sent_items!=-1)");
					if(!$database->query()) pms_sql_error($database->getErrorMsg());
					$result = $database->loadResult();
					if($result >= $max_allowed_pm AND $max_allowed_pm > 0) $error_sent_count++;
					else
					{
						// insert PM into db
						$database->setQuery("INSERT INTO #__pms (recip_id,sender_id,date,time,readstate,subject,message) VALUES ('$recip_id','$sender_id','$date','$time','$readstate_new','$subject','$message')");
						if(!$database->query())
						{
							pms_sql_error($database->getErrorMsg());
							$error_sent_count++;
						}
						
						// change readstate of original PM when reply or forward
						if($page=="reply" OR $page=="forward")
						{
							echo $readstate_original;
							if((($readstate_original==1 OR $readstate_original==3) AND $page=="reply") OR (($readstate_original==1 OR $readstate_original==5) AND $page=="forward")) $readstate = $readstate_new + 1;
							else $readstate = 7;
							$database->setQuery("UPDATE #__pms SET readstate=$readstate WHERE id=$pm_id");
							if(!$database->query()) pms_sql_error($database->getErrorMsg());
						}

						// get name and email of recip
						$database->setQuery("SELECT username, email FROM #__users WHERE id=$recip_id");
						if(!$database->query()) pms_sql_error($database->getErrorMsg());
						$rows = $database->loadObjectList();
						$row = $rows[0];
						$recip_name = $row->username;
						$recip_email = $row->email;

						// check settings of recip if necessary
						if((($page=="new" OR $page=="forward") AND $allow_change_email_new==1) OR ($page=="reply" AND $allow_change_email_reply==1))
						{
							// check if recip has personal settings, otherwise use defaults
							$database->setQuery("SELECT count(id) FROM #__pms_conf WHERE user_id=$recip_id LIMIT 1");
							if(!$database->query()) pms_sql_error($database->getErrorMsg());
							$result = $database->loadResult();
							if($result==1)
							{
								$database->setQuery("SELECT email_new, email_reply, email_html, email_offline FROM #__pms_conf WHERE user_id=$recip_id");
								if(!$database->query()) pms_sql_error($database->getErrorMsg());
								$rows = $database->loadObjectList();
								$row = $rows[0];
								if($allow_change_email_new==1) $email_new = $row->email_new;
								if($allow_change_email_reply==1) $email_reply = $row->email_reply;
								if($allow_change_email_html==1) $email_html = $row->email_html;
								if($allow_change_email_offline==1) $email_offline = $row->email_offline;
							}
						}

						// send email notification
						if((($page=="new" OR $page=="forward") AND $email_new==1) OR ($page=="reply" AND $email_reply==1))
						{
							// check if recip is offline
							$database->setQuery("SELECT count(session_id) FROM #__session WHERE userid=$recip_id");
							if(!$database->query()) pms_sql_error($database->getErrorMsg());
							$result = $database->loadResult();
							if($result==0 OR $email_offline==0)
							{
								$email_site_name = $mosConfig_sitename;
								$email_sender_name = $my->username;
								if($email_sender_address==1)
								{
									$database->setQuery("SELECT email FROM #__users WHERE id=$sender_id LIMIT 1");
									if(!$database->query()) pms_sql_error($database->getErrorMsg());
									$email_sender_email = $database->loadResult();
								}
								else $email_sender_email = $mosConfig_mailfrom;
								$email_recip_name = $recip_name;
								$email_recip_email = $recip_email;
								$message = stripslashes($message);
								$subject = stripslashes($subject);
								if($email_html==1) $message = nl2br($message);
								switch($page)
								{
									case "new":
									$email_subject = sprintf(_PMS_EMAIL_SUBJECT_NEW, $email_site_name, $email_sender_name);
									if($email_html==0) $email_message = sprintf(_PMS_EMAIL_MESSAGE_NEW_TEXT, $email_recip_name, $email_sender_name, $email_site_name, $subject, $message, $email_site_name);
									else $email_message = sprintf(_PMS_EMAIL_MESSAGE_NEW_HTML, $email_recip_name, $email_sender_name, $email_site_name, $subject, $message, $email_site_name);
									break;

									case "reply":
									$email_subject = sprintf(_PMS_EMAIL_SUBJECT_REPLY, $email_site_name, $email_sender_name);
									if($email_html==0) $email_message = sprintf(_PMS_EMAIL_MESSAGE_REPLY_TEXT, $email_recip_name, $email_sender_name, $email_site_name, $subject, $message, $email_site_name);
									else $email_message = sprintf(_PMS_EMAIL_MESSAGE_REPLY_HTML, $email_recip_name, $email_sender_name, $email_site_name, $subject, $message, $email_site_name);
									break;

									case "forward":
									$email_subject = sprintf(_PMS_EMAIL_SUBJECT_NEW, $email_site_name, $email_sender_name);
									if($email_html==0) $email_message = sprintf(_PMS_EMAIL_MESSAGE_NEW_TEXT, $email_recip_name, $email_sender_name, $email_site_name, $subject, $message, $email_site_name);
									else $email_message = sprintf(_PMS_EMAIL_MESSAGE_NEW_HTML, $email_recip_name, $email_sender_name, $email_site_name, $subject, $message, $email_site_name);
									break;
								}
								if(function_exists(mosMail)) mosMail($email_sender_email, $email_sender_name, $email_recip_email, $email_subject, $email_message, $email_html);
								else
								{
									$head = "MIME-Version: 1.0\r\n";
					            	if($email_html==0) $head .= "Content-Type: text/plain;"._ISO. "\r\n";
					            	else $head .= "Content-Type: text/html;"._ISO. "\r\n";
					            	$head .= "From: $email_sender_name <$email_sender_email>\r\n";
									$head .= "Reply-To: $email_sender_name <$email_sender_email>\r\n";
									$head .= "X-Priority: 3\r\n"; 
									$head .= "X-MSMail-Priority: Normal\r\n";
									$head .= "X-Mailer: Mambo Joomla\r\n";
									mail($email_recip_email, $email_subject, $email_message, $head);
								}
							} // check if recip is offline
						} // send email notification
					} // check how many PMs recip already has
				} // check if sender is in ignorelist of recip
			} // check if recip is member of allowed groups
		} // make loop for all recips
		
		if($error_sent_count==0 AND $recip_count>0)
		{
			if($recip_count==1) $mosmsg = _PMS_MSG_SENT;
			else $mosmsg = _PMS_MSG_SENT_MULTIPLE;
		}
		elseif($recip_count>0)
		{
			if($recip_count==1) $mosmsg = _PMS_MSG_SENT_ERROR;
			else $mosmsg = sprintf(_PMS_MSG_SENT_ERROR_MULTIPLE, $error_sent_count, $recip_count);
		}
		else
		{
			$mosmsg = _PMS_MSG_SENT_ERROR_INVALID_USER;
		}
		mosRedirect('index.php?option=com_pms&Itemid='.$pms_menuid.'&page=inbox&mosmsg='.$mosmsg);
	}
?>

	<form name="pmsForm" method="post" action="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=<?php echo $page; ?>" onSubmit="return pms_write_validate('<?php echo _PMS_WRITE_NO_RECIP; ?>', '<?php echo _PMS_WRITE_NO_MSG; ?>')">
	<table cellspacing="1" cellpadding="4" border="0" class="contentpane" align="center" width="100%">
	<tr>
		<th colspan="2" class="sectiontableheader">
			<b>
			<?php
			if($page=="new") echo _PMS_WRITE_NEW;
			if($page=="reply") echo _PMS_WRITE_REPLY;
			if($page=="forward") echo _PMS_WRITE_FORWARD;
			?>
			</b>
		</th>
	</tr>
	
<?php
	$readstate_new = 0;
	if($page=="reply" OR $page=="forward")
	{
		$pm_id = mosGetParam($_GET, 'id');
		$database->setQuery("SELECT t1.readstate, t1.subject, t1.message, t2.id, t2.username, t2.name FROM #__pms AS t1, #__users AS t2 WHERE t1.id=$pm_id AND t1.sender_id=t2.id");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$result=$database->query();
		$row = mysql_fetch_assoc($result);
		$subject = $row['subject'];
		$message = $row['message'];
		$username = $row['username'];
		$name = $row['name'];
		$readstate_original = $row['readstate'];
	}
	if($page=="reply") $readstate_new = 2;
	if($page=="forward") $readstate_new = 4;
?>

	<tr class="sectiontableentry1">
		<td valign="top">
			<b><?php echo _PMS_RECIP; ?>:</b>
		</td>
		<td width="100%">
			<ul id="pms_write_recip">
				<li class="pms_write_recipfield">
					<input name="recip_users" class="inputbox"
					<?php
						if($page=="new" AND $recip_id!="")
						{
							if($userlist==0 OR $userlist==2) $query = "SELECT username FROM #__users WHERE id=".$recip_id." LIMIT 1";
							if($userlist==1 OR $userlist==3) $query = "SELECT name FROM #__users WHERE id=".$recip_id." LIMIT 1";
							$database->setQuery($query);
							if(!$database->query()) pms_sql_error($database->getErrorMsg());
							$recip_name = $database->loadResult();
							echo 'value="'.$recip_name.'"';
						}
						if($page=="reply")
						{
							($userlist==0 OR $userlist==2) ? $recip_name = $username : $recip_name = $name;
							echo 'value="'.$recip_name.'"';
						}
					?>
					style="width:<?php echo $width_recipfield; ?>px;"
					<?php
						if($usersearch==1) echo "onkeyup=\"pms_ajax_user_search(".$my_id.",'".$session_id."')\" onfocus=\"pms_ajax_user_search(".$my_id.",'".$session_id."')\"";
					?>
					 /><br />
					<div id="pms_usersearch" style="position:absolute; display:none;"></div>
					<span class="small">
					<?php
						echo _PMS_RECIPS_DESCR;
						if($max_entries_reciplist>0) echo sprintf(_PMS_MAX_RECIPS, $max_entries_reciplist);
					?>
					</span>
				</li>
				<li>
					<?php
					if($addressbook==1)
					{
					?>
					<a onclick="pms_write_show_userlist_addressbook('buddy_users')"><img src="components/com_pms/images/addressbooklist.png" border="0" alt="<?php echo _PMS_ADDRESSBOOK_LIST; ?>" title="<?php echo _PMS_ADDRESSBOOK_LIST; ?>" /></a><br />
					<?php
					}
					?>
					<a onclick="pms_write_show_userlist_addressbook('site_users')"><img src="components/com_pms/images/userlist.png" border="0" alt="<?php echo _PMS_ADDRESSBOOK_ALL_USERS; ?>" title="<?php echo _PMS_ADDRESSBOOK_ALL_USERS; ?>" /></a><br /><br />
					<div id="write_add_button_site_users" style="display: none;">
					<input type="button" class="button" value="<?php echo _PMS_ADDRESSBOOK_ADD; ?>" onclick="pms_write_add_recip('site_users','')" />
					</div>
					<div id="write_add_button_buddy_users" style="display: none;">
					<input type="button" class="button" value="<?php echo _PMS_ADDRESSBOOK_ADD; ?>" onclick="pms_write_add_recip('buddy_users','')" />
					</div>
				</li>
				<li class="pms_write_userlists" onclick="pms_ajax_user_search_hide()">
					<div id="list_buddy_users" style="display: none;">
					<?php include_once(PMS_BASEPATH_COMPONENTS . '/addressbooklist.php'); ?>
					</div>
				</li>
				<li class="pms_write_userlists" onclick="pms_ajax_user_search_hide()">
					<div id="list_site_users" style="display: none;">
					<?php $first_load=true; include_once(PMS_BASEPATH_COMPONENTS . '/userlist.php'); ?>
					</div>
				</li>
			</ul>
		</td>
	</tr>
	<tr class="sectiontableentry2">
		<td valign="top">
			<b><?php echo _PMS_SUBJECT; ?>:</b>
		</td>
		<td>
			<input type="text" class="inputbox" name="subject" style="width:<?php echo $width_messagefields; ?>px;" onfocus="pms_ajax_user_search_hide()"
			<?php
			if($page=="new") echo 'value="'.$subject.'"';
			if($page=="reply") echo 'value="'.pms_prefix($subject, _PMS_REPLY_PREFIX).'"';
			if($page=="forward") echo 'value="'.pms_prefix($subject, _PMS_FORWARD_PREFIX).'"';
			if($max_length_subject>0)
			{
			?>
			onkeyup="pms_write_refresh_character_counter('pmsForm','subject')"
			onmouseup="pms_write_refresh_character_counter('pmsForm','subject')"
			onchange="pms_write_refresh_character_counter('pmsForm','subject')" /><br />
			<span class="small"><span id="count_subject"><?php echo $max_length_subject; ?></span><?php echo _PMS_REMAINING_CHARACTERS; ?></span>
			<?php
			}
			else echo " />";
			?>
		</td>
	</tr>
	<tr class="sectiontableentry1">
		<td valign="top">
			<b><?php echo _PMS_MESSAGE; ?>:</b>
		</td>
		<td>
			<table cellspacing="0" cellpadding="0" border="0">
			<tr>
				<td colspan="2">
					<?php
					if($bb_code==1)
					{
						$form = "pmsForm";
						$field = "message";
						include_once(PMS_BASEPATH_COMPONENTS . '/bb_code.php');
					}
					?>
				</td>
			</tr>
			<tr>
				<td valign="top">
					<textarea name="message" class="inputbox" style="width:<?php echo $width_messagefields; ?>px; height:<?php echo $height_messagefield; ?>px" onfocus="pms_ajax_user_search_hide()"
					<?php
					if($max_length_message>0){
					?>
					onkeyup="pms_write_refresh_character_counter('pmsForm','message')"
					onmouseup="pms_write_refresh_character_counter('pmsForm','message')"
					onchange="pms_write_refresh_character_counter('pmsForm','message')"><?php
					}
					else echo ">";
					if($page=="reply")
					{
						if($format_reply==1) echo _PMS_WRITE_PREFIX.stripslashes($message);
						if($format_reply==2) echo _PMS_WRITE_PREFIX.'[i]'.stripslashes(str_replace("[i]", "", str_replace("[/i]", "",$message))).'[/i]';
					}
					if($page=="forward") echo _PMS_WRITE_PREFIX.stripslashes($message);
					?></textarea><?php
					if($max_length_message>0){
					?><br />
					<span class="small"><span id="count_message"><?php echo $max_length_message; ?></span><?php echo _PMS_REMAINING_CHARACTERS; ?></span>
					<?php
					}
					?>
				</td>
				<td valign="top">
					<?php
					if($smiley==1)
					{
						$form = "pmsForm";
						$field = "message";
						include_once(PMS_BASEPATH_COMPONENTS . '/smiley.php');
					}
					?>
				</td>
			</tr>
			</table>
			<input type="submit" class="button" name="sent" value="<?php echo _PMS_SEND; ?>" />
		</td>
	</tr>
	</table>
	<input type="hidden" name="id" value="<?php echo $pm_id; ?>" />
	<input type="hidden" name="readstate_original" value="<?php echo $readstate_original; ?>" />
	<input type="hidden" name="readstate_new" value="<?php echo $readstate_new; ?>" />
	<input type="hidden" name="max_length_subject" value="<?php echo $max_length_subject; ?>" />
	<input type="hidden" name="max_length_message" value="<?php echo $max_length_message; ?>" />
	<input type="hidden" name="sender_id" value="<?php echo $my_id; ?>" />
	</form>
<?php
}
?>