<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$mainframe->appendPathWay(_PMS_ADDRESSBOOK);
?>

<table width="100%" cellpadding="0" cellspacing="0" border="0" align="center" class="contentpane">
<tr>
	<td colspan="2">
		<span class="contentheading"><?php echo _PMS_TITLE; ?>:&nbsp;<?php echo _PMS_ADDRESSBOOK; ?></span>
	</td>
</tr>
</table>

<?php
if($addressbook==0) echo _PMS_ADDRESSBOOK_DISABLED;
else
{
	if(mosGetParam($_POST, 'save'))
	{
		$buddy_ids = mosGetParam($_POST, 'buddy_ids');
		$buddy_ids = $database->getEscaped($buddy_ids);
		
		// check if user already has an entry in addressbook-table -> update or insert
		$database->setQuery("SELECT count(id) FROM #__pms_addressbook WHERE my_id=$my_id");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$count = $database->loadResult();
		if($count==1) $query = "UPDATE #__pms_addressbook SET buddy_ids='$buddy_ids' WHERE my_id=$my_id";
		else $query = "INSERT INTO #__pms_addressbook (my_id, buddy_ids) VALUES ($my_id, '$buddy_ids')";
		$database->setQuery($query);
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			$mosmsg = _PMS_MSG_SAVE_ADDRESSBOOK_ERROR;
		}
		else $mosmsg = _PMS_MSG_SAVE_ADDRESSBOOK;
		mosRedirect('index.php?option=com_pms&Itemid='.$pms_menuid.'&page=addressbook&mosmsg='.$mosmsg);
	}
	$import = mosGetParam($_GET, 'import');
	if($import AND $import==1)
	{
		$import_error = false;
		
		// import buddies from standard CB version
		if($cb_version==1)
		{
			$database->setQuery("SELECT count(referenceid) FROM #__comprofiler_members WHERE referenceid=$my_id LIMIT 1");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$count_buddy_all = $database->loadResult();
			$database->setQuery("SELECT count(t1.referenceid) FROM #__comprofiler_members AS t1, #__users AS t2 WHERE t1.referenceid=$my_id AND t1.memberid=t2.id AND t2.gid IN (".$usergroupids.") LIMIT 1");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$count_buddy_restricted = $database->loadResult();
			$database->setQuery("SELECT t1.memberid FROM #__comprofiler_members AS t1, #__users AS t2 WHERE t1.referenceid=$my_id AND t1.memberid=t2.id AND t2.gid IN (".$usergroupids.")");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$result = $database->loadResultArray();
			$buddy_ids_cb = "|".implode("|,|", $result)."|";
			
			if($count_buddy_restricted>0)
			{
				// check if user already has an entry in addressbook-table -> update or insert
				$database->setQuery("SELECT count(id) FROM #__pms_addressbook WHERE my_id=$my_id LIMIT 1");
				if(!$database->query()) pms_sql_error($database->getErrorMsg());
				$result = $database->loadResult();
				if($result==1)
				{
					$database->setQuery("SELECT buddy_ids FROM #__pms_addressbook WHERE my_id=$my_id LIMIT 1");
					if(!$database->query()) pms_sql_error($database->getErrorMsg());
					$buddy_ids_pms = $database->loadResult();
					if($buddy_ids_pms!="")
					{
						$buddy_ids_update = $buddy_ids_pms.",".$buddy_ids_cb;
						
						// delete double entries
						$tmp = explode(",", str_replace("|", "", $buddy_ids_update));
						$tmp = array_unique($tmp);
						$buddy_ids_update = "|".implode("|,|", $tmp)."|";
					}
					else $buddy_ids_update = $buddy_ids_cb;
					$query = "UPDATE #__pms_addressbook SET buddy_ids='$buddy_ids_update' WHERE my_id=$my_id";
				}
				else $query = "INSERT INTO #__pms_addressbook (my_id, buddy_ids) VALUES ($my_id, '$buddy_ids_cb')";
				$database->setQuery($query);
				if(!$database->query())
				{
					pms_sql_error($database->getErrorMsg());
					$import_error = true;
				}
			}
		}
		
		// import buddies from CBE version
		if($cb_version==2)
		{
			$database->setQuery("SELECT count(id) FROM #__comprofiler_buddylist WHERE userid=$my_id OR buddyid=$my_id LIMIT 1");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$count_buddy_all = $database->loadResult();
			$database->setQuery("SELECT count(t1.id) FROM #__comprofiler_buddylist AS t1, #__users AS t2 WHERE (t1.userid=$my_id AND t1.buddyid=t2.id AND t2.gid IN (".$usergroupids.")) OR (t1.buddyid=$my_id AND t1.userid=t2.id AND t2.gid IN (".$usergroupids.")) LIMIT 1");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$count_buddy_restricted = $database->loadResult();
			$database->setQuery("SELECT t2.id FROM #__comprofiler_buddylist AS t1, #__users AS t2 WHERE ((t1.userid=$my_id AND t1.buddyid=t2.id AND t2.gid IN (".$usergroupids.")) OR (t1.userid=t2.id AND t1.buddyid=$my_id AND t2.gid IN (".$usergroupids."))) AND buddy=1");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$result = $database->loadResultArray();
			$buddy_ids_cbe = "|".implode("|,|", $result)."|";
			
			if($count_buddy_restricted>0)
			{
				// check if user already has an entry in addressbook-table -> update or insert
				$database->setQuery("SELECT count(id) FROM #__pms_addressbook WHERE my_id=$my_id LIMIT 1");
				if(!$database->query()) pms_sql_error($database->getErrorMsg());
				$result = $database->loadResult();
				if($result==1)
				{
					$database->setQuery("SELECT buddy_ids FROM #__pms_addressbook WHERE my_id=$my_id LIMIT 1");
					if(!$database->query()) pms_sql_error($database->getErrorMsg());
					$buddy_ids_pms = $database->loadResult();
					if($buddy_ids_pms!="")
					{
						$buddy_ids_update = $buddy_ids_pms.",".$buddy_ids_cbe;
						
						// delete double entries
						$tmp = explode(",", str_replace("|", "", $buddy_ids_update));
						$tmp = array_unique($tmp);
						$buddy_ids_update = "|".implode("|,|", $tmp)."|";
					}
					else $buddy_ids_update = $buddy_ids_cbe;
					$query = "UPDATE #__pms_addressbook SET buddy_ids='$buddy_ids_update' WHERE my_id=$my_id";
				}
				else $query = "INSERT INTO #__pms_addressbook (my_id, buddy_ids) VALUES ($my_id, '$buddy_ids_cbe')";
				$database->setQuery($query);
				if(!$database->query())
				{
					pms_sql_error($database->getErrorMsg());
					$import_error = true;
				}
			}
		}
		if($import_error) $mosmsg = _PMS_MSG_ADDRESSBOOK_IMPORT_ERROR;
		elseif($count_buddy_all==0) $mosmsg = _PMS_MSG_ADDRESSBOOK_IMPORT_NO_BUDDY;
		elseif($count_buddy_restricted==0) $mosmsg = _PMS_MSG_ADDRESSBOOK_IMPORT_NONE;
		elseif($count_buddy_all>$count_buddy_restricted) $mosmsg = _PMS_MSG_ADDRESSBOOK_IMPORT_SOME;
		elseif($count_buddy_all==$count_buddy_restricted) $mosmsg = _PMS_MSG_ADDRESSBOOK_IMPORT_ALL;
		mosRedirect('index.php?option=com_pms&Itemid='.$pms_menuid.'&page=addressbook&mosmsg='.$mosmsg);
	}
?>
	<form name="pmsForm" method="post" action="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=addressbook">
	<table border="0" cellspacing="1" cellpadding="4" class="contentpane">
	<tr>
		<th class="sectiontableheader" width="50%">
			<b><?php echo _PMS_ADDRESSBOOK_LIST; ?></b>
			</th>
		<th class="sectiontableheader">
		</th>
		<th class="sectiontableheader" width="50%">
			<b><?php echo _PMS_ADDRESSBOOK_ALL_USERS; ?></b>
		</th>
	</tr>
	<tr>
		<td align="center">
			<table border="0" cellspacing="5" cellpadding="0">
			<tr>
				<td>
					<?php include_once(PMS_BASEPATH_COMPONENTS . '/addressbooklist.php'); ?>
					<input type="hidden" name="no_entry" value="<?php echo _PMS_ADDRESSBOOK_NO_ENTRY; ?>" />
				</td>
			</tr>
			<tr>
				<td>
					<input type="submit" class="button" name="save" value="<?php echo _PMS_ADDRESSBOOK_SAVE; ?>" />
				</td>
			</tr>
			</table>
		</td>
		<td valign="middle">
			<table>
			<tr>
				<td align="center">
					<input type="button" class="button" value="<?php echo _PMS_ADDRESSBOOK_ADD; ?>" onClick="pms_addressbook_ignorelist_add_user('buddy')" />
				</td>
			</tr>
			<tr>
				<td align="center">
					<input type="button" class="button" value="<?php echo _PMS_ADDRESSBOOK_REMOVE; ?>" onClick="pms_addressbook_ignorelist_remove_user('buddy')" />
				</td>
			</tr>
			</table>
		</td>
		<td align="center">
			<div id="list_site_users">
				<?php $first_load = true; include_once(PMS_BASEPATH_COMPONENTS . '/userlist.php'); ?>
			</div>
		</td>
	</tr>
	</table>
	<?php
	if($cb_version>0)
	{
		echo sprintf(_PMS_ADDRESSBOOK_IMPORT, "index.php?option=com_pms&Itemid=".$pms_menuid."&page=addressbook&import=1");
	}
	?>
	<input type="hidden" name="buddy_ids" value="<?php echo $buddy_ids_string; ?>" />
	</form>
<?php
}
?>