<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$mainframe->appendPathWay(_PMS_IGNORELIST);
?>

<table width="100%" cellpadding="0" cellspacing="0" border="0" align="center" class="contentpane">
<tr>
	<td colspan="2">
		<span class="contentheading">
			<?php echo _PMS_TITLE; ?>:&nbsp;<?php echo _PMS_IGNORELIST; ?>
		</span>
	</td>
</tr>
</table>

<?php
if($ignorelist==0) echo _PMS_IGNORELIST_DISABLED;
else
{
	if(mosGetParam($_POST, 'save'))
	{
		$ignore_ids = mosGetParam($_POST, 'ignore_ids');
		$ignore_ids = $database->getEscaped($ignore_ids);
		
		// check if user already has an entry in ignorelist-table -> update or insert
		$database->setQuery("SELECT count(id) FROM #__pms_ignorelist WHERE my_id=$my_id");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$count = $database->loadResult();
		if($count==1) $query = "UPDATE #__pms_ignorelist SET ignore_ids='$ignore_ids' WHERE my_id=$my_id";
		else $query = "INSERT INTO #__pms_ignorelist (my_id, ignore_ids) VALUES ($my_id, '$ignore_ids')";
		$database->setQuery($query);
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			$mosmsg = _PMS_MSG_SAVE_IGNORELIST_ERROR;
		}
		else $mosmsg = _PMS_MSG_SAVE_IGNORELIST;
		mosRedirect('index.php?option=com_pms&Itemid='.$pms_menuid.'&page=ignore&mosmsg='.$mosmsg);
	}
?>
	<form name="pmsForm" method="post" action="index.php?option=com_pms&Itemid=<?php echo $pms_menuid; ?>&page=ignore">
	<table border="0" cellspacing="1" cellpadding="4" class="contentpane">
	<tr>
		<th class="sectiontableheader" width="50%">
			<b><?php echo _PMS_IGNORELIST; ?></b>
		</th>
		<th class="sectiontableheader">
		</th>
		<th class="sectiontableheader" width="50%">
			<b><?php echo _PMS_ADDRESSBOOK_ALL_USERS; ?></b>
		</th>
	</tr>
	<tr>
		<td align="center">
			<table border="0" cellspacing="5" cellpadding="0">
			<tr>
				<td>
					<?php include_once(PMS_BASEPATH_COMPONENTS . '/ignorelist.php'); ?>
					<input type="hidden" name="no_entry" value="<?php echo _PMS_ADDRESSBOOK_NO_ENTRY; ?>" />
				</td>
			</tr>
			<tr>
				<td>
					<input type="submit" class="button" name="save" value="<?php echo _PMS_IGNORELIST_SAVE; ?>" />
				</td>
			</tr>
			</table>
		</td>
		<td valign="middle">
			<table>
			<tr>
				<td align="center">
					<input type="button" class="button" value="<?php echo _PMS_ADDRESSBOOK_ADD; ?>" onClick="pms_addressbook_ignorelist_add_user('ignore')" />
				</td>
			</tr>
			<tr>
				<td align="center">
					<input type="button" class="button" value="<?php echo _PMS_ADDRESSBOOK_REMOVE; ?>" onClick="pms_addressbook_ignorelist_remove_user('ignore')" />
				</td>
			</tr>
			</table>
		</td>
		<td align="center">
			<div id="list_site_users">
				<?php $first_load=true; include_once(PMS_BASEPATH_COMPONENTS . '/userlist.php'); ?>
			</div>
		</td>
	</tr>
	</table>
	<input type="hidden" name="ignore_ids" value="<?php echo $ignore_ids_string; ?>" />
	</form>
<?php
}
?>