<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$database->setQuery("SELECT ignore_ids FROM #__pms_ignorelist WHERE my_id=$my_id LIMIT 1");
if(!$database->query()) pms_sql_error($database->getErrorMsg());
$ignore_ids_string = $database->loadResult();
$ignore_ids = str_replace("|", "", $ignore_ids_string);

if($userlist==0 OR $userlist==2) $order = "ORDER BY t1.username";
if($userlist==1 OR $userlist==3) $order = "ORDER BY t1.name";

if($ignore_ids=="") $query = "SELECT t1.id, t1.username, t1.name FROM #__users AS t1 WHERE t1.id=-1";
else $query = "SELECT t1.id, t1.username, t1.name FROM #__users AS t1, #__comprofiler AS t2 WHERE t1.id=t2.user_id AND t1.id IN (".$ignore_ids.") $order";
$database->setQuery($query);
if(!$database->query()) pms_sql_error($database->getErrorMsg());
$rows = $database->loadObjectList();

$ignorelist_users = "<select class=\"inputbox\" name=\"ignore_users\" size=\"".$height_userlists."\">";
if(count($rows)==0) $ignorelist_users .= '<option value="no_entry">'._PMS_ADDRESSBOOK_NO_ENTRY.'</option>';
else
{
	foreach ($rows as $row)
	{
		$ignorelist_users .= '<option value="'.$row->id.'">';
		if($userlist==0) $ignorelist_users .= $row->username;
		if($userlist==1) $ignorelist_users .= $row->name;
		if($userlist==2) $ignorelist_users .= $row->username.' ('.$row->name.')';
		if($userlist==3) $ignorelist_users .= $row->name.' ('.$row->username.')';
		$ignorelist_users .= '</option>';
	}
}
$ignorelist_users .= "</select>";
echo $ignorelist_users;
?>