<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

DEFINE ('_PMS_TITLE', 'private messages');

// main icons
DEFINE ('_PMS_INBOX', 'inbox');
DEFINE ('_PMS_SENT_ITEMS', 'sent items');
DEFINE ('_PMS_WRITE', 'write message');
DEFINE ('_PMS_SEARCH', 'search');
DEFINE ('_PMS_TRASH', 'trash');
DEFINE ('_PMS_ADDRESSBOOK', 'addressbook');
DEFINE ('_PMS_IGNORELIST', 'ignorelist');
DEFINE ('_PMS_SETTINGS', 'settings');
DEFINE ('_PMS_PM_UNREAD', 'unread message');
DEFINE ('_PMS_PM_READ', 'read message');
DEFINE ('_PMS_PM_REPLY_UNREAD', 'answered unread message');
DEFINE ('_PMS_PM_REPLY_READ', 'answered read message');
DEFINE ('_PMS_PM_FORWARD_UNREAD', 'forwarded unread message');
DEFINE ('_PMS_PM_FORWARD_READ', 'forwarded read message');
DEFINE ('_PMS_PM_REPLY_FORWARD_UNREAD', 'answered & forwarded unread message');
DEFINE ('_PMS_PM_REPLY_FORWARD_READ', 'answered & forwarded read message');

// list of PMs
DEFINE ('_PMS_STATUS', 'status');
DEFINE ('_PMS_SENDER', 'sender');
DEFINE ('_PMS_RECIP', 'recipient');
DEFINE ('_PMS_SUBJECT', 'subject');
DEFINE ('_PMS_DATETIME', 'date/time');
DEFINE ('_PMS_AT', ' at ');
DEFINE ('_PMS_ONLINE', 'online');
DEFINE ('_PMS_OFFLINE', 'offline');
DEFINE ('_PMS_TO_TRASH', 'to trash');
DEFINE ('_PMS_DELETE', 'delete completely');
DEFINE ('_PMS_RETRACT', 'retract');
DEFINE ('_PMS_RECYCLE', 'recycle');
DEFINE ('_PMS_NO_MSG', 'You have no messages in your ');
DEFINE ('_PMS_OPTIONS', 'selected messages: ');
DEFINE ('_PMS_OPTIONS_SUBMIT', 'execute');
DEFINE ('_PMS_OPTIONS_SUBMIT_NO_SELECTION', 'Please choose at least one message.');
DEFINE ('_PMS_DELETE_TRASH_NOTICE', 'Messages in the trash will be deleted automaticly after %s days!');

// sort of PMs
DEFINE ('_PMS_SORT_FOR', 'sort for');
DEFINE ('_PMS_SORT', 'sort');
DEFINE ('_PMS_ASC', 'ascendent');
DEFINE ('_PMS_DESC', 'descendent');

// page navigation
DEFINE ('_PMS_PAGE', 'page');
DEFINE ('_PMS_RESULTS', 'hits');
DEFINE ('_PMS_OF_TOTAL', 'of alltogether');
DEFINE ('_PMS_NO_RESULTS', 'no hits');
DEFINE ('_PMS_FIRST_PAGE', 'first page');
DEFINE ('_PMS_PREV_PAGE', 'previous page');
DEFINE ('_PMS_NEXT_PAGE', 'next page');
DEFINE ('_PMS_END_PAGE', 'last page');

// open PMs
DEFINE ('_PMS_READ', 'read message');
DEFINE ('_PMS_READ_DENIED', 'You don\'t have permissions to read this message!');
DEFINE ('_PMS_MESSAGE', 'content');

// write PMs
DEFINE ('_PMS_RECIP_LIST', 'recipientlist');
DEFINE ('_PMS_REPLY', 'answer');
DEFINE ('_PMS_REPLY_PREFIX', 'RE:');
DEFINE ('_PMS_FORWARD', 'forward');
DEFINE ('_PMS_FORWARD_PREFIX', 'FW:');
DEFINE ('_PMS_WRITE_NEW', 'write new message');
DEFINE ('_PMS_WRITE_REPLY', 'answer to message');
DEFINE ('_PMS_WRITE_FORWARD', 'forward message');
DEFINE ('_PMS_WRITE_NO_RECIP', 'Please enter a user!');
DEFINE ('_PMS_WRITE_NO_MSG', 'Please enter a message!');
DEFINE ('_PMS_SEND', 'send message');
DEFINE ('_PMS_NO_SUBJECT', 'no subject');
DEFINE ('_PMS_REMAINING_CHARACTERS', ' remaining characters');
DEFINE ('_PMS_RECIPS_DESCR', 'seperate multiple users with comma');
DEFINE ('_PMS_MAX_RECIPS', ' (max. %s users allowed)');
DEFINE ('_PMS_WRITE_PREFIX',"\r\n\r\n\r\n____________________\r\n");

// bb-code
DEFINE ('_PMS_BB_LINK', 'insert link');
DEFINE ('_PMS_BB_EMAIL', 'insert email address');
DEFINE ('_PMS_BB_BOLD', 'insert bold text');
DEFINE ('_PMS_BB_ITALIC', 'insert italic text');
DEFINE ('_PMS_BB_UNDERLINE', 'insert underlined text');
DEFINE ('_PMS_BB_QUOTE', 'insert quote');
DEFINE ('_PMS_BB_CODE', 'insert code');
DEFINE ('_PMS_BB_INSERT_AT', 'insert at position');
DEFINE ('_PMS_BB_ENTER_TEXT', 'Please enter text you want to format');

// search
DEFINE ('_PMS_SEARCH_FOR', 'search values');
DEFINE ('_PMS_SEARCH_BUTTON', 'start search');
DEFINE ('_PMS_SEARCH_NO_RESULTS', 'Your search has no hits.');
DEFINE ('_PMS_SEARCH_VALIDATE', 'Please enter at least one search criterion!');

// addressbook
DEFINE ('_PMS_ADDRESSBOOK_LIST', 'addressbooklist');
DEFINE ('_PMS_ADDRESSBOOK_ALL_USERS', 'userlist');
DEFINE ('_PMS_ADDRESSBOOK_SAVE', 'save addressbook');
DEFINE ('_PMS_ADDRESSBOOK_FILTER', 'filter:');
DEFINE ('_PMS_ADDRESSBOOK_FILTER_ALL', 'all');
DEFINE ('_PMS_ADDRESSBOOK_NO_ENTRY', 'no entries');
DEFINE ('_PMS_ADDRESSBOOK_ADD', '<<');
DEFINE ('_PMS_ADDRESSBOOK_REMOVE', '>>');
DEFINE ('_PMS_ADDRESSBOOK_IMPORT', 'To import your buddies, click <a href="%s">here</a>.');
DEFINE ('_PMS_ADDRESSBOOK_DISABLED', 'The addressbook isn\'t activated.');

// ignore
DEFINE ('_PMS_IGNORELIST_SAVE', 'save ignorelist');
DEFINE ('_PMS_IGNORELIST_DISABLED', 'The ignorelist isn\'t activated.');

// settings for front- an backend
DEFINE ('_PMS_SETTINGS_TITLE', 'PMS enhanced');
DEFINE ('_PMS_SETTINGS_BACKENDTAB', 'backend');
DEFINE ('_PMS_SETTINGS_FRONTENDTAB', 'frontend');
DEFINE ('_PMS_SETTINGS_USERTAB', 'user');
DEFINE ('_PMS_SETTINGS_CONFIGFILE', ' (config.pms.php is %s)');
DEFINE ('_PMS_SETTINGS_WRITEABLE', 'writeable');
DEFINE ('_PMS_SETTINGS_UNWRITEABLE', 'unwriteable');
DEFINE ('_PMS_SETTINGS_DISABLED', 'Settings aren\'t activated.');
DEFINE ('_PMS_SETTINGS_PARAM', 'parameter');
DEFINE ('_PMS_SETTINGS_VALUE', 'value');
DEFINE ('_PMS_SETTINGS_ALLOW_OVERRIDE', 'may user change value');
DEFINE ('_PMS_SETTINGS_DESCRIPTION', 'description');
DEFINE ('_PMS_SETTINGS_MAX_ALLOWED_PM', 'how many messages:');
DEFINE ('_PMS_SETTINGS_MAX_ALLOWED_PM_DESCR', 'How many messages may a user have? Choose 0 for unlimited.');
DEFINE ('_PMS_SETTINGS_MAX_LENGTH_SUBJECT', 'how many characters for subject:');
DEFINE ('_PMS_SETTINGS_MAX_LENGTH_SUBJECT_DESCR', 'How many characters may be used for the subject? (Attention: %s is the maximum of the database field!)');
DEFINE ('_PMS_SETTINGS_MAX_LENGTH_MESSAGE', 'how many characters for content:');
DEFINE ('_PMS_SETTINGS_MAX_LENGTH_MESSAGE_DESCR', 'How many characters may be used for the content? Choose 0 for unlimited.');
DEFINE ('_PMS_SETTINGS_USERGROUPS', 'groups in userlist:');
DEFINE ('_PMS_SETTINGS_USERGROUPS_DESCR', 'Users of which groups should be displayed in the userlist? Use Strg-key for multiple selection.');
DEFINE ('_PMS_SETTINGS_MAX_ENTRIES_RECIPLIST', 'how many user per message:');
DEFINE ('_PMS_SETTINGS_MAX_ENTRIES_RECIPLIST_DESCR', 'How many users may be added to the recipientlist when writing a message? Choose 0 for unlimited.');
DEFINE ('_PMS_SETTINGS_DELETE_TRASH', 'clear trash automaticly:');
DEFINE ('_PMS_SETTINGS_DELETE_TRASH_DESCR', 'After how many days should messages be deleted from the trash automaticly? Choose 0, to disable this option.');
DEFINE ('_PMS_SETTINGS_RETRACT', 'retract of messages:');
DEFINE ('_PMS_SETTINGS_RETRACT_NO', 'no');
DEFINE ('_PMS_SETTINGS_RETRACT_YES', 'yes');
DEFINE ('_PMS_SETTINGS_RETRACT_UNREAD', 'yes, if unread');
DEFINE ('_PMS_SETTINGS_RETRACT_DESCR', 'May users retract messages?');
DEFINE ('_PMS_SETTINGS_ADDRESSBOOK', 'addressbook:');
DEFINE ('_PMS_SETTINGS_ADDRESSBOOK_DESCR', 'May users use an addressbook?');
DEFINE ('_PMS_SETTINGS_IGNORELIST', 'ignorelist:');
DEFINE ('_PMS_SETTINGS_IGNORELIST_DESCR', 'May users use an ignorelist?');
DEFINE ('_PMS_SETTINGS_CB', 'CB-version:');
DEFINE ('_PMS_SETTINGS_CB_NONE', 'none');
DEFINE ('_PMS_SETTINGS_CB_CBSTABLE', 'CB stable');
DEFINE ('_PMS_SETTINGS_CB_CBE', 'CB enhanced');
DEFINE ('_PMS_SETTINGS_CB_DESCR', 'Which version of the CommunityBuilder is installed for integration?');
DEFINE ('_PMS_SETTINGS_LAYOUT', 'menu layout:');
DEFINE ('_PMS_SETTINGS_LAYOUT_DESCR', 'Should icons, textlinks or both be used in the menu?');
DEFINE ('_PMS_SETTINGS_LAYOUT_ICON', 'icons');
DEFINE ('_PMS_SETTINGS_LAYOUT_TEXT', 'textlinks');
DEFINE ('_PMS_SETTINGS_LAYOUT_ICON_TEXT', 'icons & text');
DEFINE ('_PMS_SETTINGS_USERLIST', 'format userlist:');
DEFINE ('_PMS_SETTINGS_USERLIST_USERNAME', 'username');
DEFINE ('_PMS_SETTINGS_USERLIST_NAME', 'name');
DEFINE ('_PMS_SETTINGS_USERLIST_USERNAME_NAME', 'username (name)');
DEFINE ('_PMS_SETTINGS_USERLIST_NAME_USERNAME', 'name (username)');
DEFINE ('_PMS_SETTINGS_USERLIST_DESCR', 'In which format should users be dsiplayed?');
DEFINE ('_PMS_SETTINGS_SMILEY', 'smiley support:');
DEFINE ('_PMS_SETTINGS_SMILEY_DESCR', 'Are smileys allowed when writing a message?');
DEFINE ('_PMS_SETTINGS_BB_CODE', 'bb-code support:');
DEFINE ('_PMS_SETTINGS_BB_CODE_DESCR', 'Is bb-code allowed when writing a message?');
DEFINE ('_PMS_SETTINGS_WIDTH_RECIPFIELD', 'width of recipientfield:');
DEFINE ('_PMS_SETTINGS_WIDTH_RECIPFIELD_DESCR', 'What width (in pixel) should be used for the recipientfield, when writing a message?');
DEFINE ('_PMS_SETTINGS_WIDTH_MESSAGEFIELDS', 'width of messagefields:');
DEFINE ('_PMS_SETTINGS_WIDTH_MESSAGEFIELDS_DESCR', 'What width (in pixel) should be used for the subject- and contentfield, when writing a message?');
DEFINE ('_PMS_SETTINGS_HEIGHT_MESSAGEFIELD', 'height of contentfield:');
DEFINE ('_PMS_SETTINGS_HEIGHT_MESSAGEFIELD_DESCR', 'What height (in pixel) should be used for the contentfield, when writing a message?');
DEFINE ('_PMS_SETTINGS_HEIGHT_USERLISTS', 'height of userlists:');
DEFINE ('_PMS_SETTINGS_HEIGHT_USERLISTS_DESCR', 'What height (in rows) should be used for the userlists?');
DEFINE ('_PMS_SETTINGS_USERSEARCH', 'dynamic usersearch:');
DEFINE ('_PMS_SETTINGS_USERSEARCH_DESCR', 'Should dynamic usersearch be activated, when typing a user manuelly to the recipientfield?');
DEFINE ('_PMS_SETTINGS_USERSEARCH_MIN_CHARACTERS', 'min. characters for usersearch:');
DEFINE ('_PMS_SETTINGS_USERSEARCH_MIN_CHARACTERS_DESCR', 'How many characters must be entered to activated dynamic usersearch?');
DEFINE ('_PMS_SETTINGS_USERSEARCH_MAX_ROWS', 'max. hits for usersearch:');
DEFINE ('_PMS_SETTINGS_USERSEARCH_MAX_ROWS_DESCR', 'How many hits should be displayed, when dynamic usersearch will be used? Choose 0 for unlimited.');
DEFINE ('_PMS_SETTINGS_EMAIL_NEW', 'email for new messages:');
DEFINE ('_PMS_SETTINGS_EMAIL_NEW_DESCR', 'Would you get an email, when you get a new email?');
DEFINE ('_PMS_SETTINGS_EMAIL_REPLY', 'email for reply of a message:');
DEFINE ('_PMS_SETTINGS_EMAIL_REPLY_DESCR', 'Would you get an email, when you get an answer to one of your messages?');
DEFINE ('_PMS_SETTINGS_EMAIL_FORMAT', 'email format:');
DEFINE ('_PMS_SETTINGS_EMAIL_FORMAT_TEXT', 'text');
DEFINE ('_PMS_SETTINGS_EMAIL_FORMAT_HTML', 'html');
DEFINE ('_PMS_SETTINGS_EMAIL_FORMAT_DESCR', 'Should email be formated in html or as normal text?');
DEFINE ('_PMS_SETTINGS_OFFLINE', 'email notification only when offline:');
DEFINE ('_PMS_SETTINGS_OFFLINE_DESCR', 'Should email notification only be used of you are offline?');
DEFINE ('_PMS_SETTINGS_REPLY', 'format of answer:');
DEFINE ('_PMS_SETTINGS_REPLY_DESCR', 'Should original message be attached, when answering to a message and which format should be used?');
DEFINE ('_PMS_SETTINGS_REPLY_WITHOUT', 'not attach');
DEFINE ('_PMS_SETTINGS_REPLY_WITH', 'attach normal');
DEFINE ('_PMS_SETTINGS_REPLY_ITALIC', 'attach italic');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS', 'clear sent items automaticly:');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS_NO', 'no');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS_TRASH', 'move to trash');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS_DELETE', 'delete completely');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS_DESCR', 'Should messages in sent items, which are read from the recipient automaticly move to the trash or deleted completely?');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_POPUP', 'popup for new messages');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_POPUP_DESCR', 'Would you be informed via popup, if you get a new message?');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_SOUND', 'popup with sound');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_SOUND_DESCR', 'Should sound be used for popup notification?');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_SOUND_VALUE', 'sound file');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_SOUND_VALUE_DESCR', 'Which sound should be used for popup notification?');
DEFINE ('_PMS_SETTINGS_ROWS', 'how many messages per page:');
DEFINE ('_PMS_SETTINGS_ROWS_DESCR', 'How many messages should be displayed per page?');
DEFINE ('_PMS_SETTINGS_PAGES', 'how many page links:');
DEFINE ('_PMS_SETTINGS_PAGES_DESCR', 'How many page links for direct navigation should be displayed?');
DEFINE ('_PMS_SETTINGS_SAVE', 'save settings');
DEFINE ('_PMS_SETTINGS_INVALID_VALUES', 'The following fields have wrong values:');

// definitions for backend (view/edit/new)
DEFINE ('_PMS_BACKEND_RESULTS_PER_PAGE', 'hits per page:');
DEFINE ('_PMS_BACKEND_FILTER', 'filter');
DEFINE ('_PMS_BACKEND_FILTER_BUTTON', 'use filter');
DEFINE ('_PMS_BACKEND_DATE_FROM', 'date from<br />(dd.mm.yyyy):');
DEFINE ('_PMS_BACKEND_DATE_TILL', 'date til<br />(dd.mm.yyyy):');
DEFINE ('_PMS_BACKEND_DROPDOWN_NONE', '---');
DEFINE ('_PMS_BACKEND_STATUS_SENDER', 'place of sender');
DEFINE ('_PMS_BACKEND_STATUS_RECIPIENT', 'place of recipient');
DEFINE ('_PMS_BACKEND_DELETED', 'deleted completely');
DEFINE ('_PMS_BACKEND_PM_NEW', 'add message');
DEFINE ('_PMS_BACKEND_PM_EDIT', 'edit message');
DEFINE ('_PMS_BACKEND_VALID_DATE', 'Please enter a valid date!');
DEFINE ('_PMS_BACKEND_VALID_NO_USERS', 'Please choose a user from sender- and recipientlist!');
DEFINE ('_PMS_BACKEND_VALID_SAME_USERS', 'Please choose two different users for sender and recipient!');
DEFINE ('_PMS_BACKEND_VALID_NO_MESSAGE', 'Please enter a content!');
DEFINE ('_PMS_BACKEND_NOT_ADMIN', 'You don\'t have permissions to read or edit messages!');

// limit of PMs
DEFINE ('_PMS_STATUS_BAR', 'You have saved %s of at most %s allowed messages.');
DEFINE ('_PMS_STATUS_BAR_WARNING', '!!!ATTENTION!!!<br />You have reached the maximum of %s allowed messages. At the moment you can\'t send or recieve any message. Please delete some of your messages.');
DEFINE ('_PMS_NEW_WARNING', 'At the moment you can\'t send any message. Please delete some of your messages.');

// email notification
DEFINE ("_PMS_EMAIL_SUBJECT_NEW","%s - new private message from %s");
DEFINE ("_PMS_EMAIL_SUBJECT_REPLY","%s - answer to your private message from %s");
DEFINE ("_PMS_EMAIL_MESSAGE_NEW_TEXT","Hello %s,\r\nyou have got a new message from %s on %s.\r\n\r\nsubject: %s\r\ncontent:\r\n%s\r\n\r\nRegards,\r\n%s");
DEFINE ("_PMS_EMAIL_MESSAGE_NEW_HTML","<html><body>Hello %s,<br />you have got a new message from %s on %s.<br /><br /><b>subject:</b> %s<br /><b>content:</b><br />%s<br /><br />Regards,<br />%s</body></html>");
DEFINE ("_PMS_EMAIL_MESSAGE_REPLY_TEXT","Hello %s,\r\nyou have got an answer to your message from %s on %s.\r\n\r\nsubject: %s\r\ncontent:\r\n%s\r\n\r\nRegards,\r\n%s");
DEFINE ("_PMS_EMAIL_MESSAGE_REPLY_HTML","<html><body>Hello %s,<br />you have got an answer to your message from %s on %s.<br /><br /><b>subject:</b> %s<br /><b>content:</b><br />%s<br /><br />Regards,<br />%s</body></html>");

// definition for about
DEFINE ('_PMS_BACKEND_ABOUT_TITLE', 'info');
DEFINE ('_PMS_BACKEND_ABOUT_SUGGESTION', 'your opinion');
DEFINE ('_PMS_BACKEND_ABOUT_NAME', 'name:');
DEFINE ('_PMS_BACKEND_ABOUT_MAIL', 'email:');
DEFINE ('_PMS_BACKEND_ABOUT_SENT', 'sent');
DEFINE ('_PMS_BACKEND_ABOUT_VALIDATE', 'Please fill in all fields!');
DEFINE ('_PMS_BACKEND_ABOUT_TEXT', 'titel: PMS enhanced<br />
description: a Private Messaging System (PMS) for Mambo/Joomla<br />
author: Stefan Klingner (original Danial Taherzadeh)<br />
Version: 2.0.3<br />
created: 04.12.2006<br />
license: GNU/GPL (based on myPMS OpenSource from april 2005)<br /><br /><br />
If you have criticism, ideas or found bugs for this component, you can contact me via the form on the left.<br />Alternativly you can visit <a href="http://www.stefan-klingner.de/index.php?option=com_joomlaboard&Itemid=13" target="_blank">my forum</a> on <a href="http://www.stefan-klingner.de" target="_blank">www.stefan-klingner.de</a>.<br />The newest version you can also find on my website in the <a href="http://www.stefan-klingner.de/index.php?option=com_docman&Itemid=8" target="_blank">downloadsection</a>.');

// messages for mosRedirect
DEFINE ('_PMS_MSG_SENT', 'Your message was sent.');
DEFINE ('_PMS_MSG_SENT_MULTIPLE', 'Your message was sent to all recipients.');
DEFINE ('_PMS_MSG_SENT_ERROR', 'Your message couldn\'t be sent.');
DEFINE ('_PMS_MSG_SENT_ERROR_MULTIPLE', '%s of %s messages couldn\'t be sent.');
DEFINE ('_PMS_MSG_SENT_ERROR_INVALID_USER', 'At least one user is invalid.');
DEFINE ('_PMS_MSG_REPLY_SENT', 'Your answer was sent.');
DEFINE ('_PMS_MSG_TRASHED', 'Your message was moved to the trash.');
DEFINE ('_PMS_MSG_TRASHED_ERROR', 'Deine Nachricht konnte nicht in den Papierkorb verschoben werden.');
DEFINE ('_PMS_MSG_TRASHED_MULTIPLE', 'Your messages were moved to the trash.');
DEFINE ('_PMS_MSG_TRASHED_MULTIPLE_ERROR', 'Deine Nachrichten konnten nicht in den Papierkorb verschoben werden.');
DEFINE ('_PMS_MSG_DELETED', 'Your message was deleted completely.');
DEFINE ('_PMS_MSG_DELETED_ERROR', 'Deine Nachricht konnte nicht endgltig gelscht werden.');
DEFINE ('_PMS_MSG_DELETED_MULTIPLE', 'Your messages were deleted completely.');
DEFINE ('_PMS_MSG_DELETED_MULTIPLE_ERROR', 'Deine Nachrichten konnten nicht endgltig gelscht werden.');
DEFINE ('_PMS_MSG_RECYCLED', 'Your message was recycled.');
DEFINE ('_PMS_MSG_RECYCLED_ERROR', 'Deine Nachricht konnte nicht wiederhergestellt werden.');
DEFINE ('_PMS_MSG_RECYCLED_MULTIPLE', 'Your messages were recycled.');
DEFINE ('_PMS_MSG_RECYCLED_MULTIPLE_ERROR', 'Deine Nachrichten konnten nicht wiederhergestellt werden.');
DEFINE ('_PMS_MSG_RETRACTED', 'Your message was retracted.');
DEFINE ('_PMS_MSG_RETRACTED_ERROR', 'Your message couldn\'t be retracted.');
DEFINE ('_PMS_MSG_RETRACTED_MULTIPLE', 'Your messages were retracted.');
DEFINE ('_PMS_MSG_RETRACTED_MULTIPLE_ERROR', 'Your messages couldn\'t be retracted.');
DEFINE ('_PMS_MSG_RETRACTED_FORBIDDEN', 'Your messages may not be retracted.');
DEFINE ('_PMS_MSG_RETRACTED_MULTIPLE_FORBIDDEN_SOME', 'Some of your messages may not be retracted.');
DEFINE ('_PMS_MSG_RETRACTED_MULTIPLE_FORBIDDEN_ALL', 'Your messages may not be retracted.');
DEFINE ('_PMS_MSG_SAVE_SETTINGS_ALL', 'Your settings were saved.');
DEFINE ('_PMS_MSG_SAVE_SETTINGS_FILE', 'Only the settings in the configfile were saved.');
DEFINE ('_PMS_MSG_SAVE_SETTINGS_DB', 'Only the settings in the database were saved.');
DEFINE ('_PMS_MSG_SAVE_SETTINGS_ERROR', 'Your settings couldn\'t be saved.');
DEFINE ('_PMS_MSG_ABOUT_SENT_OK', 'Your opinion was sent.');
DEFINE ('_PMS_MSG_ABOUT_SENT_ERROR', 'Your opinion couldn\'t be sent.');
DEFINE ('_PMS_MSG_SAVE_NEW', 'The message was saved.');
DEFINE ('_PMS_MSG_SAVE_NEW_ERROR', 'The message couldn\'t be saved.');
DEFINE ('_PMS_MSG_SAVE_UPDATE', 'The message was updated.');
DEFINE ('_PMS_MSG_SAVE_UPDATE_ERROR', 'The message couldn\'t be updated.');
DEFINE ('_PMS_MSG_SAVE_ADDRESSBOOK', 'Your change to the addressbook was saved.');
DEFINE ('_PMS_MSG_SAVE_ADDRESSBOOK_ERROR', 'Your change to the addressbook couldn\'t be saved.');
DEFINE ('_PMS_MSG_SAVE_IGNORELIST', 'Your change to the ignorelist was saved.');
DEFINE ('_PMS_MSG_SAVE_IGNORELIST_ERROR', 'Your change to the ignorelist couldn\'t be saved.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_NO_BUDDY', 'You have no buddies.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_ALL', 'Your buddies were imported.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_SOME', 'Some of your buddies may not be imported.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_NONE', 'Your buddies may not be imported.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_ERROR', 'Your buddies couldn\'t be imported.');
?>