<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

DEFINE ('_PMS_TITLE', 'Private Nachrichten');

// main icons
DEFINE ('_PMS_INBOX', 'Posteingang');
DEFINE ('_PMS_SENT_ITEMS', 'Postausgang');
DEFINE ('_PMS_WRITE', 'Nachricht schreiben');
DEFINE ('_PMS_SEARCH', 'Suche');
DEFINE ('_PMS_TRASH', 'Papierkorb');
DEFINE ('_PMS_ADDRESSBOOK', 'Adressbuch');
DEFINE ('_PMS_IGNORELIST', 'Ignorliste');
DEFINE ('_PMS_SETTINGS', 'Einstellungen');
DEFINE ('_PMS_PM_UNREAD', 'ungelesene Nachricht');
DEFINE ('_PMS_PM_READ', 'gelesene Nachricht');
DEFINE ('_PMS_PM_REPLY_UNREAD', 'beantwortete ungelesene Nachricht');
DEFINE ('_PMS_PM_REPLY_READ', 'beantwortete gelesene Nachricht');
DEFINE ('_PMS_PM_FORWARD_UNREAD', 'weitergeleitete ungelesene Nachricht');
DEFINE ('_PMS_PM_FORWARD_READ', 'weitergeleitete gelesene Nachricht');
DEFINE ('_PMS_PM_REPLY_FORWARD_UNREAD', 'beantwortete & weitergeleitete ungelesene Nachricht');
DEFINE ('_PMS_PM_REPLY_FORWARD_READ', 'beantwortete & weitergeleitete gelesene Nachricht');

// list of PMs
DEFINE ('_PMS_STATUS', 'Status');
DEFINE ('_PMS_SENDER', 'Absender');
DEFINE ('_PMS_RECIP', 'Empfnger');
DEFINE ('_PMS_SUBJECT', 'Betreff');
DEFINE ('_PMS_DATETIME', 'Datum/Uhrzeit');
DEFINE ('_PMS_AT', ' um ');
DEFINE ('_PMS_ONLINE', 'online');
DEFINE ('_PMS_OFFLINE', 'offline');
DEFINE ('_PMS_TO_TRASH', 'in den Papierkorb');
DEFINE ('_PMS_DELETE', 'endgltig lschen');
DEFINE ('_PMS_RETRACT', 'zurckziehen');
DEFINE ('_PMS_RECYCLE', 'wiederherstellen');
DEFINE ('_PMS_NO_MSG', 'Sie haben keine Nachrichten in Ihrem ');
DEFINE ('_PMS_OPTIONS', 'selektierte Nachrichten: ');
DEFINE ('_PMS_OPTIONS_SUBMIT', 'ausfhren');
DEFINE ('_PMS_OPTIONS_SUBMIT_NO_SELECTION', 'Whlen Sie bitte mindestens eine Nachricht aus.');
DEFINE ('_PMS_DELETE_TRASH_NOTICE', 'Nachrichten im Papierkorb werden nach %s Tagen automatisch entfernt!');

// sort of PMs
DEFINE ('_PMS_SORT_FOR', 'Sortieren nach');
DEFINE ('_PMS_SORT', 'sortieren');
DEFINE ('_PMS_ASC', 'aufsteigend');
DEFINE ('_PMS_DESC', 'absteigend');

// page navigation
DEFINE ('_PMS_PAGE', 'Seite');
DEFINE ('_PMS_RESULTS', 'Treffer');
DEFINE ('_PMS_OF_TOTAL', 'von insgesamt');
DEFINE ('_PMS_NO_RESULTS', 'keine Treffer');
DEFINE ('_PMS_FIRST_PAGE', 'erste Seite');
DEFINE ('_PMS_PREV_PAGE', 'vorherige Seite');
DEFINE ('_PMS_NEXT_PAGE', 'nchste Seite');
DEFINE ('_PMS_END_PAGE', 'letzte Seite');

// open PMs
DEFINE ('_PMS_READ', 'Nachricht lesen');
DEFINE ('_PMS_READ_DENIED', 'Sie haben keine Berechtigung die angeforderte Nachricht zu lesen!');
DEFINE ('_PMS_MESSAGE', 'Inhalt');

// write PMs
DEFINE ('_PMS_RECIP_LIST', 'Empfngerliste');
DEFINE ('_PMS_REPLY', 'Antworten');
DEFINE ('_PMS_REPLY_PREFIX', 'AW:');
DEFINE ('_PMS_FORWARD', 'Weiterleiten');
DEFINE ('_PMS_FORWARD_PREFIX', 'WG:');
DEFINE ('_PMS_WRITE_NEW', 'Neue Nachricht schreiben');
DEFINE ('_PMS_WRITE_REPLY', 'Auf Nachricht antworten');
DEFINE ('_PMS_WRITE_FORWARD', 'Nachricht weiterleiten');
DEFINE ('_PMS_WRITE_NO_RECIP', 'Geben Sie bitte einen Benutzer ein!');
DEFINE ('_PMS_WRITE_NO_MSG', 'Geben Sie bitte eine Nachricht ein!');
DEFINE ('_PMS_SEND', 'Nachricht senden');
DEFINE ('_PMS_NO_SUBJECT', 'kein Betreff');
DEFINE ('_PMS_REMAINING_CHARACTERS', ' Zeichen brig');
DEFINE ('_PMS_RECIPS_DESCR', 'Mehrere Benutzer durch Komma trennen');
DEFINE ('_PMS_MAX_RECIPS', ' (max. %s Benutzer erlaubt)');
DEFINE ('_PMS_WRITE_PREFIX',"\r\n\r\n\r\n____________________\r\n");

// bb-code
DEFINE ('_PMS_BB_LINK', 'Link einfgen');
DEFINE ('_PMS_BB_EMAIL', 'E-Mail Adresse einfgen');
DEFINE ('_PMS_BB_BOLD', 'Text in fetter Schrift');
DEFINE ('_PMS_BB_ITALIC', 'Text in kursiver Schrift');
DEFINE ('_PMS_BB_UNDERLINE', 'Text in unterstrichener Schrift');
DEFINE ('_PMS_BB_QUOTE', 'Zitieren');
DEFINE ('_PMS_BB_CODE', 'Code einfgen');
DEFINE ('_PMS_BB_INSERT_AT', 'Einfgen an Position');
DEFINE ('_PMS_BB_ENTER_TEXT', 'Geben Sie bitte den zu formatierenden Text ein');

// search
DEFINE ('_PMS_SEARCH_FOR', 'Suchparameter');
DEFINE ('_PMS_SEARCH_BUTTON', 'Suche starten');
DEFINE ('_PMS_SEARCH_NO_RESULTS', 'Ihre Suche ergab keine Treffer.');
DEFINE ('_PMS_SEARCH_VALIDATE', 'Geben Sie bitte mindestens einen Suchbegriff ein!');

// addressbook
DEFINE ('_PMS_ADDRESSBOOK_LIST', 'Adressbuchliste');
DEFINE ('_PMS_ADDRESSBOOK_ALL_USERS', 'Benutzerliste');
DEFINE ('_PMS_ADDRESSBOOK_SAVE', 'Adressbuch speichern');
DEFINE ('_PMS_ADDRESSBOOK_FILTER', 'filtern:');
DEFINE ('_PMS_ADDRESSBOOK_FILTER_ALL', 'alle');
DEFINE ('_PMS_ADDRESSBOOK_NO_ENTRY', 'keine Eintr&auml;ge');
DEFINE ('_PMS_ADDRESSBOOK_ADD', '<<');
DEFINE ('_PMS_ADDRESSBOOK_REMOVE', '>>');
DEFINE ('_PMS_ADDRESSBOOK_IMPORT', 'Um Ihre Buddies zu importieren bitte <a href="%s">hier</a> klicken.');
DEFINE ('_PMS_ADDRESSBOOK_DISABLED', 'Das Adressbuch ist nicht freigeschaltet.');

// ignore
DEFINE ('_PMS_IGNORELIST_SAVE', 'Ignorliste speichern');
DEFINE ('_PMS_IGNORELIST_DISABLED', 'Die Ignorliste ist nicht freigeschaltet.');

// settings for front- an backend
DEFINE ('_PMS_SETTINGS_TITLE', 'PMS enhanced');
DEFINE ('_PMS_SETTINGS_BACKENDTAB', 'Backend');
DEFINE ('_PMS_SETTINGS_FRONTENDTAB', 'Frontend');
DEFINE ('_PMS_SETTINGS_USERTAB', 'Benutzer');
DEFINE ('_PMS_SETTINGS_CONFIGFILE', ' (config.pms.php ist %s)');
DEFINE ('_PMS_SETTINGS_WRITEABLE', 'schreibbar');
DEFINE ('_PMS_SETTINGS_UNWRITEABLE', 'unschreibbar');
DEFINE ('_PMS_SETTINGS_DISABLED', 'Es sind keine Einstellungen freigeschaltet.');
DEFINE ('_PMS_SETTINGS_PARAM', 'Parameter');
DEFINE ('_PMS_SETTINGS_VALUE', 'Wert');
DEFINE ('_PMS_SETTINGS_ALLOW_OVERRIDE', 'Darf Benutzer den Wert ndern');
DEFINE ('_PMS_SETTINGS_DESCRIPTION', 'Beschreibung');
DEFINE ('_PMS_SETTINGS_MAX_ALLOWED_PM', 'Anzahl von Nachrichten:');
DEFINE ('_PMS_SETTINGS_MAX_ALLOWED_PM_DESCR', 'Wieviele Nachrichten darf der Benutzer haben? Whle 0 fr unbegrenzt.');
DEFINE ('_PMS_SETTINGS_MAX_LENGTH_SUBJECT', 'Anzahl Zeichen im Betreff:');
DEFINE ('_PMS_SETTINGS_MAX_LENGTH_SUBJECT_DESCR', 'Wieviele Zeichen drfen fr den Betreff verwendet werden? (Achtung: %s ist das Maximum des Datenbankfelds!)');
DEFINE ('_PMS_SETTINGS_MAX_LENGTH_MESSAGE', 'Anzahl Zeichen in der Nachricht:');
DEFINE ('_PMS_SETTINGS_MAX_LENGTH_MESSAGE_DESCR', 'Wieviele Zeichen drfen fr die Nachricht verwendet werden? Whle 0 fr unbegrenzt.');
DEFINE ('_PMS_SETTINGS_USERGROUPS', 'Gruppen in Benutzerliste:');
DEFINE ('_PMS_SETTINGS_USERGROUPS_DESCR', 'Benutzer welcher Gruppen sollen in der Benutzerliste angezeigt werden? Mehrfachauswahl mit gedrckter Strg-Taste mglich.');
DEFINE ('_PMS_SETTINGS_MAX_ENTRIES_RECIPLIST', 'Anzahl Benutzer pro Nachricht:');
DEFINE ('_PMS_SETTINGS_MAX_ENTRIES_RECIPLIST_DESCR', 'Wieviele Benutzer drfen beim Versenden einer neuen Nachricht in die Empfngerliste hinzugefgt werden? Whle 0 fr unbegrenzt.');
DEFINE ('_PMS_SETTINGS_DELETE_TRASH', 'Papierkorb automatisch leeren:');
DEFINE ('_PMS_SETTINGS_DELETE_TRASH_DESCR', 'Nach wieviel Tagen sollen Nachrichten im Papierkorb automatisch gelscht werden? Whle 0, um diese Option zu deaktivieren.');
DEFINE ('_PMS_SETTINGS_RETRACT', 'Zurckziehen von Nachrichten:');
DEFINE ('_PMS_SETTINGS_RETRACT_NO', 'Nein');
DEFINE ('_PMS_SETTINGS_RETRACT_YES', 'Ja');
DEFINE ('_PMS_SETTINGS_RETRACT_UNREAD', 'Ja, wenn ungelesen');
DEFINE ('_PMS_SETTINGS_RETRACT_DESCR', 'Drfen die Benutzer versehentlich verschickte Nachrichten zurckziehen?');
DEFINE ('_PMS_SETTINGS_ADDRESSBOOK', 'Adressbuch:');
DEFINE ('_PMS_SETTINGS_ADDRESSBOOK_DESCR', 'Drfen sich die Benutzer ein Adressbuch anlegen?');
DEFINE ('_PMS_SETTINGS_IGNORELIST', 'Ignorliste:');
DEFINE ('_PMS_SETTINGS_IGNORELIST_DESCR', 'Drfen sich die Benutzer eine Ignorliste anlegen?');
DEFINE ('_PMS_SETTINGS_CB', 'CB-Version:');
DEFINE ('_PMS_SETTINGS_CB_NONE', 'Keine');
DEFINE ('_PMS_SETTINGS_CB_CBSTABLE', 'CB stable');
DEFINE ('_PMS_SETTINGS_CB_CBE', 'CB enhanced');
DEFINE ('_PMS_SETTINGS_CB_DESCR', 'Welche Version des CommunityBuilder ist installiert und soll integriert werden?');
DEFINE ('_PMS_SETTINGS_LAYOUT', 'Menu Layout:');
DEFINE ('_PMS_SETTINGS_LAYOUT_DESCR', 'Sollen im Menu Icons, Textlinks oder beides verwendet werden?');
DEFINE ('_PMS_SETTINGS_LAYOUT_ICON', 'Icon-Links');
DEFINE ('_PMS_SETTINGS_LAYOUT_TEXT', 'Text-Links');
DEFINE ('_PMS_SETTINGS_LAYOUT_ICON_TEXT', 'Icons & Text');
DEFINE ('_PMS_SETTINGS_USERLIST', 'Format Userliste:');
DEFINE ('_PMS_SETTINGS_USERLIST_USERNAME', 'Username');
DEFINE ('_PMS_SETTINGS_USERLIST_NAME', 'Name');
DEFINE ('_PMS_SETTINGS_USERLIST_USERNAME_NAME', 'Username (Name)');
DEFINE ('_PMS_SETTINGS_USERLIST_NAME_USERNAME', 'Name (Username)');
DEFINE ('_PMS_SETTINGS_USERLIST_DESCR', 'In welchem Format sollen die Benutzer in der Auswahlliste dargestellt werden?');
DEFINE ('_PMS_SETTINGS_SMILEY', 'Smilie Support:');
DEFINE ('_PMS_SETTINGS_SMILEY_DESCR', 'Ist die Verwendung von Smilies beim Schreiben von Nachrichten erlaubt?');
DEFINE ('_PMS_SETTINGS_BB_CODE', 'BB-Code Support:');
DEFINE ('_PMS_SETTINGS_BB_CODE_DESCR', 'Ist die Verwendung von BB-Code beim Schreiben neuer Nachrichten erlaubt?');
DEFINE ('_PMS_SETTINGS_WIDTH_RECIPFIELD', 'Breite des Empfngerfeldes:');
DEFINE ('_PMS_SETTINGS_WIDTH_RECIPFIELD_DESCR', 'Wie breit (in Pixel) soll das Feld fr die Empfnger beim Schreiben einer neuen Nachricht sein?');
DEFINE ('_PMS_SETTINGS_WIDTH_MESSAGEFIELDS', 'Breite der Nachrichtenfelder:');
DEFINE ('_PMS_SETTINGS_WIDTH_MESSAGEFIELDS_DESCR', 'Wie breit (in Pixel) soll das Betreff- bzw. Inhaltsfeld beim Schreiben einer neuen Nachricht sein?');
DEFINE ('_PMS_SETTINGS_HEIGHT_MESSAGEFIELD', 'Hhe des Nachrichtenfeldes:');
DEFINE ('_PMS_SETTINGS_HEIGHT_MESSAGEFIELD_DESCR', 'Wie hoch (in Pixel) soll das Inhaltsfeld beim Schreiben einer neuen Nachricht sein?');
DEFINE ('_PMS_SETTINGS_HEIGHT_USERLISTS', 'Hhe der Benutzerlisten:');
DEFINE ('_PMS_SETTINGS_HEIGHT_USERLISTS_DESCR', 'Wie hoch (in Zeilen) sollen die Benutzerlisten sein?');
DEFINE ('_PMS_SETTINGS_USERSEARCH', 'dynamische Benutzersuche:');
DEFINE ('_PMS_SETTINGS_USERSEARCH_DESCR', 'Soll beim manuellen Eingeben eines Benutzers beim Schreiben einer Nachricht die dynamische Benutzersuche aktiviert werden?');
DEFINE ('_PMS_SETTINGS_USERSEARCH_MIN_CHARACTERS', 'min. Zeichenlnge bei Benutzersuche:');
DEFINE ('_PMS_SETTINGS_USERSEARCH_MIN_CHARACTERS_DESCR', 'Ab wievielen Zeichen soll die dynamische Benutzersuche beim manuellen Eingeben eines Benutzers beim Schreiben einer Nachricht aktiviert werden?');
DEFINE ('_PMS_SETTINGS_USERSEARCH_MAX_ROWS', 'max. Treffer bei Benutzersuche:');
DEFINE ('_PMS_SETTINGS_USERSEARCH_MAX_ROWS_DESCR', 'Wieviele Treffer sollen maximal bei der dynamischen Benutzersuche angezeigt werden? Whle 0 fr unbegrenzt.');
DEFINE ('_PMS_SETTINGS_EMAIL_NEW', 'E-Mail bei neuen Nachrichten:');
DEFINE ('_PMS_SETTINGS_EMAIL_NEW_DESCR', 'Mchtest du per E-Mail informiert werden, wenn du eine neue Nachricht erhltst?');
DEFINE ('_PMS_SETTINGS_EMAIL_REPLY', 'E-Mail bei Antwort auf eine Nachricht:');
DEFINE ('_PMS_SETTINGS_EMAIL_REPLY_DESCR', 'Mchtest du per E-Mail informiert werden, wenn du eine Antwort auf eine Nachricht erhltst?');
DEFINE ('_PMS_SETTINGS_EMAIL_FORMAT', 'E-Mail Format:');
DEFINE ('_PMS_SETTINGS_EMAIL_FORMAT_TEXT', 'Text');
DEFINE ('_PMS_SETTINGS_EMAIL_FORMAT_HTML', 'HTML');
DEFINE ('_PMS_SETTINGS_EMAIL_FORMAT_DESCR', 'Soll die E-Mail im HTML-Format oder als reine Text E-Mail verschickt werden?');
DEFINE ('_PMS_SETTINGS_OFFLINE', 'E-Mail Benachrichtigung nur wenn offline:');
DEFINE ('_PMS_SETTINGS_OFFLINE_DESCR', 'Soll bei aktivierter E-Mail Benachrichtigung diese nur versendet werden, wenn du offline bist?');
DEFINE ('_PMS_SETTINGS_REPLY', 'Formatierung der Antwort:');
DEFINE ('_PMS_SETTINGS_REPLY_DESCR', 'Soll beim Antworten auf Nachrichten die ursprngliche Nachricht angehngt werden und wenn ja, in welchem Format?');
DEFINE ('_PMS_SETTINGS_REPLY_WITHOUT', 'nicht anhngen');
DEFINE ('_PMS_SETTINGS_REPLY_WITH', 'normal anhngen');
DEFINE ('_PMS_SETTINGS_REPLY_ITALIC', 'kursiv anhngen');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS', 'Postausgang automatisch aufrumen:');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS_NO', 'Nein');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS_TRASH', 'in Papierkorb verschieben');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS_DELETE', 'endgltig lschen');
DEFINE ('_PMS_SETTINGS_CLEAR_SENT_ITEMS_DESCR', 'Sollen Nachrichten, welche vom Empfnger gelesen wurden, automatisch in den Papierkorb verschoben oder endgltig gelscht werden?');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_POPUP', 'Popup bei neuen Nachrichten');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_POPUP_DESCR', 'Soll der Benutzer via Popup benachrichtigt werden, wenn er neue Nachrichten erhlt?');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_SOUND', 'Popup mit Sound');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_SOUND_DESCR', 'Soll beim Erscheinen des Popups ein Sound abgespielt werden?');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_SOUND_VALUE', 'Sound Datei');
DEFINE ('_PMS_SETTINGS_PMSNOTIFY_SOUND_VALUE_DESCR', 'Welcher Sound soll beim Erscheinen des Popups abgespielt werden?');
DEFINE ('_PMS_SETTINGS_ROWS', 'Anzahl Nachrichten pro Seite:');
DEFINE ('_PMS_SETTINGS_ROWS_DESCR', 'Wieviele Nachrichten sollen auf einer Seite angezeigt werden?');
DEFINE ('_PMS_SETTINGS_PAGES', 'Anzahl Seiten im Menu:');
DEFINE ('_PMS_SETTINGS_PAGES_DESCR', 'Wieviele Seiten sollen ber einen direkten Link im Menu erreicht werden?');
DEFINE ('_PMS_SETTINGS_SAVE', 'Einstellungen speichern');
DEFINE ('_PMS_SETTINGS_INVALID_VALUES', 'Folgende Felder enthalten ungltige Werte:');

// definitions for backend (view/edit/new)
DEFINE ('_PMS_BACKEND_RESULTS_PER_PAGE', 'Anzahl Treffer pro Seite:');
DEFINE ('_PMS_BACKEND_FILTER', 'Filter');
DEFINE ('_PMS_BACKEND_FILTER_BUTTON', 'Filter anwenden');
DEFINE ('_PMS_BACKEND_DATE_FROM', 'Datum von<br />(TT.MM.JJJJ):');
DEFINE ('_PMS_BACKEND_DATE_TILL', 'Datum bis<br />(TT.MM.JJJJ):');
DEFINE ('_PMS_BACKEND_DROPDOWN_NONE', '---');
DEFINE ('_PMS_BACKEND_STATUS_SENDER', 'Ablage beim Absender');
DEFINE ('_PMS_BACKEND_STATUS_RECIPIENT', 'Ablage beim Empfnger');
DEFINE ('_PMS_BACKEND_DELETED', 'endgltig gelscht');
DEFINE ('_PMS_BACKEND_PM_NEW', 'Nachricht hinzufgen');
DEFINE ('_PMS_BACKEND_PM_EDIT', 'Nachricht editieren');
DEFINE ('_PMS_BACKEND_VALID_DATE', 'Geben Sie bitte ein gltiges Datum ein!');
DEFINE ('_PMS_BACKEND_VALID_NO_USERS', 'Whlen Sie bitte einen Benutzer aus der Absender- und Empfngerliste!');
DEFINE ('_PMS_BACKEND_VALID_SAME_USERS', 'Whlen Sie bitte zwei unterschiedliche Benutzer fr Absender und Empfnger!');
DEFINE ('_PMS_BACKEND_VALID_NO_MESSAGE', 'Geben Sie bitte einen Inhalt ein!');
DEFINE ('_PMS_BACKEND_NOT_ADMIN', 'Sie sind nicht berechtigt, Nachrichten zu lesen oder zu bearbeiten!');

// limit of PMs
DEFINE ('_PMS_STATUS_BAR', 'Sie haben %s von maximal %s erlaubten Nachrichten gespeichert.');
DEFINE ('_PMS_STATUS_BAR_WARNING', '!!!ACHTUNG!!!<br />Sie haben die maximale Anzahl von %s erlaubten Nachrichten erreicht oder berschritten. Zur Zeit knnen Sie keine Nachrichten versenden oder empfangen. Bitte lschen Sie einige Ihrer Nachrichten.');
DEFINE ('_PMS_NEW_WARNING', 'Zur Zeit knnen Sie keine Nachrichten versenden. Bitte lschen Sie einige Ihrer Nachrichten.');

// email notification
DEFINE ("_PMS_EMAIL_SUBJECT_NEW","%s - Neue private Nachricht von %s");
DEFINE ("_PMS_EMAIL_SUBJECT_REPLY","%s - Antwort auf Ihre private Nachricht von %s");
DEFINE ("_PMS_EMAIL_MESSAGE_NEW_TEXT","Hallo %s,\r\nSie haben eine neue Nachricht von %s auf %s erhalten.\r\n\r\nBetreff: %s\r\nInhalt:\r\n%s\r\n\r\nGru,\r\n%s");
DEFINE ("_PMS_EMAIL_MESSAGE_NEW_HTML","<html><body>Hallo %s,<br />Sie haben eine neue private Nachricht von %s auf %s erhalten.<br /><br /><b>Betreff:</b> %s<br /><b>Inhalt:</b><br />%s<br /><br />Gru,<br />%s</body></html>");
DEFINE ("_PMS_EMAIL_MESSAGE_REPLY_TEXT","Hallo %s,\r\nSie haben eine Antwort auf Ihre private Nachricht von %s auf %s erhalten.\r\n\r\nBetreff: %s\r\nInhalt:\r\n%s\r\n\r\nGru,\r\n%s");
DEFINE ("_PMS_EMAIL_MESSAGE_REPLY_HTML","<html><body>Hallo %s,<br />Sie haben eine Antwort auf Ihre private Nachricht von %s auf %s erhalten.<br /><br /><b>Betreff:</b> %s<br /><b>Inhalt:</b><br />%s<br /><br />Gru,<br />%s</body></html>");

// definition for about
DEFINE ('_PMS_BACKEND_ABOUT_TITLE', 'Info');
DEFINE ('_PMS_BACKEND_ABOUT_SUGGESTION', 'Ihre Meinung');
DEFINE ('_PMS_BACKEND_ABOUT_NAME', 'Name:');
DEFINE ('_PMS_BACKEND_ABOUT_MAIL', 'E-Mail:');
DEFINE ('_PMS_BACKEND_ABOUT_SENT', 'abschicken');
DEFINE ('_PMS_BACKEND_ABOUT_VALIDATE', 'Fllen Sie bitte alle Felder aus!');
DEFINE ('_PMS_BACKEND_ABOUT_TEXT', 'Titel: PMS enhanced<br />
Beschreibung: Ein Private Messaging System (PMS) fr Mambo/Joomla<br />
Author: Stefan Klingner (Original Danial Taherzadeh)<br />
Version: 2.0.3<br />
Erstellt: 04.12.2006<br />
Lizenz: GNU/GPL (basierend auf myPMS OpenSource vom April 2005)<br /><br /><br />
Wenn Sie Kritik, Ideen oder Fehler zu dieser Komponente haben, knnen Sie mich gerne ber links stehendes Formular kontaktieren.<br />Alternativ knnen Sie auch <a href="http://www.stefan-klingner.de/index.php?option=com_joomlaboard&Itemid=13" target="_blank">mein Forum</a> auf <a href="http://www.stefan-klingner.de" target="_blank">www.stefan-klingner.de</a> besuchen.<br />Die aktuellste Version finden Sie ebenfalls auf meiner Seite <a href="http://www.stefan-klingner.de/index.php?option=com_docman&Itemid=8" target="_blank">im Downloadbereich</a>.');

// messages for mosRedirect
DEFINE ('_PMS_MSG_SENT', 'Ihre Nachricht wurde gesendet.');
DEFINE ('_PMS_MSG_SENT_MULTIPLE', 'Ihre Nachricht wurde an alle gesendet.');
DEFINE ('_PMS_MSG_SENT_ERROR', 'Ihre Nachricht konnte nicht gesendet werden.');
DEFINE ('_PMS_MSG_SENT_ERROR_MULTIPLE', '%s von %s Nachrichten konnten nicht gesendet werden.');
DEFINE ('_PMS_MSG_SENT_ERROR_INVALID_USER', 'Mindestens ein Benutzer ist ungltig.');
DEFINE ('_PMS_MSG_REPLY_SENT', 'Ihre Antwort wurde gesendet.');
DEFINE ('_PMS_MSG_TRASHED', 'Ihre Nachricht wurde in den Papierkorb verschoben.');
DEFINE ('_PMS_MSG_TRASHED_ERROR', 'Deine Nachricht konnte nicht in den Papierkorb verschoben werden.');
DEFINE ('_PMS_MSG_TRASHED_MULTIPLE', 'Ihre Nachrichten wurden in den Papierkorb verschoben.');
DEFINE ('_PMS_MSG_TRASHED_MULTIPLE_ERROR', 'Deine Nachrichten konnten nicht in den Papierkorb verschoben werden.');
DEFINE ('_PMS_MSG_DELETED', 'Ihre Nachricht wurde endgltig gelscht.');
DEFINE ('_PMS_MSG_DELETED_ERROR', 'Deine Nachricht konnte nicht endgltig gelscht werden.');
DEFINE ('_PMS_MSG_DELETED_MULTIPLE', 'Ihre Nachrichten wurden endgltig gelscht.');
DEFINE ('_PMS_MSG_DELETED_MULTIPLE_ERROR', 'Deine Nachrichten konnten nicht endgltig gelscht werden.');
DEFINE ('_PMS_MSG_RECYCLED', 'Ihre Nachricht wurde wiederhergestellt.');
DEFINE ('_PMS_MSG_RECYCLED_ERROR', 'Deine Nachricht konnte nicht wiederhergestellt werden.');
DEFINE ('_PMS_MSG_RECYCLED_MULTIPLE', 'Ihre Nachrichten wurden wiederhergestellt.');
DEFINE ('_PMS_MSG_RECYCLED_MULTIPLE_ERROR', 'Deine Nachrichten konnten nicht wiederhergestellt werden.');
DEFINE ('_PMS_MSG_RETRACTED', 'Ihre Nachricht wurde zurckgezogen.');
DEFINE ('_PMS_MSG_RETRACTED_ERROR', 'Ihre Nachricht konnte nicht zurckgezogen werden.');
DEFINE ('_PMS_MSG_RETRACTED_MULTIPLE', 'Ihre Nachrichten wurden zurckgezogen.');
DEFINE ('_PMS_MSG_RETRACTED_MULTIPLE_ERROR', 'Ihre Nachrichten konnten nicht zurckgezogen werden.');
DEFINE ('_PMS_MSG_RETRACTED_FORBIDDEN', 'Ihre Nachricht darf nicht mehr zurckgezogen werden.');
DEFINE ('_PMS_MSG_RETRACTED_MULTIPLE_FORBIDDEN_SOME', 'Einige Ihrer Nachrichten drfen nicht mehr zurckgezogen werden.');
DEFINE ('_PMS_MSG_RETRACTED_MULTIPLE_FORBIDDEN_ALL', 'Ihre Nachrichten drfen nicht mehr zurckgezogen werden.');
DEFINE ('_PMS_MSG_SAVE_SETTINGS_ALL', 'Ihre Einstellungen wurden gespeichert.');
DEFINE ('_PMS_MSG_SAVE_SETTINGS_FILE', 'Nur die Einstellungen in der Konfigurationsdatei konnten gespeichert werden.');
DEFINE ('_PMS_MSG_SAVE_SETTINGS_DB', 'Nur die Einstellungen in der Datenbank konnten gespeichert werden.');
DEFINE ('_PMS_MSG_SAVE_SETTINGS_ERROR', 'Ihre Einstellungen konnten nicht gespeichert werden.');
DEFINE ('_PMS_MSG_ABOUT_SENT_OK', 'Ihre Meinung wurde erfolgreich versendet.');
DEFINE ('_PMS_MSG_ABOUT_SENT_ERROR', 'Ihre Meinung konnte nicht versendet werden.');
DEFINE ('_PMS_MSG_SAVE_NEW', 'Die Nachricht wurde gespeichert.');
DEFINE ('_PMS_MSG_SAVE_NEW_ERROR', 'Die Nachricht wurde nicht gespeichert.');
DEFINE ('_PMS_MSG_SAVE_UPDATE', 'Die Nachricht wurde aktualisiert.');
DEFINE ('_PMS_MSG_SAVE_UPDATE_ERROR', 'Die Nachricht wurde nicht aktualisiert.');
DEFINE ('_PMS_MSG_SAVE_ADDRESSBOOK', 'Ihre nderung am Adressbuch wurde gespeichert.');
DEFINE ('_PMS_MSG_SAVE_ADDRESSBOOK_ERROR', 'Ihre nderung am Adressbuch konnte nicht gespeichert werden.');
DEFINE ('_PMS_MSG_SAVE_IGNORELIST', 'Ihre nderung an der Ignorliste wurde gespeichert.');
DEFINE ('_PMS_MSG_SAVE_IGNORELIST_ERROR', 'Ihre nderung an der Ignorliste konnte nicht gespeichert werden.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_NO_BUDDY', 'Sie haben keine Buddies angelegt.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_ALL', 'Ihre Buddies wurden importiert.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_SOME', 'Einige Ihrer Buddies drfen nicht importiert werden.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_NONE', 'Ihre Buddies drfen nicht importiert werden.');
DEFINE ('_PMS_MSG_ADDRESSBOOK_IMPORT_ERROR', 'Ihre Buddies konnten nicht importiert werden.');
?>