<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

if($pm_all >= $max_allowed_pm)
{
?>
	<span style="color: red; font-weight: bold;">
		<?php echo sprintf(_PMS_STATUS_BAR_WARNING, $max_allowed_pm); ?>
	</span>
	<br />
	<br />
<?php
}
else
{
	echo sprintf(_PMS_STATUS_BAR, $pm_all, $max_allowed_pm);
?>
	<table width="100%" cellspacing="1" cellpadding="0">
	<tr>
		<td width="<?php echo $pm_all * 100 / $max_allowed_pm; ?>%" height="15px" bgcolor="red">
		</td>
		<td width="<?php echo ($max_allowed_pm - $pm_all) * 100 / $max_allowed_pm; ?>%" height="15px" bgcolor="green">
		</td>
	</tr>
	</table>
	<br />
<?php
}
?>
