<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$mainframe->appendPathWay(_PMS_READ);

?>

<table width="100%" cellpadding="0" cellspacing="0" border="0" align="center" class="contentpane">
<tr>
	<td colspan="2">
		<span class="contentheading">
			<?php	echo _PMS_TITLE; ?>:&nbsp;<?php echo _PMS_READ; ?>
		</span>
	</td>
</tr>
</table>

<?php
$pm_id = mosGetParam($_GET, 'id');
$pm_id = intval($pm_id);
$database->setQuery("SELECT recip_id, sender_id, inbox, sent_items FROM #__pms WHERE id=$pm_id");
if(!$database->query()) pms_sql_error($database->getErrorMsg());
$result=$database->query();
$row = mysql_fetch_assoc($result);
$opener = false;
if($my_id==$row['recip_id'] AND $row['inbox']==1) $opener = "inbox";
if($my_id==$row['sender_id'] AND $row['sent_items']==1) $opener = "sent_items";
if(($my_id==$row['recip_id'] AND $row['inbox']==0) OR ($my_id==$row['sender_id'] AND $row['sent_items']==0)) $opener = "trash";
if($my_id==$row['recip_id'] AND $row['inbox']==0) $trash_from_inbox = true;

if($opener=="inbox") $base_url_param = "?option=com_pms&Itemid=".$pms_menuid."&page=inbox";
elseif($opener=="sent_items") $base_url_param = "?option=com_pms&Itemid=".$pms_menuid."&page=sent_items";
elseif($opener=="trash") $base_url_param = "?option=com_pms&Itemid=".$pms_menuid."&page=trash";

if($opener)
{
	$database->setQuery("SELECT t1.id, DATE_FORMAT(t1.date, '%d.%m.%Y') AS sentdate, t1.time, t1.readstate, t1.subject, t1.message, t2.username AS recip_username, t2.name AS recip_name, t3.username AS sender_username, t3.name AS sender_name FROM #__pms AS t1, #__users AS t2, #__users AS t3 WHERE t1.id=$pm_id AND t2.id=t1.recip_id AND t3.id=t1.sender_id");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$pm_values = $database->query();
	$row_pm_values = mysql_fetch_assoc($pm_values);
	$total = $database->loadResult();
	if($cb_version>0)
	{
		$database->setQuery("SELECT t1.avatar AS recip_avatar, t1.avatarapproved AS recip_avatarapproved, t2.avatar AS sender_avatar, t2.avatarapproved AS sender_avatarapproved FROM #__comprofiler AS t1, #__comprofiler AS t2, #__pms AS t3 WHERE t3.id=$pm_id AND t1.user_id=t3.recip_id AND t2.user_id=t3.sender_id");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$avatars = $database->query();
		$row_avatars = mysql_fetch_assoc($avatars);
	}
}

if($total<1 OR !$opener) echo _PMS_READ_DENIED;
else
{
	$action = mosGetParam($_GET, 'action');
	$action = $database->getEscaped($action);
	if($action=="to_trash")
	{
		if($opener=="inbox") $query = "UPDATE #__pms SET inbox=0 WHERE id=$pm_id";
		if($opener=="sent_items") $query = "UPDATE #__pms SET sent_items=0 WHERE id=$pm_id";
		$database->setQuery($query);
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			$mosmsg = _PMS_MSG_TRASHED_ERROR;
		}
		else $mosmsg = _PMS_MSG_TRASHED;
		mosRedirect('index.php'.$base_url_param.'&mosmsg='.$mosmsg);
	}
	if($action=="retract")
	{
		$database->setQuery("SELECT readstate FROM #__pms WHERE id=$pm_id LIMIT 1");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$readstate = $database->loadResult();
		if($retract==1 OR ($retract==2 AND $readstate%2==0))
		{
			$database->setQuery("DELETE FROM #__pms WHERE id=$pm_id");
			if(!$database->query())
			{
				pms_sql_error($database->getErrorMsg());
				$mosmsg = _PMS_MSG_RETRACTED_ERROR;
			}
			else $mosmsg = _PMS_MSG_RETRACTED;
		}
		else $mosmsg = _PMS_MSG_RETRACTED_FORBIDDEN;
		mosRedirect('index.php'.$base_url_param.'&mosmsg='.$mosmsg);
	}
	if($action=="delete")
	{
		if($trash_from_inbox OR $opener=="inbox") $pm_delete = "UPDATE #__pms SET inbox=-1 WHERE id=$pm_id";
		else $pm_delete = "UPDATE #__pms SET sent_items=-1 WHERE id=$pm_id";
		$database->setQuery($pm_delete);
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			$mosmsg = _PMS_MSG_DELETED_ERROR;
		}
		else $mosmsg = _PMS_MSG_DELETED;
		$database->setQuery("DELETE FROM #__pms WHERE inbox=-1 AND sent_items=-1");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		mosRedirect('index.php'.$base_url_param.'&mosmsg='.$mosmsg);
	}
	if($action=="recycle")
	{
		if($trash_from_inbox) $pm_recycle = "UPDATE #__pms SET inbox=1 WHERE id=$pm_id";
		else $pm_recycle = "UPDATE #__pms SET sent_items=1 WHERE id=$pm_id";
		$database->setQuery($pm_recycle);
		if(!$database->query())
		{
			pms_sql_error($database->getErrorMsg());
			$mosmsg = _PMS_MSG_RECYCLED_ERROR;
		}
		else $mosmsg = _PMS_MSG_RECYCLED;
		mosRedirect('index.php'.$base_url_param.'&mosmsg='.$mosmsg);
	}
	
	// if installed check for cb-avatar and display if valid
	if($cb_version>0)
	{
		$sender_avatar = "";
		$recip_avatar = "";
		if($row_avatars['sender_avatar']!=NULL AND $row_avatars['sender_avatar']!="" AND $row_avatars['sender_avatarapproved']==1)
		{
			if(strpos($row_avatars['sender_avatar'],"gallery/")===false) $img = "images/comprofiler/tn".$row_avatars['sender_avatar'];
			else $img = "images/comprofiler/".$row_avatars['sender_avatar'];
			$sender_avatar = '<br /><img src="'.$img.'" border="0" alt="'.$row_avatars['sender_avatar'].'" title="'.$row_avatars['sender_avatar'].'" />';
		}
		if($row_avatars['recip_avatar']!=NULL AND $row_avatars['recip_avatar']!="" AND $row_avatars['recip_avatarapproved']==1)
		{
			if(strpos($row_avatars['recip_avatar'],"gallery/")===false) $img = "images/comprofiler/tn".$row_avatars['recip_avatar'];
			else $img = "images/comprofiler/".$row_avatars['recip_avatar'];
			$recip_avatar = '<br /><img src="'.$img.'" border="0" alt="'.$row_avatars['recip_avatar'].'" title="'.$row_avatars['recip_avatar'].'" />';
		}
	}
	?>
	<table cellspacing="1" cellpadding="4" border="0" width="100%" class="contentpane">
	<tr>
		<th class="sectiontableheader" colspan="3" align="right">
			<b><?php echo _PMS_DATETIME; ?>:</b>&nbsp;<?php echo $row_pm_values['sentdate'].'&nbsp;'._PMS_AT.'&nbsp;'.$row_pm_values['time']; ?>
		</th>
	</tr>
	<?php
	if($opener=="inbox" OR $opener=="trash")
	{
	?>
	<tr class="sectiontableentry2">
		<td valign="top">
			<b><?php echo _PMS_SENDER; ?>:</b>
		</td>
		<td width="100%">
			<?php
			if($cb_version>0)
			{
			?>
			<a href="index.php?option=com_comprofiler&task=userProfile&user=<?php echo $row['sender_id']; ?>&Itemid=<?php echo $cb_menuid; ?>"><?php echo ($userlist==0 OR $userlist==2) ? $row_pm_values['sender_username'] : $row_pm_values['sender_name']; ?></a>
			<?php
			echo $sender_avatar;
			}
			else echo ($userlist==0 OR $userlist==2) ? $row_pm_values['sender_username'] : $row_pm_values['sender_name'];
			?>
		</td>
	</tr>
	<?php
	}
	if($opener=="sent_items" OR $opener=="trash")
	{
	?>
	<tr class="sectiontableentry2">
		<td valign="top">
			<b><?php echo _PMS_RECIP; ?>:</b>
		</td>
		<td width="100%">
			<?php
			if($cb_version>0)
			{
			?>
			<a href="index.php?option=com_comprofiler&task=userProfile&user=<?php echo $row['recip_id']; ?>&Itemid=<?php echo $cb_menuid; ?>"><?php echo ($userlist==0 OR $userlist==2) ? $row_pm_values['recip_username'] : $row_pm_values['recip_name']; ?></a>
			<?php
			echo $recip_avatar;
			}
			else echo ($userlist==0 OR $userlist==2) ? $row_pm_values['recip_username'] : $row_pm_values['recip_name'];
			?>
		</td>
	</tr>
	<?php
	}
	?>
	<tr class="sectiontableentry1">
		<td>
			<b><?php echo _PMS_SUBJECT; ?>:</b>
		</td>
		<td width="100%">
			<?php 
				if(!get_magic_quotes_gpc()) echo pms_parse(stripslashes($row_pm_values['subject']));
				else echo pms_parse($row_pm_values['subject']);
			?>
		</td>
	</tr>
	<tr class="sectiontableentry2">
		<td valign="top">
			<b><?php echo _PMS_MESSAGE; ?>:</b>
		</td>
		<td width="100%">
			<?php
				if(!get_magic_quotes_gpc()) echo pms_parse(stripslashes($row_pm_values['message']));
				else echo pms_parse($row_pm_values['message']);
			?>
		</td>
	</tr>
	<tr>
		<td colspan="2" align="right">
		<?php
		if($opener=="inbox")
		{
		?>
			<a href="index.php?option=com_pms&page=reply&Itemid=<?php echo $pms_menuid; ?>&id=<?php echo $pm_id; ?>" />
				<img src="components/com_pms/images/reply.png" border="0" alt="<?php echo _PMS_REPLY; ?>" title="<?php echo _PMS_REPLY; ?>" />
			</a>
			<a href="index.php?option=com_pms&page=forward&Itemid=<?php echo $pms_menuid; ?>&id=<?php echo $pm_id; ?>" />
				<img src="components/com_pms/images/forward.png" border="0" alt="<?php echo _PMS_FORWARD; ?>" title="<?php echo _PMS_FORWARD; ?>" />
			</a>
		<?php
		}
		if($opener=="trash")
		{
		?>
			<a href="index.php?option=com_pms&page=open&Itemid=<?php echo $pms_menuid; ?>&id=<?php echo $pm_id; ?>&action=recycle" />
				<img src="components/com_pms/images/recycle.png" border="0" alt="<?php echo _PMS_RECYCLE; ?>" title="<?php echo _PMS_RECYCLE; ?>" />
			</a>
		<?php
		}
		if(($opener=="sent_items" OR $opener=="trash") AND ($retract==1 OR ($retract==2 AND $row_pm_values['readstate']%2==0)))
		{
			if($retract==1 AND $row_pm_values['readstate']%2==1) $retract_img = "retract_read.png";
			else $retract_img = "retract_unread.png";
		?>
			<a href="index.php?option=com_pms&page=open&Itemid=<?php echo $pms_menuid; ?>&id=<?php echo $pm_id; ?>&action=retract" />
				<img src="components/com_pms/images/<?php echo $retract_img; ?>" border="0" alt="<?php echo _PMS_RETRACT; ?>" title="<?php echo _PMS_RETRACT; ?>" />
			</a>
		<?php
		}
		if($opener=="inbox" OR $opener=="sent_items")
		{
		?>
			<a href="index.php?option=com_pms&page=open&Itemid=<?php echo $pms_menuid; ?>&id=<?php echo $pm_id; ?>&action=to_trash" />
				<img src="components/com_pms/images/trash.png" border="0" alt="<?php echo _PMS_TO_TRASH; ?>" title="<?php echo _PMS_TO_TRASH; ?>" />
			</a>
		<?php
		}
		?>
			<a href="index.php?option=com_pms&page=open&Itemid=<?php echo $pms_menuid; ?>&id=<?php echo $pm_id; ?>&action=delete" />
				<img src="components/com_pms/images/delete.png" border="0" alt="<?php echo _PMS_DELETE; ?>" title="<?php echo _PMS_DELETE; ?>" />
			</a>
		</td>
	</tr>
	</table>
	<?php
		
	// update readstate
	if($row_pm_values['readstate']%2==0 AND ($opener=="inbox" OR ($opener=="trash" AND strtolower($my->username)==strtolower($row_pm_values['recip_username']))))
	{
		$id = $row_pm_values['id'];
		$readstate = $row_pm_values['readstate'] + 1;
		$database->setQuery("UPDATE #__pms SET readstate=$readstate, pmsnotify=1 WHERE id=$id");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
	}
	
	// update sent_items of sender
	$sender_id = $row['sender_id'];

	// check if sender has an own config
	$database->setQuery("SELECT count(id) FROM #__pms_conf WHERE user_id=$sender_id");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$result = $database->loadResult();

	// if yes take the sender value
	if($result==1) $query = "SELECT clear_sent_items FROM #__pms_conf WHERE user_id=$sender_id LIMIT 1";
	// else take the admin value
	else $query = "SELECT clear_sent_items FROM #__pms_conf WHERE user_id=0 LIMIT 1";

	// load value
	$database->setQuery($query);
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$clear_sent_items = $database->loadResult();

	$database->setQuery("UPDATE #__pms SET sent_items=$clear_sent_items WHERE id=$pm_id AND sent_items=1 AND recip_id=$my_id");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
}
?>