<?php

/*
	XML-RPC Komponente - Joomla! PMS- Center
	Author: 	Tobias Burggraf
			http://www.joomlascripts.de
	Version: 	1.0.0
	
	Note: this class is part of the Joomla! PMS- Center package. Its licenced unter the GPL.
	Please, dont remove this copyright!
*/
require_once 'Server.php';
require_once 'ipblock.php';

//+++++++++++++++++ XML- RPC Server +++++++++++++++++++++

$server = new XML_RPC_Server(
    array(
        'function_delXMLFile' => array('function' => 'delXMLFile'),
        'function_writeNewMessage' => array('function' => 'writeNewMessage'),
        'function_getFileHash' => array('function' => 'getFileHash'),
        'function_getVersion' => array('function' => 'getVersion'),
        'function_setMessageReadState' => array('function' => 'setMessageReadState'),
        'function_replyMessage' => array('function' => 'replyMessage'),
        'function_deleteMessage' => array('function' => 'deleteMessage'),
        'function_getOnlineUser' => array('function' => 'getOnlineUser'),
        'function_getConfig' => array('function' => 'getConfig'),
        'function_getUserConfig' => array('function' => 'getUserConfig'),
        'function_getUserList' => array('function' => 'getUserList'),
        'function_countAllMessages' => array('function' => 'countAllMessages'),
        'function_getBuddyList' => array('function' => 'getBuddyList'),
        'function_checkVersion' => array('function' => 'checkVersion'),
        'function_checkLoginData' => array('function' => 'checkLoginData'),
        'function_isAlive' => array('function' => 'isAlive')
    ),
    1 // serviceNow
);

//-------------------------- einzelne Funktionen --------------------------------------

function delXMLFile($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->delXMLFile($params);
}

function writeNewMessage($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->insertNewMessage($params);
}

function getFileHash($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->getFileHash($params);
}

function getVersion($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->getVersion($params);
}

function setMessageReadState($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->setMessageReadState($params);
}

function replyMessage($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->replyMessage($params);
}

function deleteMessage($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->deleteMessage($params);
}

function getOnlineUser($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->getOnlineUser($params);
}

function getConfig($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->getConfig($params);
}

function getUserConfig($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->getUserConfig($params);
}

function getUserList($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->getUserList($params);
}

function countAllMessages($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->countAllMessages($params);
}

function getBuddyList($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->getBuddyList();
}

function checkVersion($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->checkVersion($params);
}
function checkLoginData($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->checkLoginData($params);
}

function isAlive($params) {
	$obj = new PMSActions($_REQUEST['username'], $_REQUEST['password']);
    	return $obj->isAlive($params);
}
//------------------------------------- Klassen --------------------------------------------

// <-- Datenbankverbindung --->
class DBConnection  {
    // Aufbau der DB Verbindung
    function DBConnection($host, $username, $password, $db) {
      mysql_connect($host, $username, $password) or die
      ("Keine Verbindung moeglich");
      mysql_select_db($db) or die
      ("Die Datenbank existiert nicht");
    }
}

// <-- Zugangsdaten--->
class Zugangsdaten {
		 // Quote variable to make safe
	 function quote_smart($value)
	 {
	    // Stripslashes
	    if (get_magic_quotes_gpc()) {
	        $value = stripslashes($value);
	    }
	    // Quote if not a number or a numeric string
	    if (!is_numeric($value)) {
	        $value = "'" . mysql_real_escape_string($value) . "'";
	    }
	    return $value;
	 }
	var $db_prefix;
	function Zugangsdaten() {
		require '../../../configuration.php';
 		$dbConnection = new DBConnection($mosConfig_host,$mosConfig_user,$mosConfig_password,$mosConfig_db);
 		$this->db_prefix = $mosConfig_dbprefix;
	}

	function checkZugangsdaten($action) {
	// MessageReadState kann mehrmals ausgefhrt werden!
		if(strcmp($action,"setMessageReadState") == -1 && strcmp($action,"deleteMessage") == -1 && strcmp($action,"replyMessage") == -1  && strcmp($action,"insertNewMessage") == -1  ) {

            $ip = get_ip();
            // make unix-timestamp
            $timestamp = mktime ();
            // function against to many request... only 1 per second for each function from 1 ip!
            // check ip in textfile- if ip is used => return false
            if (!check_it ($ip, $timestamp, $action)) return false;
		}

		// Zusammensetzen des Querys
		$username = addslashes($_REQUEST['username']);
		$password = addslashes($_REQUEST['password']);
		$ergebnis = mysql_query($queryPMS);
	 	$query = "SELECT * FROM " . $this->db_prefix . "users WHERE username=" . $this->quote_smart($username) ." AND password=" . $this->quote_smart($password) . " and block='0' ";
	 	$userErg = mysql_query($query);
		if(mysql_numrows($userErg) == 0) return false;
		else return true;
	}
}

// <-- PMS- Action --->
class PMSActions {

	// Anlegen bentigter Variablen
	var $dbConnection;
	var $username;
	var $password;
	var $zugangsdaten;
	var $pathConfig = '../../../administrator/components/com_pms/config.pms.php';
	var $db_prefix;

    function PMSActions($username, $password) {
		require '../../../configuration.php';
    	$this->username = $username;
    	$this->password = $password;
    	$this->zugangsdaten = new Zugangsdaten();
    	$this->db_prefix = $mosConfig_dbprefix;
    }
    
	 // Quote variable to make safe
	 function quote_smart($value)
	 {
	    // Stripslashes
	    if (get_magic_quotes_gpc()) {
	        $value = stripslashes($value);
	    }
	    // Quote if not a number or a numeric string
	    if (!is_numeric($value)) {
	        $value = "'" . mysql_real_escape_string($value) . "'";
	    }
	    return $value;
	 }
 


	/**
	* berprfen der Zugangsdaten
	*/
	function checkLoginData() {
		if($this->zugangsdaten->checkZugangsdaten("checkLoginData")) {
			return new XML_RPC_Response(new XML_RPC_Value("true", 'boolean'));
		}
	else return new XML_RPC_Response(new XML_RPC_Value("false", 'boolean'));
	}

	/**
	* ist Server bereit
	*/
	function isAlive() {
		return new XML_RPC_Response(new XML_RPC_Value("true", 'boolean'));
	}

   /*
    * Ermittelt MD5- Hash der Nachrichtendatei
    *
    */
    function getFileHash($params) {
        if($this->zugangsdaten->checkZugangsdaten("getFileHash")) {
    		$password = $params->getParam(0);
    		$password = $password->scalarval();
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
    	if(file_exists($password . ".xml")) {
  		return new XML_RPC_Response(new XML_RPC_Value(md5_file($password . ".xml"), 'string'));
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10003",'string'));
    }

	/*
	 * Benutzerliste generieren
	 *
	 */
    function getUserList($params) {
        if($this->zugangsdaten->checkZugangsdaten("getUserList")) {
    		$absender = $params->getParam(0);
    		$absender = $this->quote_smart($absender->scalarval());
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
    	// einbinden der PMSconfig
 		require $this->pathConfig;

        if($userlist==0 OR $userlist==2) $order = "ORDER BY t1.username";
        if($userlist==1 OR $userlist==3) $order = "ORDER BY t1.name";

 		if($cb_version>0) $query="SELECT t1.id,t1.username,t1.name FROM " . $this->db_prefix . "users AS t1, ". $this->db_prefix ."comprofiler AS t2 WHERE t1.block!=1 AND t2.approved=1 AND t2.confirmed=1 AND t1.id!=" . $this->quote_smart($absender). " AND t1.id=t2.user_id AND t1.gid IN (".$usergroupids.") $where_filter $order";
		else $query="SELECT t1.id,t1.username,t1.name FROM ". $this->db_prefix ."users AS t1 WHERE t1.block!=1 " . $order;

        $result = mysql_query($query);
        $userNames = array();
        $bigArray = array();
        while($row = mysql_fetch_object($result)){

            $userNames[0] = new XML_RPC_Value($row->id, "string");
            $userNames[1] = new XML_RPC_Value($row->username, "string");
            $userNames[2] = new XML_RPC_Value($row->name, "string");

            $bigArray[] = new XML_RPC_Value($userNames, 'array');
        }

        return new XML_RPC_RESPONSE( new XML_RPC_Value($bigArray, 'array'));
    }

    /*
     * Liefert die fr den Benutzer gltigen Einstellungen
     */
    function getUserConfig($params) {
        if($this->zugangsdaten->checkZugangsdaten("getUserConfig")) {
    		$absender = $params->getParam(0);
    		$absender = $absender->scalarval();
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));

        $sql = 'SELECT email_new,`email_reply`,`email_html`,`email_offline`,`format_reply` FROM ' . $this->db_prefix . 'pms_conf WHERE user_id=' . $this->quote_smart($absender) .' LIMIT 0, 30 ';

        //wenn keine Benutzereinstellungen hinterlegt => Mastereinstellung abrufen
        $result = mysql_query($sql);
        if(mysql_numrows($result) == 0) {
        	$absender = 0;
        	$sql = 'SELECT email_new,`email_reply`,`email_html`,`email_offline`,`format_reply` FROM ' . $this->db_prefix . 'pms_conf WHERE user_id=' . $this->quote_smart($absender) .' LIMIT 0, 30 ';
        	$result = mysql_query($sql);
        }


        $row = mysql_fetch_object($result);
        $myStruct =         array(
    		"eMailNew" => new XML_RPC_Value($row->email_new,"int"),
    		"eMailReply" => new XML_RPC_Value($row->email_reply,"int"),
    		"eMailHTML" => new XML_RPC_Value($row->email_html,"int"),
    		"eMailOffline" => new XML_RPC_Value($row->email_offline,"int"),
    		"formatReply" => new XML_RPC_Value($row->format_reply,"int"),
    		);

        return new XML_RPC_RESPONSE( new XML_RPC_Value($myStruct, 'struct'));
    }


    /*
     * Liefert Array mit Namen aller mglichen Empfngern
     */
    function getConfig($params) {
 		require $this->pathConfig;
        if($this->zugangsdaten->checkZugangsdaten("getConfig")) {
    		$absender = $params->getParam(0);
    	//	$absender = $absender->scalarval();
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
        $myStruct =         array(
    		"maxPM" => new XML_RPC_Value($max_allowed_pm,"int"),
    		"maxLengthSubject" => new XML_RPC_Value($max_length_subject,"int"),
    		"maxLengthMessage" => new XML_RPC_Value($max_length_message,"int"),
    		"userGroupIds" => new XML_RPC_Value($usergroupids),
    		"maxEntriesRecip" => new XML_RPC_Value($max_entries_reciplist,"int"),
    		"retract" => new XML_RPC_Value($retract,"int"),
    		"adressbook" => new XML_RPC_Value($addressbook,"int"),
    		"cbVersion" => new XML_RPC_Value($cb_version,"int"),
    		"userList" => new XML_RPC_Value($userlist,"int"),
    		"smilie" => new XML_RPC_Value($smiley,"int"),
    		"bbCode" => new XML_RPC_Value($bb_code,"int"),
    		);
        return new XML_RPC_RESPONSE( new XML_RPC_Value($myStruct, 'struct'));
    }

    /*
     * Lscht das erstellte XML- File
     *
     */
    function delXMLFile($params) {
        if($this->zugangsdaten->checkZugangsdaten("delXMLFile")) {
    		$password = $params->getParam(0);
    		$password = $password->scalarval();
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
        if(file_exists($password . ".xml")) {
            return new XML_RPC_RESPONSE(new XML_RPC_VALUE(unlink($password . ".xml"),'int'));
            exit();
        }
        else return new XML_RPC_RESPONSE(new XML_RPC_VALUE(10002,'int'));
    }


    /*
     *
     * Liefert Version der installierten PMS- Reader Komponente
     *
    */
    function getVersion($params) {
        if($this->zugangsdaten->checkZugangsdaten("getVersion")) {
    	}
		else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
		$version[] = new XML_RPC_Value("1.0.0", 'string');
		$version[] = new XML_RPC_Value("100", 'int');
        return new XML_RPC_RESPONSE( new XML_RPC_Value($version, "array"));
    }

    /*
     *
     * berprft Version des PMS- Centers *Client*
     *
    */
    function checkVersion($params) {
        if($this->zugangsdaten->checkZugangsdaten("checkVersion")) {
        	$clienVersion = $params->getParam(0);
			$clienVersion = $clienVersion->scalarval();
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
    	// clientVersion older than act. version => update recommend
    	if($clienVersion < 100) return new XML_RPC_Response(new XML_RPC_Value("2", 'int'));
        else return new XML_RPC_Response(new XML_RPC_Value("1", 'int')); // ok Code
    }



        /*
     *
     * Generieren einer neuen Nachricht
     *
     */
    function insertNewMessage($params) {
        if($this->zugangsdaten->checkZugangsdaten("insertNewMessage")) {
    		$absender = $params->getParam(0);
    		$absender = $absender->scalarval();
    		$empfaenger = $params->getParam(1);
    		$empfaenger = $empfaenger->scalarval();
    		$betreff = $params->getParam(2);
    		$betreff = $betreff->scalarval();
			$nachricht = $params->getParam(3);
    		$nachricht = $nachricht->scalarval();
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
    	// check if sender is on ignorelist of recip
    	$query = "SELECT ignore_ids FROM " . $this->db_prefix . "pms_ignorelist WHERE my_id=" .$this->quote_smart($recip_id) ." LIMIT 1";
		$result = mysql_query($query);
		$ignore_ids = explode(",", str_replace("|", "", $result));
		//
        $time = date('H:i:s');
        $date = date('Y-m-d');
        $insertQuery = "INSERT INTO " . $this->db_prefix . "pms (recip_id,sender_id,date,time,subject,message) VALUES (" . $this->quote_smart($empfaenger) . "," . $this->quote_smart($absender) . "," . $this->quote_smart($date) . "," . $this->quote_smart($time) . "," . $this->quote_smart($betreff) . "," . $this->quote_smart($nachricht). ")";
        if(mysql_query($insertQuery)) return new XML_RPC_RESPONSE(new XML_RPC_VALUE(true, 'boolean'));
        else return new XML_RPC_RESPONSE(new XML_RPC_VALUE(false, 'boolean'));
    }


    // Beantworten einer Nachricht
    function replyMessage($params) {
        if($this->zugangsdaten->checkZugangsdaten("replyMessage")) {
            $messageId = $params->getParam(0);
    		$messageId = $messageId->scalarval();
    		$absender = $params->getParam(1);
    		$absender = $absender->scalarval();
    		$empfaenger = $params->getParam(2);
    		$empfaenger = $empfaenger->scalarval();
    		$betreff = $params->getParam(3);
    		$betreff = $betreff->scalarval();
			$nachricht = $params->getParam(4);
    		$nachricht = $nachricht->scalarval();
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));

    	$time = date('H:i:s');
        $date = date('Y-m-d');

        mysql_query("UPDATE " . $this->db_prefix . "pms SET readstate='2' WHERE id='$messageId'");
    	$insertQuery = "INSERT INTO " . $this->db_prefix . "pms (recip_id,sender_id,date,time,subject,message) VALUES (" . $this->quote_smart($empfaenger) . "," . $this->quote_smart($absender) . "," . $this->quote_smart($date) . "," . $this->quote_smart($time) . "," . $this->quote_smart($betreff) . "," . $this->quote_smart($nachricht). ")";
    	if(mysql_query($insertQuery)) return new XML_RPC_RESPONSE(new XML_RPC_VALUE(true, 'boolean'));
        else return new XML_RPC_RESPONSE(new XML_RPC_VALUE(false, 'boolean'));
    }


   /*
     * Setzt Status der Nachricht
     * Status Message setzen
     * 0 - ungelesen , 1 - gelesen, 2 - beantwortet
     */
    function setMessageReadState($params) {
        if($this->zugangsdaten->checkZugangsdaten("setMessageReadState")) {
    		$messageId = $params->getParam(0);
    		$messageId = $messageId->scalarval();
			$readstate = $params->getParam(1);
    		$readstate = $readstate->scalarval();
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
    	    	// Zur Sicherheit nur die Nachrichten abrufen, der mit Benutzername/ Passwort authentifiziert!
        $result = mysql_query("SELECT id FROM " . $this->db_prefix . "users WHERE username=" . $this->quote_smart($_REQUEST['username']));
        $row = mysql_fetch_row($result);
        $my_id = $row[0];
        if(mysql_query("UPDATE " . $this->db_prefix . "pms SET readstate=" . $this->quote_smart($readstate) . " WHERE id=" . $this->quote_smart($messageId) . " and recip_id=" . $this->quote_smart($my_id))) return new XML_RPC_RESPONSE(new XML_RPC_VALUE(true, 'boolean'));
        else return new XML_RPC_RESPONSE(new XML_RPC_VALUE(false, 'boolean'));
    }


    /*
     * Lscht PMS
     */
    function deleteMessage($params) {
        if($this->zugangsdaten->checkZugangsdaten("deleteMessage")) {
    		$messageId = $params->getParam(0);
    		$messageId = $messageId->scalarval();
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));

		$result = mysql_query("SELECT id FROM " . $this->db_prefix . "users WHERE username='" .$_REQUEST['username']. "'");
        $row = mysql_fetch_row($result);
        $my_id = $row[0];

        if(mysql_query("UPDATE " . $this->db_prefix . "pms SET inbox='0' AND readstate='1' WHERE id=" . $this->quote_smart($messageId) . " and recip_id=" . $this->quote_smart($my_id))) return new XML_RPC_RESPONSE(new XML_RPC_VALUE(true, 'boolean'));
        else return new XML_RPC_RESPONSE(new XML_RPC_VALUE(false, 'boolean'));
    }

    /*
     * Liste aller Benutzer die gerade online sind
	 */
    function getOnlineUser() {
        if($this->zugangsdaten->checkZugangsdaten("getOnlineUser")) {
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
        $query= "SELECT DISTINCT userid FROM " . $this->db_prefix . "session";
        $result = mysql_query($query);
        $userNames = array();
        while($row = mysql_fetch_object($result)){
            $userNames[] = new XML_RPC_Value($row->userid);
        }
        return new XML_RPC_RESPONSE( new XML_RPC_Value($userNames, "array"));
    }

    /*
     * Abrufen der Buddyliste
	 */
    function getBuddyList() {
		if($this->zugangsdaten->checkZugangsdaten("getBuddyList")) {
		}
	 	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));

	    $result = mysql_query("SELECT id FROM " . $this->db_prefix . "users WHERE username=" .$this->quote_smart($_REQUEST['username']));
	    $row = mysql_fetch_row($result);
	    $my_id = $row[0];
	    $query= "SELECT buddy_ids FROM " . $this->db_prefix . "pms_addressbook WHERE my_id=" .$this->quote_smart($my_id);
	    $result = mysql_query($query);
	    while($row = mysql_fetch_object($result)){
	        $ids= $row->buddy_ids;
	    }
	    return new XML_RPC_RESPONSE( new XML_RPC_Value($ids, 'string'));
	}


     /*
     * beliebige SQL Abfrage stellen
	 */
    function countAllMessages($params) {
        if($this->zugangsdaten->checkZugangsdaten("countAllMessages")) {
    	}
    	else return new XML_RPC_Response(new XML_RPC_Value("10001", 'int'));
    	// Zur Sicherheit nur die Nachrichten abrufen, der mit Benutzername/ Passwort authentifiziert!
        $result = mysql_query("SELECT id FROM " . $this->db_prefix . "users WHERE username=" .$this->quote_smart($_REQUEST['username']));
        $row = mysql_fetch_row($result);
        $my_id = $row[0];
        $result = mysql_query("SELECT count(id) FROM " . $this->db_prefix . "pms WHERE recip_id='$my_id' AND inbox='1'");
        $row = mysql_fetch_row($result);
        $pm_in_inbox = $row[0];
        $result = mysql_query("SELECT count(id) FROM " . $this->db_prefix . "pms WHERE sender_id='$my_id' AND sent_items='1'");
        $row = mysql_fetch_row($result);
        $pm_in_sent_items = $row[0];
        $result = mysql_query("SELECT count(id) FROM " . $this->db_prefix . "pms WHERE (recip_id='$my_id' AND inbox='0') OR (sender_id='$my_id' AND sent_items='0')");
        $row = mysql_fetch_row($result);
        $pm_in_trash = $row[0];
        $pm_all = $pm_in_inbox + $pm_in_sent_items + $pm_in_trash;
        return new XML_RPC_RESPONSE( new XML_RPC_Value($pm_all, "int"));
    }
}

?>
