<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

define( '_VALID_MOS', 1 );
define('PMS_BASEPATH_COMPONENTS', dirname(__FILE__));
define('PMS_BASEPATH_ADMINISTRATOR', dirname(__FILE__).'/../../administrator/components/com_pms');
require_once("./../../configuration.php");
require_once("./../../includes/database.php");
require_once("./../../includes/joomla.php");
require_once(PMS_BASEPATH_ADMINISTRATOR . '/config.pms.php');
if(file_exists(PMS_BASEPATH_ADMINISTRATOR . '/language/'.$mosConfig_lang.'.php')) require_once(PMS_BASEPATH_ADMINISTRATOR . '/language/'.$mosConfig_lang.'.php');
else require_once(PMS_BASEPATH_ADMINISTRATOR . '/language/english.php');
if(file_exists("./../../language/".$mosConfig_lang.".php")) require_once("./../../language/".$mosConfig_lang.".php");
else require_once("./../../language/english.php");
header("Content-Type: text/html; "._ISO);

$database = new database($mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix);

$search = mosGetParam($_GET, 'search');
$my_id = mosGetParam($_GET, 'my_id');
$session_id = mosGetParam($_GET, 'session_id', -1);
if($session_id=="") $session_id = -1;
$search = $database->getEscaped($search);
$my_id = intval($my_id);
$database->setQuery("SELECT session_id FROM #__session WHERE userid=$my_id LIMIT 1");
$session_id_table = $database->loadResult();
if($session_id!=$session_id_table) die('Direct Access to this location is not allowed.');
else
{
	if($usersearch_min_character==0 OR strlen($search)>=$usersearch_min_character)
	{
		if($cb_version>0)
		{
			if($userlist==0 OR $userlist==2) $query = "SELECT t1.username FROM #__users AS t1, #__comprofiler AS t2 WHERE t1.username LIKE '$search%' AND t1.id!=$my_id AND t1.gid IN (".$usergroupids.") AND t1.block!=1 AND t2.approved=1 AND t2.confirmed=1 AND t2.banned=0 AND t1.id=t2.user_id ORDER BY t1.username";
			if($userlist==1 OR $userlist==3) $query = "SELECT t1.name FROM #__users AS t1, #__comprofiler AS t2 WHERE t1.name LIKE '$search%' AND t1.id!=$my_id AND t1.gid IN (".$usergroupids.") AND t1.block!=1 AND t2.approved=1 AND t2.confirmed=1 AND t2.banned=0 AND t1.id=t2.user_id ORDER BY t1.name";
		}
		else
		{
			if($userlist==0 OR $userlist==2) $query = "SELECT username FROM #__users WHERE username LIKE '$search%' AND id!=$my_id AND gid IN (".$usergroupids.") AND block!=1 ORDER BY username";
			if($userlist==1 OR $userlist==3) $query = "SELECT name FROM #__users WHERE name LIKE '$search%' AND id!=$my_id AND gid IN (".$usergroupids.") AND block!=1 ORDER BY name";
		}
		if($usersearch_max_rows>0) $query .= " LIMIT 0, $usersearch_max_rows";
		$database->setQuery($query);
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$result = $database->query();

		$output = '<table cellspacing="1" cellpadding="4" border="0" style="background-color: white;">';
		$i = 0;
		while($row = mysql_fetch_assoc($result))
		{
			$i = 1 - $i;
			$entry = $i + 1;
			$class = "sectiontableentry".$entry;
			if($userlist==0 OR $userlist==2) $output .= "<tr class=\"".$class."\"><td><a onclick=\"pms_write_add_recip('','".$row['username']."')\" style=\"cursor: pointer\">".$row['username']."</a></td></tr>";
			if($userlist==1 OR $userlist==3) $output .= "<tr class=\"".$class."\"><td><a onclick=\"pms_write_add_recip('','".$row['name']."')\" style=\"cursor: pointer\">".$row['name']."</a></td></tr>";
		}
		$output .= "</table>";

		echo $output;
	}
}
?>